-----DEBUG CONTROL--------------------------------------------------------------

debug_output = true -- true/false --display debug messages in the console

-----DISPLAY CONSOLE MESSAGE----------------------------------------------------

-- Display a message in the console for debugging, message can be a number variable
-- or a string but not mixed. No line feed character is added.
function Msg(value)
  --returns nothing

  if debug_output then --check if flag is set true (at the start of this script)
    reaper.ShowConsoleMsg(tostring(value).."\n")
  end
end

function print(value)

 reaper.ShowConsoleMsg(tostring(value).."\n")
end


-- NoIndex: true)

--[[
  Lokasenna_GUI example

  - Getting user input before running an action; i.e. replacing GetUserInputs

]]--

--------------------------------
 --REATRAK LOCAL GUI LIBRARY start
--------------------------------
local info = debug.getinfo(1,'S');
script_path = info.source:match[[^@?(.*[\/])[^\/]-$]]
--Msg("script_path "..script_path)
local lib_path = script_path --reaper.GetExtState("Lokasenna_GUI", "lib_path_v2")
--if not lib_path or lib_path == "" then
    --reaper.MB("Couldn't load the ReaTrak Lokasenna_GUI library. Please check Scripts/ReaTrak/ReaTrak_Classes/", "Whoops!", 0)
    --return
--end

loadfile(script_path .. "ReaTrak_Core.lua")()

GUI.req(script_path .. "ReaTrak_Classes/Class - Label.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Knob.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Tabs.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Slider.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Button.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Menubox.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Textbox.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Frame.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Options.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Window.lua")()

--------------------------------
 --REATRAK LOCAL GUI LIBRARY end
--------------------------------

--[[
--------------------------------
 --LOKASENNA GUI LIBRARY start
--------------------------------

-- NoIndex: true

--[[
  Lokasenna_GUI example

  - Getting user input before running an action; i.e. replacing GetUserInputs

]]--


--[[
-- The Core library must be loaded prior to anything else
reaper.MB("Using Lokasenna_GUI library", "Notice", 0)
    
local lib_path = reaper.GetExtState("Lokasenna_GUI", "lib_path_v2")
if not lib_path or lib_path == "" then
    reaper.MB("Couldn't load the Lokasenna_GUI library. Please run 'Script: Set Lokasenna_GUI v2 library path.lua' in your Action List.", "Whoops!", 0)
    return
end
loadfile(lib_path .. "Core.lua")()

GUI.req("Classes/Class - Label.lua")()
GUI.req("Classes/Class - Knob.lua")()
GUI.req("Classes/Class - Tabs.lua")()
GUI.req("Classes/Class - Slider.lua")()
GUI.req("Classes/Class - Button.lua")()
GUI.req("Classes/Class - Menubox.lua")()
GUI.req("Classes/Class - Textbox.lua")()
GUI.req("Classes/Class - Frame.lua")()
GUI.req("Classes/Class - Options.lua")()
GUI.req("Classes/Class - Window.lua")()

--------------------------------
 --LOKASENNA GUI LIBRARY end
--------------------------------
--]]
-- If any of the requested libraries weren't found, abort the script.
if missing_lib then return 0 end

-- Button Colors  = {r, g, b, transparency}

GUI.colors["count_in"] = {255, 124, 192, 255}
GUI.colors["intro_post_fill"] = {119, 17, 174, 255}
GUI.colors["intro"] = {159, 22, 232, 255}
GUI.colors["intro_fill"] = {183, 128, 237, 255}
GUI.colors["verse_post_fill"] = {17, 39, 174, 255}
GUI.colors["verse"] = {55, 118, 235, 255}
GUI.colors["verse_fill"] = {113, 190, 241, 255}
GUI.colors["verse_ending"] = {151, 208, 245, 255}
GUI.colors["bridge_post_fill"] = {206, 105, 20, 255}
GUI.colors["bridge"] = {234, 133, 48, 255}
GUI.colors["bridge_fill"] = {239, 164, 100, 255}
GUI.colors["pre_chorus_post_fill"] = {206, 179, 20, 255}
GUI.colors["pre_chorus"] = {234, 208, 48, 255}
GUI.colors["pre_chorus_fill"] = {244, 231, 151, 255}
GUI.colors["chorus_post_fill"] = {11, 116, 39, 255}
GUI.colors["chorus"] = {17, 174, 59, 255}
GUI.colors["chorus_fill"] = {80, 237, 123, 255}
GUI.colors["chorus_ending"] = {158, 254, 182, 255}
GUI.colors["play_anywhere"] = {228, 26, 39, 250}
GUI.colors["drum_riff"] = {115, 23, 17, 255}
GUI.colors["hold"] = {191, 191, 191, 255}
GUI.colors["shot"] = {127, 127, 127, 255}
GUI.colors["rest"] = {0, 0, 0, 255}
GUI.colors["stop"] = {151, 0, 75, 255}
GUI.colors["light_gray"] = {192, 192, 192, 255}
GUI.colors["dark_red"] = {143, 7, 41, 250}

--Text Colors

GUI.colors["btn_txt1"] = {255, 255, 255, 255} --white
GUI.colors["btn_txt2"] = {155, 155, 155, 255} --gray
GUI.colors["btn_txt3"] = {0, 0, 0, 255} --black


------------------------------------
-------- Functions -----------------
------------------------------------

  local info = debug.getinfo(1,'S');
  script_path = info.source:match[[^@?(.*[\/])[^\/]-$]] 
  script_path2 = script_path .."/ahk/scripts/"
  
  inipath = reaper.get_ini_file()
  
  
  --reaper.SNM_SetStringConfigVar( varname, newvalue )
  reaper.BR_Win32_WritePrivateProfileString( "reaper", "video_decprio", "wmf ffmpeg vlc qt:mov,qt,m4v,mp4 dshow:!mov,!mp4,!m4v,!qt", inipath )

function get_riff_section_custom_btn_click()

  sel_track = reaper.GetSelectedTrack2( 0, 0, 0 )
  
  if not sel_track then
  
    reaper.MB("Select Track", "Attention", 0)
    no_loop = 1
    goto get_riff_section_custom_end  
  
  end
 --[[ 
  retval, stringNeedBig = reaper.GetSetMediaTrackInfo_String( sel_track, "P_NAME", "", 0 )
   
  --s = "522:Guitar, Acoustic, Fingerpicking Ev 120"
  RTnumber = stringNeedBig:match("(.+):")
  if not RTnumber then
    reaper.MB("No exsisting RT Number on Track, Insert Track Name eg 1515: ", "Attention", 0)
    no_loop = 1
    goto get_riff_section_custom_end
  end
  --]]
  --Msg(RT_number)
  
  pos_start, pos_end = reaper.GetSet_LoopTimeRange2( 0, 0, 0, "", "", 0 )
  
  if pos_start == pos_end then
    reaper.MB("Select Time Selection", "Attention", 0)
    no_loop = 1
    goto get_riff_section_custom_end
  end  
  no_loop = 0
  --Msg(pos_start.." "..pos_end)
  
   retval, start_measures, cml, start_fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, pos_start )
   
   retval, end_measures, cml, end_fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, pos_end )
   --Msg(cml)
   beats_start = start_fullbeats - (start_measures * cml ) + 1
   
   beats_end = end_fullbeats - (end_measures * cml ) + 1
   
   beats_end = math.floor(beats_end) 
   --Msg("start "..beats_start)
   beats_start = math.floor(beats_start)
   
   start_measures = start_measures -1
   
   end_measures = end_measures -1
   
  -- Msg("start "..start_measures.."."..beats_start)
  -- Msg("end "..end_measures.."."..beats_end)
   
   --riff_data = start_pos..","..end_pos..","..RTnumber..","..Style..","..bpm..","..ts..","..Bluesy..","..Simpler..","..DirectInput..","..Held
   bpm =  reaper.Master_GetTempo()
   bpm = math.floor(bpm)
   Style = "BLANK.STY"
   TB = GUI.Val("my_mnu")
   timebase = {"Normal-Time","Half-Time","Double-Time","Triple-Time"}
   RTnumber = "1260"
   --Msg("TB "..timebase[TB])
   opts = GUI.Val("my_chk")
   Blue,Simp,DI,H = bool_num(opts[1]), bool_num(opts[2]), bool_num(opts[3]), bool_num(opts[4])
   --Msg("H "..H)
   reaper.CF_SetClipboard( start_measures.."."..beats_start..","..end_measures.."."..beats_end..","..RTnumber..","..Style..","..bpm..","..cml..","..timebase[TB]..","..Blue..","..Simp..","..DI..","..H )
   
  
reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\F8 Generate RT Section Custom.ahk"]],0) --F8 Generate RT Section Custom.ahk]],-2)

--wait(12)
::get_riff_section_custom_end::


end

function get_riff_section()

  
  sel_track = reaper.GetSelectedTrack2( 0, 0, 0 )
  
  if not sel_track then
  
    reaper.MB("Select Track", "Attention", 0)
    no_loop = 1
    goto get_riff_section_end  
  
  end
  
  retval, stringNeedBig = reaper.GetSetMediaTrackInfo_String( sel_track, "P_NAME", "", 0 )
   
  --s = "522:Guitar, Acoustic, Fingerpicking Ev 120"
  RTnumber = stringNeedBig:match("(.+):")
  if not RTnumber then
    reaper.MB("No exsisting RT Number on Track, Insert Track Name eg 1515: ", "Attention", 0)
    no_loop = 1
    goto get_riff_section_end
  end
  
  --Msg(RT_number)
  
  pos_start, pos_end = reaper.GetSet_LoopTimeRange2( 0, 0, 0, "", "", 0 )
  
  if pos_start == pos_end then
    reaper.MB("Select Time Selection", "Attention", 0)
    no_loop = 1
    goto get_riff_section_end
  end  
  no_loop = 0
  --Msg(pos_start.." "..pos_end)
  
   retval, start_measures, cml, start_fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, pos_start )
   
   retval, end_measures, cml, end_fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, pos_end )
   --Msg(cml)
   beats_start = start_fullbeats - (start_measures * cml ) + 1
   
   beats_end = end_fullbeats - (end_measures * cml ) + 1
   
   beats_end = math.floor(beats_end) 
   --Msg("start "..beats_start)
   beats_start = math.floor(beats_start)
   
   start_measures = start_measures -1
   
   end_measures = end_measures -1
   
  -- Msg("start "..start_measures.."."..beats_start)
  -- Msg("end "..end_measures.."."..beats_end)
   
   --riff_data = start_pos..","..end_pos..","..RTnumber..","..Style..","..bpm..","..ts..","..Bluesy..","..Simpler..","..DirectInput..","..Held
   bpm =  reaper.Master_GetTempo()
   bpm = math.floor(bpm)
   Style = "BLANK.STY"
   TB = GUI.Val("my_mnu")
   timebase = {"Normal-Time","Half-Time","Double-Time","Triple-Time"}
   --Msg("TB "..timebase[TB])
   opts = GUI.Val("my_chk")
   Blue,Simp,DI,H = bool_num(opts[1]), bool_num(opts[2]), bool_num(opts[3]), bool_num(opts[4])
   --Msg("H "..H)
   reaper.CF_SetClipboard( start_measures.."."..beats_start..","..end_measures.."."..beats_end..","..RTnumber..","..Style..","..bpm..","..cml..","..timebase[TB]..","..Blue..","..Simp..","..DI..","..H )
   
--reaper.MB("Wait","Wait",0)  
reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\F8 Generate RT Section.ahk"]],0) --F8 Generate Section.ahk]],-2)

start_pos, end_pos = reaper.GetSet_LoopTimeRange2(0, false, false, 0, 0, false)
reaper.MoveEditCursor( start_pos, 0 )
--wait(12)
::get_riff_section_end::
end


------------------------------------------------------- END OF USER CONFIG AREA

function ColorHexToInt(hex)
  hex = hex:gsub("#", "")
  local R = tonumber("0x"..hex:sub(1,2))
  local G = tonumber("0x"..hex:sub(3,4))
  local B = tonumber("0x"..hex:sub(5,6))
  return reaper.ColorToNative(R, G, B)
end

function bool_num(value)
  return value and 1 or 0
end

function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end


function round2(val, decimal)
  local exp = decimal and 10^decimal or 1
  return math.ceil(val * exp - 0.5) / exp
end

function GetFilename(path)   
    local start, finish = path:find('[%w%s!-={-|]+[_%.].+')   
    return path:sub(start,#path) 
end



function round(x)
  return x>=0 and math.floor(x+0.5) or math.ceil(x-0.5)
end


-- Optimization
local reaper = reaper

-- CSV to Table
-- http://lua-users.org/wiki/LuaCsv
function ParseCSVLine (line,sep)
  local res = {}
  local pos = 1
  sep = sep or ','
  while true do
    local c = string.sub(line,pos,pos)
    if (c == "") then break end
    if (c == '"') then
      -- quoted value (ignore separator within)
      local txt = ""
      repeat
        local startp,endp = string.find(line,'^%b""',pos)
        txt = txt..string.sub(line,startp+1,endp-1)
        pos = endp + 1
        c = string.sub(line,pos,pos)
        if (c == '"') then txt = txt..'"' end
        -- check first char AFTER quoted string, if it is another
        -- quoted string without separator, then append it
        -- this is the way to "escape" the quote char in a quote. example:
        --   value1,"blub""blip""boing",value3  will result in blub"blip"boing  for the middle
      until (c ~= '"')
      table.insert(res,txt)
      assert(c == sep or c == "")
      pos = pos + 1
    else
      -- no quotes used, just look for the first separator
      local startp,endp = string.find(line,sep,pos)
      if (startp) then
        table.insert(res,string.sub(line,pos,startp-1))
        pos = endp + 1
      else
        -- no separator found -> use rest of string and terminate
        table.insert(res,string.sub(line,pos))
        break
      end
    end
  end
  return res
end


-- UTILITIES -------------------------------------------------------------


function wait(seconds)
    local start = os.time()
    repeat until os.time() > start + seconds
end

function ReverseTable(t)
    local reversedTable = {}
    local itemCount = #t
    for k, v in ipairs(t) do
        reversedTable[itemCount + 1 - k] = v
    end
    return reversedTable
end

--------------------------------------------------------- END OF UTILITIES



function import_sgu_btn_click()

  rootNames = { "C", "Db", "D", "Eb", "E", "F", "Gb", "G", "Ab", "A", "Bb", "B", "C#", "D#", "F#", "G#", "A#" }
  
  --pad the rest of rootNames with ? for unknown types
  for j = 18,26 do 
    rootNames[j] = "?"
  end
  --add in any unusual chord types
  
  rootNames[27] ="Ab/A"
  rootNames[28] ="A/Bb"
  rootNames[29] ="Bb/B"
  rootNames[30] ="B/C"
  rootNames[31] ="C#/Db"
  rootNames[32] ="D#/D"
  rootNames[33] ="F#/Eb"
  rootNames[34] ="G#/E"
  rootNames[35] ="A#/F"
  rootNames[36] ="A#/Db"
  rootNames[37] ="C/D"
  rootNames[38] ="Db/Eb"
  rootNames[39] ="D/E"
  rootNames[40] ="Eb/F"
  rootNames[41] ="E/Gb"
  rootNames[42] ="F/G"
  rootNames[43] ="Gb/Ab"
  rootNames[44] ="G/A"
  rootNames[45] ="Ab/Bb"
  rootNames[46] ="A/B"
  rootNames[47] ="Bb/C"
  rootNames[48] ="B/Db"
  rootNames[49] ="C#/D"
  rootNames[50] ="D#/Eb"
  rootNames[51] ="F#/E"
  rootNames[52] ="G#/F"
  rootNames[53] ="A#/Gb"
  rootNames[54] ="A#/D"
  rootNames[55] ="C/Eb"
  rootNames[56] ="Db/E"
  rootNames[57] ="D/F"
  rootNames[58] ="Eb/Gb"
  rootNames[59] ="E/G"
  rootNames[60] ="F/Ab"
  rootNames[61] ="Gb/A"
  rootNames[62] ="G/Bb"
  rootNames[63] ="Ab/B"
  rootNames[64] ="A/C"
  rootNames[65] ="Bb/Db"
  rootNames[66] ="B/D"
  rootNames[67] ="C#/Eb"
  rootNames[68] ="D#/E"
  rootNames[69] ="F#/F"
  rootNames[70] ="G#/Gb"
  rootNames[71] ="A#/G"
  rootNames[72] ="A#/Eb"
  rootNames[73] ="C/E"
  rootNames[74] ="Db/F"
  rootNames[75] ="D/Gb"
  rootNames[76] ="Eb/G"
  rootNames[77] ="E/Ab"
  rootNames[78] ="F/A"
  rootNames[79] ="Gb/Bb"
  rootNames[80] ="G/B"
  rootNames[81] ="Ab/C"
  rootNames[82] ="A/Db"
  rootNames[83] ="Bb/D"
  rootNames[84] ="B/Eb"
  rootNames[85] ="C#/E"
  rootNames[86] ="D#/F"
  rootNames[87] ="F#/Gb"
  rootNames[88] ="G#/G"
  rootNames[89] ="A#/Ab"
  rootNames[90] ="A#/E"
  rootNames[91] ="C/F"
  rootNames[92] ="Db/Gb"
  rootNames[93] ="D/G"
  rootNames[94] ="Eb/Ab"
  rootNames[95] ="E/A"
  rootNames[96] ="F/Bb"
  rootNames[97] ="Gb/B"
  rootNames[98] ="G/C"
  rootNames[99] ="Ab/Db"
  rootNames[100] ="A/D"
  rootNames[101] ="Bb/Eb"
  rootNames[102] ="B/E"
  rootNames[103] ="C#/F"
  rootNames[104] ="D#/Gb"
  rootNames[105] ="F#/G"
  rootNames[106] ="G#/Ab"
  rootNames[107] ="A#/A"
  rootNames[108] ="A#/F"
  rootNames[109] ="C/Gb"
  rootNames[110] ="Db/G"
  rootNames[111] ="D/Ab"
  rootNames[112] ="Eb/A"
  rootNames[113] ="E/Bb"
  rootNames[114] ="F/B"
  rootNames[115] ="Gb/C"
  rootNames[116] ="G/Db"
  rootNames[117] ="Ab/D"
  rootNames[118] ="A/Eb"
  rootNames[119] ="Bb/E"
  rootNames[120] ="B/F"
  rootNames[121] ="C#/Gb"
  rootNames[122] ="D#/G"
  rootNames[123] ="F#/Ab"
  rootNames[124] ="G#/A"
  rootNames[125] ="A#/Bb"
  rootNames[126] ="A#/Gb"
  rootNames[127] ="C/G"
  rootNames[128] ="Db/Ab"
  rootNames[129] ="D/A"
  rootNames[130] ="Eb/Bb"
  rootNames[131] ="E/B"
  rootNames[132] ="F/C"
  rootNames[133] ="Gb/Db"
  rootNames[134] ="G/D"
  rootNames[135] ="Ab/Eb"
  rootNames[136] ="A/E"
  rootNames[137] ="Bb/F"
  rootNames[138] ="B/Gb"
  rootNames[139] ="C#/G"
  rootNames[140] ="D#/Ab"
  rootNames[141] ="F#/A"
  rootNames[142] ="G#/Bb"
  rootNames[143] ="A#/B"
  rootNames[144] ="A#/G"
  rootNames[145] ="C/Ab"
  rootNames[146] ="Db/A"
  rootNames[147] ="D/Bb"
  rootNames[148] ="Eb/B"
  rootNames[149] ="E/C"
  rootNames[150] ="F/Db"
  rootNames[151] ="Gb/D"
  rootNames[152] ="G/Eb"
  rootNames[153] ="Ab/E"
  rootNames[154] ="A/F"
  rootNames[155] ="Bb/Gb"
  rootNames[156] ="B/G"
  rootNames[157] ="C#/Ab"
  rootNames[158] ="D#/A"
  rootNames[159] ="F#/Bb"
  rootNames[160] ="G#/B"
  rootNames[161] ="A#/C"
  rootNames[162] ="A#/Ab"
  rootNames[163] ="C/A"
  rootNames[164] ="Db/Bb"
  rootNames[165] ="D/B"
  rootNames[166] ="Eb/C"
  rootNames[167] ="E/Db"
  rootNames[168] ="F/D"
  rootNames[169] ="Gb/Eb"
  rootNames[170] ="G/E"
  rootNames[171] ="Ab/F"
  rootNames[172] ="A/Gb"
  rootNames[173] ="Bb/G"
  rootNames[174] ="B/Ab"
  rootNames[175] ="C#/A"
  rootNames[176] ="D#/Bb"
  rootNames[177] ="F#/B"
  rootNames[178] ="G#/C"
  rootNames[179] ="A#/Db"
  rootNames[180] ="A#/A"
  rootNames[181] ="C/Bb"
  rootNames[182] ="Db/B"
  rootNames[183] ="D/C"
  rootNames[184] ="Eb/Db"
  rootNames[185] ="E/D"
  rootNames[186] ="F/Eb"
  rootNames[187] ="Gb/E"
  rootNames[188] ="G/F"
  rootNames[189] ="Ab/Gb"
  rootNames[190] ="A/G"
  rootNames[191] ="Bb/Ab"
  rootNames[192] ="B/A"
  rootNames[193] ="C#/Bb"
  rootNames[194] ="D#/B"
  rootNames[195] ="F#/C"
  rootNames[196] ="G#/Db"
  rootNames[197] ="A#/D"
  rootNames[198] ="A#/Bb"
  rootNames[199] ="C/B"
  rootNames[200] ="Db/C"
  rootNames[201] ="D/Db"
  rootNames[202] ="Eb/D"
  rootNames[203] ="E/Eb"
  rootNames[204] ="F/E"
  rootNames[205] ="Gb/F"
  rootNames[206] ="G/Gb"
  rootNames[207] ="Ab/G"
  rootNames[208] ="A/Ab"
  rootNames[209] ="Bb/A"
  rootNames[210] ="B/Bb"
  rootNames[211] ="C#/B"
  rootNames[212] ="D#/C"
  rootNames[213] ="F#/Db"
  rootNames[214] ="G#/D"
  rootNames[215] ="A#/Eb"
  rootNames[216] ="A#/B"
  
  --pad the rest of unknown types with ?
  for j = 217,255 do 
    rootNames[j] = "?"
  end
  
  typeNames = {
    "",  -- 1 
    "Maj",  -- 2 
    "b5",  -- 3 
    "aug",  -- 4 
    "6",  -- 5 
    "Maj7",  -- 6 
    "Maj9",  -- 7 
    "Maj9#11",  -- 8 
    "Maj13#11",  -- 9 
    "Maj13",  -- 10 
    "Maj9(no 3)",  -- 11 
    "+",  -- 12 
    "Maj7#5",  -- 13 
    "69",  -- 14 
    "2",  -- 15 
    "m",  -- 16 
    "maug",  -- 17 
    "mMaj7",  -- 18 
    "m7",  -- 19 
    "m9",  -- 20 
    "m11",  -- 21 
    "m13",  -- 22 
    "m6",  -- 23 
    "m#5",  -- 24 
    "m7#5",  -- 25 
    "?",  -- 26 
    "?",  -- 27 
    "?",  -- 28 
    "?",  -- 29 
    "?",  -- 30 
    "?",  -- 31 
    "m7b5",  -- 32 
    "dim",  -- 33 
    "?",  -- 34 
    "?",  -- 35 
    "?",  -- 36 
    "?",  -- 37 
    "?",  -- 38 
    "?",  -- 39 
    "5",  -- 40 
    "?",  -- 41 
    "?",  -- 42 
    "?",  -- 43 
    "?",  -- 44 
    "?",  -- 45 
    "?",  -- 46 
    "?",  -- 47 
    "?",  -- 48 
    "?",  -- 49 
    "?",  -- 50 
    "?",  -- 51 
    "?",  -- 52 
    "?",  -- 53 
    "?",  -- 54 
    "?",  -- 55 
    "7+",  -- 56 
    "9+",  -- 57 
    "13+",  -- 58 
    "?",  -- 59 
    "?",  -- 60 
    "?",  -- 61 
    "?",  -- 62 
    "?",  -- 63 
    "7",  -- 64 
    "13",  -- 65 
    "7b13",  -- 66 
    "7#11",  -- 67 
    "13#11",  -- 68 
    "7#11b13",  -- 69 
    "9",  -- 70 
    "?",  -- 71 
    "9b13",  -- 72 
    "9#11",  -- 73 
    "13#11",  -- 74 
    "9#11b13",  -- 75 
    "7b9",  -- 76 
    "13b9",  -- 77 
    "7b9b13",  -- 78 
    "7b9#11",  -- 79 
    "13b9#11",  -- 80 
    "7b9#11b13",  -- 81 
    "7#9",  -- 82 
    "13#9",  -- 83 
    "7#9b13",  -- 84 
    "9#11",  -- 85 
    "13#9#11",  -- 86 
    "7#9#11b13",  -- 87 
    "7b5",  -- 88 
    "13b5",  -- 89 
    "7b5b13",  -- 90 
    "9b5",  -- 91 
    "9b5b13",  -- 92 
    "7b5b9",  -- 93 
    "13b5b9",  -- 94 
    "7b5b9b13",  -- 95 
    "7b5#9",  -- 96 
    "13b5#9",  -- 97 
    "7b5#9b13",  -- 98 
    "7#5",  -- 99 
    "13#5",  -- 100 
    "7#5#11",  -- 101 
    "13#5#11",  -- 102 
    "9#5",  -- 103 
    "9#5#11",  -- 104 
    "7#5b9",  -- 105 
    "13#5b9",  -- 106 
    "7#5b9#11",  -- 107 
    "13#5b9#11",  -- 108 
    "7#5#9",  -- 109 
    "13#5#9#11",  -- 110 
    "7#5#9#11",  -- 111 
    "13#5#9#11",  -- 112 
    "7alt",  -- 113 
    "?",  -- 114 
    "?",  -- 115 
    "?",  -- 116 
    "?",  -- 117 
    "?",  -- 118 
    "?",  -- 119 
    "?",  -- 120 
    "?",  -- 121 
    "?",  -- 122 
    "?",  -- 123 
    "?",  -- 124 
    "?",  -- 125 
    "?",  -- 126 
    "?",  -- 127 
    "7sus",  -- 128 
    "13sus",  -- 129 
    "7susb13",  -- 130 
    "7sus#11",  -- 131 
    "13sus#11",  -- 132 
    "7sus#11b13",  -- 133 
    "9sus",  -- 134 
    "?",  -- 135 
    "9susb13",  -- 136 
    "9sus#11",  -- 137 
    "13sus#11",  -- 138 
    "9sus#11b13",  -- 139 
    "7susb9",  -- 140 
    "13susb9",  -- 141 
    "7susb913",  -- 142 
    "7susb9#11",  -- 143 
    "13susb9#11",  -- 144 
    "7susb9#11b13",  -- 145 
    "7sus#9",  -- 146 
    "13sus#9",  -- 147 
    "7sus#9b13",  -- 148 
    "9sus#11",  -- 149 
    "13sus#9#11",  -- 150 
    "7sus#9#11b13",  -- 151 
    "7susb5",  -- 152 
    "13susb5",  -- 153 
    "7susb5b13",  -- 154 
    "9susb5",  -- 155 
    "9susb5b13",  -- 156 
    "7susb5b9",  -- 157 
    "13susb5b9",  -- 158 
    "7susb5b9b13",  -- 159 
    "7susb5#9",  -- 160 
    "13susb5#9",  -- 161 
    "7susb5#9b13",  -- 162 
    "7sus#5",  -- 163 
    "13sus#5",  -- 164 
    "7sus#5#11",  -- 165 
    "13sus#5#11",  -- 166 
    "9sus#5",  -- 167 
    "9sus#5#11",  -- 168 
    "7sus#5b9",  -- 169 
    "13sus#5b9",  -- 170 
    "7sus#5b9#11",  -- 171 
    "13sus#5b9#11",  -- 172 
    "7sus#5#9",  -- 173 
    "13sus#5#9#11",  -- 174 
    "7sus#5#9#11",  -- 175 
    "13sus#5#9#11",  -- 176 
    "4",  -- 177 
    "?",  -- 178 
    "?",  -- 179 
    "?",  -- 180 
    "?",  -- 181 
    "?",  -- 182 
    "?",  -- 183 
    "sus"}  -- 184 

    retval = reaper.MB( "Yes the Song 4/4 or No for 3/4", "Time Signature", 4 ) 
    if retval == 6 then
      chords_44()
    end
    if retval == 7 then
      chords_34()
    end 
    

end

function chords_34()
    retval, filetxt = reaper.GetUserFileNameForRead("", "Import Chords from SGU,MGU...", "")
    if not retval then goto chords_34_end end
    --print(GetFilename(filetxt))
    
    f = assert(io.open(filetxt, "rb"))
    
    local first_byte_sig = f:read(1)
    local name_bytes = f:read(1)
    --print("First byte = "..tostring(first_byte_sig))
    name_len = string.byte(name_bytes)
    --print("Name_length =" ..name_len)
    local bytes = f:read(name_len)
    --print("Name: "..tostring(bytes))
    local meter_denominator = 4
    --print("Meter: "..tostring(4).."/"..tostring(meter_denominator))
    local byte1 = string.byte(f:read(1))
    local byte2 = string.byte(f:read(1))
    local byte3 = string.byte(f:read(1))
    local keyByte = string.byte(f:read(1)) --read 
    local tempoByte = string.byte(f:read(1)) --read tempo byte
    
    if keyByte <= 17 then
      key = rootNames[keyByte]
      isMinor = false 
    else key = rootNames[keyByte - 17]
      isMinor = true
    end
    if isMinor then
      --print("Key : " ..key.. "m")
    else --print("Key: " ..key)
    end
    --print("Tempo: " ..tempoByte)
    reaper.Main_OnCommand( 40042, 0 ) -- Transport: Go to start of project
    reaper.SetCurrentBPM( 0, tempoByte, 0 ) -- 0 no undo points 1 undo points
    
    
    reaper.SetTempoTimeSigMarker( 0, -1, 0, -1, -1, -1, 3, 4, false )
    
    local bar = string.byte(f:read(1)) --read start bar number
    --print("Start bar: " ..bar)
    
    local types = {}
    local roots = {}
    local beats = {}
    local partm = {}
    numberOfChords = 1

-- count through the bars and bar types to find section boundaries
    
    while bar < 255 do -- maximum of 255 bars
      local barType = string.byte(f:read(1)) --read bar type
      
      if barType == 0 then
        duration = string.byte(f:read(1))
        bar = bar + duration
      else bar = bar + 1
      end
    

      partm[bar] = barType
       
    end
    
    total_bars = bar - duration -1
    --print("Total number of bars =" ..total_bars)
-- count through the chord type/duration section recording the beat count where chord changes occur in table beats[] and the chord type in types[] 
    local beat = 1 --start at beat 1
    while beat < 1020 do --maximum of 1020 beats (= 255 bars x 4 beats)
      local chordType = string.byte(f:read(1))
      if chordType == 0 then
        local duration = string.byte(f:read(1))
        beat = beat + duration
      else types[numberOfChords] = chordType
        --print("Chord change number "..tostring(numberOfChords).." to "..tostring(chordType).." ["..typeNames[chordType].."] at beat count "..tostring(beat))
        beats[numberOfChords] = beat
        numberOfChords = numberOfChords + 1
        last_beat = beat
        beat = beat + 1
      end
    end
  total_beats = last_beat - 1


  local i=1
  beat = 1 --start at beat 1
  
  while beat < 1020 do --maximum of 1020 beats
    
    local chordRoot = string.byte(f:read(1))
    if chordRoot == 0 then 
      local duration = string.byte(f:read(1))
      beat = beat + duration
    else roots[i] = chordRoot
      if beat ~= beats[i] then
        --print("Inconsistent chord type and root beat")
      end
      

      i = i + 1
      beat = beat + 1
    end
 
  end


  if i ~= numberOfChords then
    print("Inconsistent number of chord types and roots")
  end


  beats_no = (last_beat +15) / 4 * 3
  --print("Toatal 3/4 Beats ".. beats_no  )
  waltz_bars = 0
  
  
  chord_name = {}
  beat_count = {}
  part_marker = {}
  part_marker_beats = {}
  
  for i = 1, tablelength(roots)  do
  
    waltz_beats = ((beats[i] / 4) * 3) +.75 --+.25 
    beat_number = 1
    --print("waltz_beats ".. waltz_beats)
    
    
    waltz_bars = (waltz_beats / 3) + .66666666666667
    --if waltz_bars ~= math.floor(waltz_bars) then
      
      waltz_bars2 = round2(waltz_bars,0)
      --print("waltz_bars ".. waltz_bars .." floor ".. waltz_bars2)
      if tostring(waltz_bars2) == tostring(waltz_bars) then
        beat_number = 1 --print("Is Equal")
      
      elseif waltz_bars2 < waltz_bars then
        beat_number = 2 --print("Is Less")
       
      elseif waltz_bars2 > waltz_bars then 
        beat_number = 3 --print("Is Greater")
      end 
     
     waltz_beats2 = math.floor(waltz_beats)
     
     
  --end
   --print("Beat ".. waltz_beats2 .." Bar ".. math.floor(waltz_bars) .."[" .. beat_number .."]".." " ..tostring(rootNames[roots[i]]) ..tostring(typeNames[types[i]]))
 
  --end
  

  
  
    --print("Beat ".. waltz_beats2 .." " ..tostring(rootNames[roots[i]]) ..tostring(typeNames[types[i]]))
    
    chord_name[i] = tostring(rootNames[roots[i]]) ..tostring(typeNames[types[i]])
    beat_count[i] = waltz_beats2
    
  
  end
  

  
  part_marker_count = 0
  for i = 2, total_bars +1 do --tablelength(roots) do --total_bars +1 do
    if partm[i] and partm[i] > 0 then
      --print("PartM ".. (i*3 )-5  .. " " ..tostring(partm[i]))
      part_marker[i] = tostring(partm[i])
      part_marker_beats[i] = (i*3 )-5
    end
    part_marker_count = part_marker_count +1
  end   
  
  for i = 1, part_marker_count +1 do
    if part_marker_beats[i] then
      --print("part_marker_beats ".. part_marker_beats[i] .." type ".. part_marker[i])
    --print("beat_count ".. beat_count[3] .." ".. chord_name[3])
  
    --print("Toatal Bars ".. total_bars+3)
    end
  end
  
  for i = 1, tablelength(roots) +1 do --total_bars +1 do
  
    --chord_name[i]
    --beat_count[i]
    color = reaper.ColorToNative(192,192,192)|0x1000000
    for m = 1, part_marker_count +1 do
      if part_marker_beats[m] then
        --print("PM Color ".. beat_count[i] .." ".. part_marker_beats[m])
        if beat_count[i] == part_marker_beats[m] then
          --print("FOUND part_marker_beats ".. part_marker_beats[m])
          if part_marker[m] == "1" then
            --print("BLUE")
            color = reaper.ColorToNative(17,39,174)|0x1000000
          end
          if part_marker[m] == "2" then
            --print("GREEN")
            color = reaper.ColorToNative(11,116,39)|0x1000000
          end      
        end
      end  
      
    end  
    
    if beat_count[i] then
      --print("REG START beat_count[i] ".. beat_count[i] .." " ..tostring(rootNames[roots[i]]) ..tostring(typeNames[types[i]]))
      reg_start = reaper.TimeMap2_beatsToTime( 0, beat_count[i]+5 )
      reg_start = reaper.SnapToGrid( 0, reg_start )
      --print("TIME reg_start "..reg_start)
    end  
    --reg_start = reaper.SnapToGrid( 0, reg_start )
    --print("reg_start "..reg_start)
   
    -- ADD 2 bar for count-in
    if i < tablelength(roots) then
      --print("REG END beat_count[i] ".. beat_count[i+1])
      reg_end = reaper.TimeMap2_beatsToTime( 0, beat_count[i+1]+5 )
      reg_end = reaper.SnapToGrid( 0, reg_end )
      --print("TIME reg_end "..reg_end)
      reaper.AddProjectMarker2( 0, true, reg_start, reg_end, chord_name[i], 1, color )
    end
    if i == tablelength(roots) then
      ending_bars = reaper.TimeMap2_beatsToTime( 0, 12)
      ending_bars = reaper.SnapToGrid( 0, ending_bars )
      reaper.AddProjectMarker2( 0, true, reg_start, reg_start+ending_bars, chord_name[i], 1, color )
    end
  end
  
  --reaper.Main_OnCommand( 40898, 0 ) -- Markers: Renumber all markers in timeline order
  reaper.SNM_SetIntConfigVar( "projmeasoffs", -2) -- offset measures
  
::chords_34_end::  
  
end  

function chords_44()
    retval, filetxt = reaper.GetUserFileNameForRead("", "Import Chords from SGU,MGU...", "")
    if not retval then goto chords_44_end end
    --print(GetFilename(filetxt))
    
    f = assert(io.open(filetxt, "rb"))
    
    local first_byte_sig = f:read(1)
    local name_bytes = f:read(1)
    --print("First byte = "..tostring(first_byte_sig))
    name_len = string.byte(name_bytes)
    --print("Name_length =" ..name_len)
    local bytes = f:read(name_len)
    --print("Name: "..tostring(bytes))
    local meter_denominator = 4
    --print("Meter: "..tostring(4).."/"..tostring(meter_denominator))
    local byte1 = string.byte(f:read(1))
    local byte2 = string.byte(f:read(1))
    local byte3 = string.byte(f:read(1))
    local keyByte = string.byte(f:read(1)) --read 
    local tempoByte = string.byte(f:read(1)) --read tempo byte
    
    if keyByte <= 17 then
      key = rootNames[keyByte]
      isMinor = false 
    else key = rootNames[keyByte - 17]
      isMinor = true
    end
    if isMinor then
      --print("Key : " ..key.. "m")
    else --print("Key: " ..key)
    end
    --print("Tempo: " ..tempoByte)
    reaper.Main_OnCommand( 40042, 0 ) -- Transport: Go to start of project
    reaper.SetCurrentBPM( 0, tempoByte, 0 ) -- 0 no undo points 1 undo points
    
    
    reaper.SetTempoTimeSigMarker( 0, -1, 0, -1, -1, -1, 4, 4, false )
    
    local bar = string.byte(f:read(1)) --read start bar number
    --print("Start bar: " ..bar)
    
    local types = {}
    local roots = {}
    local beats = {}
    local partm = {}
    numberOfChords = 1

-- count through the bars and bar types to find section boundaries
    
    while bar < 255 do -- maximum of 255 bars
      local barType = string.byte(f:read(1)) --read bar type
      
      if barType == 0 then
        duration = string.byte(f:read(1))
        bar = bar + duration
      else bar = bar + 1
      end
    

      partm[bar] = barType
       
    end
    
    total_bars = bar - duration -1
    --print("Total number of bars =" ..total_bars)
-- count through the chord type/duration section recording the beat count where chord changes occur in table beats[] and the chord type in types[] 
    local beat = 1 --start at beat 1
    while beat < 1020 do --maximum of 1020 beats (= 255 bars x 4 beats)
      local chordType = string.byte(f:read(1))
      if chordType == 0 then
        local duration = string.byte(f:read(1))
        beat = beat + duration
      else types[numberOfChords] = chordType
        --print("Chord change number "..tostring(numberOfChords).." to "..tostring(chordType).." ["..typeNames[chordType].."] at beat count "..tostring(beat))
        beats[numberOfChords] = beat
        numberOfChords = numberOfChords + 1
        last_beat = beat
        beat = beat + 1
      end
    end
  total_beats = last_beat - 1


  local i=1
  beat = 1 --start at beat 1
  
  while beat < 1020 do --maximum of 1020 beats
    
    local chordRoot = string.byte(f:read(1))
    if chordRoot == 0 then 
      local duration = string.byte(f:read(1))
      beat = beat + duration
    else roots[i] = chordRoot
      if beat ~= beats[i] then
        --print("Inconsistent chord type and root beat")
      end
      

      i = i + 1
      beat = beat + 1
    end
 
  end


  if i ~= numberOfChords then
    print("Inconsistent number of chord types and roots")
  end


  beats_no = (last_beat +15) / 4 * 4
  --print("Toatal 3/4 Beats ".. beats_no  )
  waltz_bars = 0

  
    --types = {}
    --roots = {}
    --beats = {}
    --partm = {}  
  
  chord_name = {}
  beat_count = {}
  part_marker = {}
  part_marker_beats = {}
  
  for i = 1, tablelength(roots) do
  
    nom_beats = beats[i] --((beats[i] / 4) * 4) 
    beat_number = 1
    
    nom_bars = (nom_beats / 4) 
    
    nom_bars  = math.floor(nom_bars)
    --nom_bars2 = round2(nom_bars,0)
     
     
    nom_beats2 = math.floor(nom_beats)
     
    --print("BAR ".. math.floor(nom_beats2 /4))
    --end
    --print("Beat ".. nom_beats2 .." " ..tostring(rootNames[roots[i]]) ..tostring(typeNames[types[i]]))
    
    chord_name[i] = tostring(rootNames[roots[i]]) ..tostring(typeNames[types[i]])
    beat_count[i] = nom_beats2
    
  
  end
  part_marker_count = 0
  for i = 2, total_bars +1 do --tablelength(roots) do --total_bars +1 do
    if partm[i] and partm[i] > 0 then
      --print("PartM ".. (i*4 )-7  .. " " ..tostring(partm[i]))
      part_marker[i] = tostring(partm[i])
      part_marker_beats[i] = (i*4 )-7
    end
    part_marker_count = part_marker_count +1
  end   
  
  for i = 1, part_marker_count +1 do
    if part_marker_beats[i] then
      --Msg("part_marker_beats ".. part_marker_beats[i] .." type ".. part_marker[i])
    --print("beat_count ".. beat_count[3] .." ".. chord_name[3])

    --print("Toatal Bars ".. total_bars+3)
    end
  end
  
  for i = 1, tablelength(roots) +1 do --total_bars +1 do
  
    --chord_name[i]
    --beat_count[i]
    color = reaper.ColorToNative(192,192,192)|0x1000000
    for m = 1, part_marker_count +1 do
      if part_marker_beats[m] then
        --print("PM Color ".. beat_count[i] .." ".. part_marker_beats[m])
        if beat_count[i] == part_marker_beats[m] then
          --print("FOUND part_marker_beats ".. part_marker_beats[m])
          if part_marker[m] == "1" then
            --Msg("BLUE")
            color = reaper.ColorToNative(17,39,174)|0x1000000
          end
          if part_marker[m] == "2" then
            --Msg("GREEN")
            color = reaper.ColorToNative(11,116,39)|0x1000000
          end      
        --else
          --color = reaper.ColorToNative(192,192,192)|0x1000000
        end
      end  
     
    end  
    
    if beat_count[i] then
      reg_start = reaper.TimeMap2_beatsToTime( 0, beat_count[i]+7 )
    end  
    reg_start = reaper.SnapToGrid( 0, reg_start )
    --print("reg_start "..reg_start)
   
    -- ADD 2 bar for count-in
    if i < tablelength(roots) then
      reg_end = reaper.TimeMap2_beatsToTime( 0, beat_count[i+1]+7 )
      reg_end = reaper.SnapToGrid( 0, reg_end )
      --beat_count_var = beat_count[i+1]+7
      --print("beat_count "..beat_count_var.." reg_end "..reg_end)
      --Msg("reg_start "..reg_start.." reg_end "..reg_end.." chord_name ".. chord_name[i])
      reaper.AddProjectMarker2( 0, true, reg_start, reg_end, chord_name[i], 1, color )
    end
    if i == tablelength(roots) then
      ending_bars = reaper.TimeMap2_beatsToTime( 0, 16)
      ending_bars = reaper.SnapToGrid( 0, ending_bars )
      reaper.AddProjectMarker2( 0, true, reg_start, reg_start+ending_bars, chord_name[i], 1, color )
    end
  end
  
  --reaper.Main_OnCommand( 40898, 0 ) -- Markers: Renumber all markers in timeline order
  reaper.SNM_SetIntConfigVar( "projmeasoffs", -2) -- offset measures
  
::chords_44_end::  
end



function read_linesRT(filepathRT)
  --Msg("filepath "..filepath)
  linesRT = {}

  local f = io.input(filepathRT)
  repeat

    r = f:read ("*l") -- read one line

    if r then  -- if not end of file (EOF)
      table.insert(linesRT, ParseCSVLine (r,sep))
    end

  until not r  -- until end of file

  f:close()

end

function read_linesRD(filepathRD)
  --Msg("filepath "..filepath)
  linesRD = {}

  local f = io.input(filepathRD)
  repeat

    r = f:read ("*l") -- read one line

    if r then  -- if not end of file (EOF)
      table.insert(linesRD, ParseCSVLine (r,sep))
    end

  until not r  -- until end of file

  f:close()

end

function read_lines2(filepath)
  --Msg("filepath "..filepath)
  --Msg("Read Lines")
  lines2 = {}

  local f = io.input(filepath)
  repeat

    s = f:read ("*l") -- read one line
    --Msg(s)
    if s then  -- if not end of file (EOF)
      table.insert(lines2, ParseCSVLine (s,sep))
    end

  until not s  -- until end of file

  f:close()

end

function read_lines(filepath)
  --Msg("filepath "..filepath)
  lines = {}

  local f = io.input(filepath)
  repeat

    s = f:read ("*l") -- read one line

    if s then  -- if not end of file (EOF)
      table.insert(lines, ParseCSVLine (s,sep))
    end

  until not s  -- until end of file

  f:close()

end

function stretch_item_to_pos(xpos)

  item = reaper.GetSelectedMediaItem(0, 0)
  take = reaper.GetActiveTake(item)
  rate = reaper.GetMediaItemTakeInfo_Value(take, "D_PLAYRATE")
  pos = reaper.GetMediaItemInfo_Value(item, "D_POSITION")
  length = reaper.GetMediaItemInfo_Value(item, "D_LENGTH")
  snapoffset = reaper.GetMediaItemInfo_Value(item, "D_SNAPOFFSET")
  
  invsnapoffset = length - snapoffset
  snapoffset_pos = pos + snapoffset
  item_end = pos + length
  editcur = xpos --reaper.GetCursorPosition()
  abs_beetween = math.abs(snapoffset_pos - editcur)
  itemcenter = pos + length/2
  k = 1
  
  if snapoffset ~= 0 then
    if editcur < snapoffset_pos then
      k = abs_beetween / snapoffset
      newlength = item_end - editcur
      newpos = editcur
      newsnapoffset = snapoffset * k 
      snapoffset0 = snapoffset * rate
      reaper.SetTakeStretchMarker(take, -1, 0)
      reaper.SetTakeStretchMarker(take, -1, snapoffset0)
    end  
  
    if editcur > snapoffset_pos then
      k = abs_beetween / invsnapoffset
      newlength = editcur - pos
      newpos = pos
      newsnapoffset = snapoffset
      snapoffset0 = snapoffset * rate
      length0 = length * rate
      reaper.SetTakeStretchMarker(take, -1, snapoffset0)
      reaper.SetTakeStretchMarker(take, -1, length0)
    end
    if editcur == snapoffset_pos then
      newlength = length
      newpos = pos
      newsnapoffset = snapoffset
    end
  reaper.SetMediaItemInfo_Value(item, "D_SNAPOFFSET", newsnapoffset)    
  end
  
  if snapoffset == 0 then
    if editcur < itemcenter then
      fut_lenght = item_end - editcur
      k = fut_lenght / length
      newlength = length * k
      newpos = editcur
    end
    if editcur > itemcenter then
      fut_length = editcur - pos
      k = fut_length / length
      newlength = length * k
      newpos = editcur - newlength
    end
    if editcur == itemcenter then
      newlength = length
      newpos = pos
    end
    newrate = rate / k 
    reaper.SetMediaItemTakeInfo_Value(take, "D_PLAYRATE", newrate)  
  end
     
  reaper.SetMediaItemInfo_Value(item, "D_POSITION", newpos)
  reaper.SetMediaItemInfo_Value(item, "D_LENGTH", newlength)
   
  
  if snapoffset ~= 0 then
    if editcur < snapoffset_pos then
      newsnapoffset0 = (snapoffset_pos - newpos) * rate
      reaper.SetTakeStretchMarker(take, 1, newsnapoffset0)
    end
    if editcur > snapoffset_pos then
      newlength0 = (editcur - newpos) * rate
      reaper.SetTakeStretchMarker(take, 0, snapoffset0)
      reaper.SetTakeStretchMarker(take, 1, newlength0)
    end
  end

end

function getFolderName(str)
    
    file_path = str:match("^(.+)\\") --("(.*[/\\])")
    file = string.gsub(str, file_path, "")
    --Msg("file "..file)
    --Msg("file_path "..file_path)
    
    dir_back = string.gsub(file_path,"(.*)\\.*$","%1")
    
    --Msg("dir_back "..dir_back)
    
    file_folder = string.gsub(str, dir_back, "")
    
    file_folder = string.gsub(file_folder, file, "")
    
    file_folder = string.gsub(file_folder, "\\", "")
    
    --Msg("folder "..file_folder)
    
    
    return file_folder
end

function getFolderName2(path)

  local dir = path:match".*[\\/](.-)[\\/]"
  
  return dir

end



function getFolder(_path)
    pattern1 = "^(.+)//"
    pattern2 = "^(.+)\\"

    if (string.match(path,pattern1) == nil) then
        return string.match(path,pattern2)
    else
        return string.match(path,pattern1)
    end
end

function getRTnumber(instrument_name)
  
  letter = GUI.Val("my_mnu3")
  drive = {"C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"}
  RTtxt = drive[letter]..[[:\bb\Data\RealTracksList.txt]]
  
  check_file =  reaper.file_exists( RTtxt )
  
  if not check_file then
    
    reaper.MB("No RT List, In RT Picker select Copy List", "Notice",0)
    RT_number = "000"
    goto read_linesRT_end
    
  end
  
  read_linesRT(RTtxt)
  
  folder = RTtxt:match[[^@?(.*[\/])[^\/]-$]]
  --Msg("Instrument name "..instrument_name)
  
  for i, line in ipairs( linesRT ) do
    if i > 0 then
  
      local RT_name = line[1]
      local RT_number = line[7]
      
      --if RT_name then
        --Msg("RTname "..RT_name)
      --end
     -- Msg(instrument_name)
      --if i == 937 then
      
        --Msg("RT_name "..RT_name)
      --end
      if instrument_name == RT_name then
        --Msg("RT# "..RT_number)
        --Msg("RTname "..RT_name)
        return RT_number
        --break
      end
    end
  end 
  
  if instrument_name ~= RT_name then
    --Msg("RT# "..RT_number)
    --Msg("RTname "..RT_name)
    RT_number = "000"
    return RT_number  
  end  
::read_linesRT_end::
end


function import_all_chk_tracks_btn_click()

  trks = GUI.Val("my_chk2")
     --Blue,Simp,DI,H = bool_num(opts[1]), bool_num(opts[2]), bool_num(opts[3]), bool_num(opts[4])
  --Msg(trks[2])
  
  for i = 1, 24 do
    if trks[i] == true then
    
      --Msg("Track "..i)
      reaper.CF_SetClipboard( i-1 )
      reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select track number.ahk"]],0) 
      import_sel_trk_btn_click()
      import_sel_mid_trk_btn_click()
      
    end
  
  end
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Close F8.ahk"]],0) 
        
end

function snap_regions_grid()

  reaper.Main_OnCommand(40754, 0) -- Enable snap
  
  region_count , num_markersOut, num_regionsOut = reaper.CountProjectMarkers(0)
  
  for i=0, region_count -1 do
  
   --EnumProjectMarkers(i, is_region, region_start, region_end, #name, region_id)
   retval, isrgnOut, posOut, rgnendOut, region_name, markrgnindexnumberOut, colorOut = reaper.EnumProjectMarkers3(0, i)      
  
  --if isrgnOut then
     
     region_snapped_start =  reaper.SnapToGrid(0, posOut)
     region_snapped_end =  reaper.SnapToGrid(0, rgnendOut) 
     
     --SetProjectMarker(region_id, 1, region_snapped_start, region_snapped_end, #name)
     
     reaper.SetProjectMarker3( 0, markrgnindexnumberOut, isrgnOut, region_snapped_start, region_snapped_end, region_name , colorOut )
     
  --end
  --end  
  end 

end

function send_chords_biab_btn_click()

  snap_regions_grid() 
  
  reaper.ClearConsole()
  if reaper.APIExists("JS_Window_Find") == true then
  local hwnd = reaper.JS_Window_Find("ReaScript console output", true)
  if hwnd then reaper.JS_Window_Destroy(hwnd) end
  end 
  
  b = 0
  bar4 = 0
  bar16 = 0
  part = ""
  pre_part = ""
  pre_chord = ""
  
  --ts_choice = GUI.Val("my_mnu4")
  --ts_choice = GUI.elms.my_mnu4.optarray[ GUI.Val("my_mnu4") ]
  --Msg("choice "..ts_choice)
  
  --if ts_choice == "4/4" then time_signature = 4 end
  --if ts_choice == "3/4" then time_signature = 3 end
  --Msg("TS "..time_signature[ts_choice])  
  --
  --reaper.ClearConsole()
  
    --Msg("Color "..ColorHexToInt("#1127AE"))
   retval, num_markers, num_regions = reaper.CountProjectMarkers( 0 )
   if num_regions == 0 then goto biab_chords_end end
  -- Msg(num_regions)
   retval, isrgn, end_pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, num_regions -1 )
   --Msg("\n"..end_pos.."\n")
   retval, measures, cml, end_fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, end_pos  )
   
   bpm =  math.floor(reaper.Master_GetTempo())
   --bpm, bpi = reaper.GetProjectTimeSignature2( 0 )
   retval, timepos, measurepos, beatpos, bpm2, timesig_num, timesig_denom, lineartempo = reaper.GetTempoTimeSigMarker( 0, 0 )
   --Msg("TS "..timesig_num)
   end_measure = measures -2
   key_choice = GUI.elms.my_mnu5.optarray[ GUI.Val("my_mnu5") ]
   --Msg(end_fullbeats)
   reaper.ShowConsoleMsg("[Song]".."\n".."[Key "..key_choice.."] [Tempo ".. bpm.."] [Form 1-"..end_measure.."*1]".."\n".."[Chords]".."\n")
   for b = (timesig_num*2), end_fullbeats  do -- 8 = 2 bar count-in
     current_pos = reaper.TimeMap2_beatsToTime( 0, b )
     --Msg(" current_pos "..current_pos)
     --retval, measures, cml, current_fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, current_pos )
     --current_pos = reaper.TimeMap2_beatsToTime( 0, current_fullbeats )
     
     for i = 0, num_markers + num_regions -1 do
       retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, i )
       --Msg(" pos "..pos)
       --Msg("name "..name)
       
       --if isrgn == 1 and pos == current_pos then
       if reaper.SnapToGrid( 0, pos ) == reaper.SnapToGrid( 0, current_pos) then
       
          chord = name
          
         --Msg("pos = current pos ".." part "..part)
         --Msg("region color "..color.." name "..name)
         --if pos == current_pos then
           if color == reaper.ColorToNative(17,39,174)|0x1000000 then -- verse_post_fill
             part = "a)" 
             
           end
           if color == reaper.ColorToNative(11,116,39)|0x1000000 then -- chorus_post_fill
             part = "b)" 
             
           end
           if color == reaper.ColorToNative(151,208,254)|0x1000000 then -- verse_ending
             part = "aend)"
             
           end         
           if color == reaper.ColorToNative(158,245,182)|0x1000000 then -- chorus_ending
             part = "bend)"
             
           end         
           
       end
       
     end
     
     if pre_part == part then part = "" end
     if pre_chord == chord then chord = "\\" end
     --if pre_chord == "\\" then chord = "\\" end
     if b == (timesig_num*2) then reaper.ShowConsoleMsg("|") bar4 = bar4 + 1 end
     --Msg(" beat "..b.." pos "..current_pos)
     reaper.ShowConsoleMsg(part.." "..chord)
     if bar4 == timesig_num then bar4 = 0 bar16 = bar16 + 1 reaper.ShowConsoleMsg("|") end
     if bar16 == 4 then bar16 = 0 reaper.ShowConsoleMsg("\n".."|") end
     bar4 = bar4 + 1
     
     pre_part = part
     pre_chord = chord
   end
   reaper.ShowConsoleMsg("|")
    
   --retval, isrgn, pos, rgnend, name3, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, num_regions -1 )
   
   --reaper.ShowConsoleMsg("\n".."|b)"..name3.."|")
    
   reaper.ShowConsoleMsg("\n".."[ChordsEnd]".."\n".."[SongEnd]") 
   
   reascript_console_hwnd = reaper.JS_Window_Find("ReaScript console output", true)
   
   reascript_console_hwnd_textfield = reaper.JS_Window_FindChildByID(reascript_console_hwnd, 1177)
   
   content=reaper.JS_Window_GetTitle(reascript_console_hwnd_textfield)
   
   reaper.CF_SetClipboard(content)
   
   --reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Reaper region chord to Biab.ahk"]],0) 
   --wait(10)
   --if timesig_num == tonumber(time_signature) then
   reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Reaper region chord to Biab.ahk"]],0) 
   --else
   
     --reaper.MB("Set Time Signature to match Reaper", "Notice",0)
   --end
::biab_chords_end::

end

function create_stem_track(stem_name)

  reaper.Main_OnCommand(40062,0) -- Track: Duplicate tracks

  sel_track = reaper.GetSelectedTrack2( 0, 0, 0 )
  
  reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items
  
  reaper.Main_OnCommand(40421,0) -- Item: Select all items in track
  
  item_count = reaper.CountTrackMediaItems( sel_track )
  
  
  
  if not previouse_stem_name then
    previouse_stem_name = ""
  end  
  
  
  
  --Msg("previouse_stem_name "..previouse_stem_name)
  
  for i = 0, item_count -1 do
    
    item2 = reaper.GetSelectedMediaItem(0, i)
    take2 = reaper.GetActiveTake(item2)
    item_source = filenamenoext..stem_name..extension
    item_source = string.gsub(item_source, "Style", "")
    item_source = string.gsub(item_source, "STYLE", "")
    item_source = string.gsub(item_source, "\\", "\\".."\\")
    --Msg(filenamenoext..stem_name..extension)
    --Msg(item_source)
    
     
    retval, stringNeedBig = reaper.GetSetMediaItemTakeInfo_String( take2, "P_NAME", "", false )
    
    --stringNeedBig = string.gsub(stringNeedBig, "Style_", "")
    --stringNeedBig = string.gsub(stringNeedBig, "STYLE_", "")
    
    item_name = string.gsub(stringNeedBig, extension, "")
    
    item_name = string.gsub(item_name, previouse_stem_name, "")

    
    
    --Msg("item_name "..item_name.."  Removed "..previouse_stem_name)
    
    --Msg("previouse_stem_name "..previouse_stem_name)
    
    item_name = item_name.."_"..stem_name..extension
    
    item_name = string.gsub(item_name, "Style_", "")
    item_name = string.gsub(item_name, "STYLE_", "")
    
    retval, stringNeedBig = reaper.GetSetMediaItemTakeInfo_String( take2, "P_NAME", item_name, true )
    
    reaper.BR_SetTakeSourceFromFile(take2, item_source, true)
    
    --start_offsets = reaper.GetMediaItemTakeInfo_Value( take2, "D_STARTOFFS" )
    
    --Msg("start_offsets "..start_offsets)
    
    --reaper.SetMediaItemTakeInfo_Value( take2, "D_STARTOFFS", source_time_pos ) -- "D_PLAYRATE" "D_PITCH" "D_STARTOFFS" 
    
    
    
    
  end  
  
    previouse_stem_name = ("_"..stem_name) --..extension)
    
    --previouse_stem_name = string.gsub(previouse_stem_name, "Style_", "")
    --previouse_stem_name = string.gsub(previouse_stem_name, "STYLE_", "")
    
    
    retval, namestring = reaper.GetSetMediaTrackInfo_String( sel_track, "P_NAME", stem_name, true )
    
    --reaper.UpdateTimeline()
    
    --reaper.Main_UpdateLoopInfo( 0 )
    
    reaper.UpdateArrange() 
    --reaper.Main_OnCommand(40441, 0) -- rebuild peaks for selected items 
    reaper.Main_OnCommand(40047, 0) -- Peaks: Build any missing peaks
    

end

function stereo_drums_to_stems_btn_click()

  reaper.Undo_BeginBlock() 
  sep = "," -- default sep
  popup = true
  
  col_stem = 1
  
   sel_track = reaper.GetSelectedTrack2( 0, 0, 0 ) 
   
   if not sel_track then goto finish_stems end
    
   first_item = reaper.GetTrackMediaItem( sel_track, 0 )
   
   take = reaper.GetMediaItemTake( first_item, 0)
   
   source = reaper.GetMediaItemTake_Source(take)
   
   filenamepath = reaper.GetMediaSourceFileName( source )
   
   path = GetPath(filenamepath)
   
   
   --Msg("filenamepath "..filenamepath)
   --Msg("path "..path)
   
   filename = GetFilename(filenamepath)
   --Msg("filename "..filename)
   extension = GetFileExtension(filename)
   --Msg("extension "..extension)
   filenamenoext = string.gsub(filenamepath, extension, "")
   
   filenamenoext = string.gsub(filenamenoext, "Style", "")
   filenamenoext = string.gsub(filenamenoext, "STYLE", "")
   --Msg("filenamenoext "..filenamenoext)
   steminfopath = (path.."StemInfo.txt")
   if reaper.file_exists( steminfopath ) then
   --Msg("steminfopath "..steminfopath)
     read_lines(steminfopath)
     filetxt = steminfopath
     main4()
   else
     reaper.MB("No Stems for these Drums", "Attention",0)
   end  
   
  ::finish_stems:: 
  reaper.Undo_EndBlock("ReaTrak create stems", -1) 
  


end

function unfold_btn_click()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\bb_unfold.ahk"]],0) 
       

end

function GetFileExtension(url)
  return url:match("^.+(%..+)$")
end

function GetPath(str)
  return str:match("(.*[/\\])")
end

-- Main function
function main2()

  drums = 0

  folder = filetxt:match[[^@?(.*[\/])[^\/]-$]]

  for i, line in ipairs( lines ) do
    if i > 0 then

      -- Name Variables
      --[[
      local pos = tonumber(line[col_pos])
      local pos_end = tonumber(line[col_pos_end])
      local len =  tonumber( line[col_len] )
      local name = line[col_name]
      local color = 0
      
      PN2719-2.WAV
      
      col_id = 1
      col_data = 2
      col_source = 3
      col_bpm = 4
      col_timesig = 7
      col_source_start = 8 -- - (beats * 1200) 
      col_source_end = 12 -- / 1200 (/col_timesig)
      col_source_dest = 17
      col_bar_dest = 19 -- +3 including count-in
      col_transpose = 22
      --]]
      d = 0
      ps = 0
      pitch = ""
      local is_data = tonumber(line[col_data])
      
      
      if is_data == 1 then
        local source = line[col_source]
        local source_bpm = tonumber(line[col_bpm])
        local time_sig = tonumber(line[col_timesig])
        local source_start = tonumber(line[col_source_start])
        local source_end = tonumber(line[col_source_end]) 
        local source_offset = (line[col_source_offset])
        local source_dest = tonumber(line[col_source_dest])
        local transpose = tonumber(line[col_transpose])
        local d = tonumber(line[col_is_drums])
        --filename = GetFilename(source)
        --Msg("source "..source)
        
        if string.find(source, "+1.") then pitch = "+1" end
        if string.find(source, "+2.") then pitch = "+2" end
        if string.find(source, "+3.") then pitch = "+3" end
        if string.find(source, "+4.") then pitch = "+4" end
        if string.find(source, "-1.") then pitch = "-1" end
        if string.find(source, "-2.") then pitch = "-2" end
        if string.find(source, "-3.") then pitch = "-3" end
        if string.find(source, "-4.") then pitch = "-4" end
        
        
        if pitch == "" then pitch = 0 ps = 15 end
        
        
        --pitch = tonumber(round(pitch))
        --Msg("pitch "..pitch)
        if ps ~= 15 then
          source = source:gsub(pitch..".", ".")
        end
        
        RTextension = GUI.Val("my_mnu2")
        
        file_type = {".wma",".wav",".aiff",".flac",".mp3",".wv",".ogg"}
        
        source = source:gsub(".WAV", file_type[RTextension])
        
        if string.find(source,"Drums") then
          drums = 1
          
        else
          drums = 0
        end
        
        source_offset = source_offset:gsub("-", "")
        
        source_offset = 0
        
        --Msg("source "..source)
        --Msg("source bpm "..source_bpm)
        --Msg("time sig "..time_sig)
        --Msg("source start "..source_start)
        --Msg("source end "..source_end)
        --Msg("source dest "..source_dest)
        --Msg("transpose "..transpose)
         
        --if d == 1 then  
        --  offset = 50 
        --else offset = 0  
        --end
        
        
        bpm =  reaper.Master_GetTempo()
        
        pitch = pitch + transpose
        
        track_pos = ""
        
        reaper.InsertMedia( source, 0 )
        
        sel_item =reaper.GetSelectedMediaItem( 0, 0 )
        
        --instrument_name = getFolderName(source)
        
        instrument_name1 = getFolderName2(source)
        
        
        
        instrument_name = instrument_name1:gsub(" Direct Input", "")
        
        --Msg(
        --Msg("instrument_name1 "..instrument_name1)
        
        --instrument_path = (string.gsub(source, start_path, "")) 
        
        
        
        --Msg(instrument_name)
        
        --if i == 1 then
          --current_track = reaper.GetMediaItem_Track( sel_item )
          --current_track = reaper.GetSelectedTrack2( 0, 0, 1 )
          --reaper.GetSetMediaTrackInfo_String(current_track, "P_NAME", instrument_name, true)
        
        --end
        
        sel_take = reaper.GetTake( sel_item, 0 )
        
        playrate = (bpm / source_bpm)
        
        source_beat_start = (((source_start + source_offset) / 1200) ) --- (1200 * time_sig)
        
        source_beat_end = (((source_end + source_offset) / 1200) ) --- (1200 * time_sig)
        
        source_beat_length = source_beat_end - source_beat_start
        
        source_time_length = ((source_beat_length / source_bpm) * 60)
        
        source_time_pos = ((source_beat_start / source_bpm) * 60)
        
        track_beat_pos = (source_dest / 1200)
        
        track_time_pos = reaper.TimeMap2_beatsToTime( 0, track_beat_pos )
        
        track_time_pos_end = reaper.TimeMap2_beatsToTime( 0, track_beat_pos + source_beat_length )
        
        --track_time_pos = (((track_beat_pos) / bpm) * 60)
        
        --track_item_length = ((source_beat_length / bpm) * 60)
        
        --Msg("track time pos "..track_time_pos)
        --Msg("source_beat_length "..source_beat_length)
        --Msg("source_time_length "..source_time_length)
        --Msg("source_beat_start "..source_beat_start)
        --Msg("source_beat_end "..source_beat_end)
        --Msg("track_time_pos "..track_time_pos)
       -- Msg("track_beat_pos "..track_beat_pos)
        
        
        --reaper.SetMediaItemTakeInfo_Value( sel_take, "D_PLAYRATE", playrate ) -- "D_PLAYRATE" "D_PITCH" "D_STARTOFFS"
        
        reaper.SetMediaItemTakeInfo_Value( sel_take, "D_PITCH", pitch ) -- "D_PLAYRATE" "D_PITCH" "D_STARTOFFS"
        
        reaper.SetMediaItemTakeInfo_Value( sel_take, "D_STARTOFFS", source_time_pos ) -- "D_PLAYRATE" "D_PITCH" "D_STARTOFFS"        
        
        reaper.SetMediaItemInfo_Value( sel_item, "D_POSITION", track_time_pos ) -- "D_POSITION"  "D_LENTH"
        
       -- reaper.SetMediaItemInfo_Value( sel_item, "D_LENTH", source_time_length ) -- "D_POSITION"  "D_LENTH"
        
        reaper.SetMediaItemLength(sel_item, source_time_length, true)
        
        stretch_item_to_pos(track_time_pos_end)
        
        reaper.SetMediaItemInfo_Value( sel_item, "C_BEATATTACHMODE", 1 )
         
        reaper.SetMediaItemInfo_Value( sel_item, "C_AUTOSTRETCH", 1 )
        
        -- Msg("SET")
        
        reaper.Main_OnCommand( 40289, 0 ) -- Item: Unselect (clear selection of) all items
        
        --if i > 2 then break end
        --reaper.SetMediaItemPosition(sel_item, number position, boolean refreshUI)
  
        --reaper.UpdateArrange()
      
        --reaper.AddProjectMarker2( 0, is_region, pos + cur_pos, pos_end + cur_pos, name, -1, color )
      end

    end
  end
  
  if drums == 1 then
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\bb_get_midi_track_name.ahk"]],0) 
        
    
    set_track_and_item_name() 
  else
    RT_number = getRTnumber(instrument_name)
    if not RT_number then RT_number = "000" end
    if not instrument_name1 then instrument_name1 = "none" end
    instrument_name = instrument_name1:gsub(" Direct Input", "")
  
    --current_track = reaper.GetMediaItem_Track( sel_item )
    current_track = reaper.GetSelectedTrack( 0, 0 )
    --current_track = reaper.GetTrack( 0, sel_track )
    --current_track = reaper.GetSelectedTrack2( 0, 0, 1 )
    reaper.GetSetMediaTrackInfo_String(current_track, "P_NAME", RT_number..":"..instrument_name1, true)
    --Msg(instrument_name)
  end
end

function main3()

  folder = filetxt2:match[[^@?(.*[\/])[^\/]-$]]
  --Msg("filetxt2 "..filetxt2)
  for i, line in ipairs( lines2 ) do
    --Msg(line[1])
    if i > 1 then -- start on 2nd line
      --Msg(line[6])
      if i == 2 and string.match(line[6],"Tick*") then
        midi_ppq = string.gsub(line[6], "Tick", "")
        --Msg("midi_ppq "..midi_ppq)
      end
      
      -- Name Variables
      --[[
      col_ch = 2
      col_pqpos = 3
      col_note = 7
      col_vel = 9
      col_duration = 10
      --]]
      --Msg("Line "..line
      local is_NoteOn = tostring(line[1])
      --Msg(tostring(line[1]))
      --Msg("Pos "..tonumber(line[3]))
      
      
      if is_NoteOn == "NoteOn" then
        local channel = tonumber(line[col_ch])
        local ppqpos = tonumber(line[col_ppqpos])
        local note = tonumber(line[col_note])
        local velocity = tonumber(line[col_vel])
        local duration = tonumber(line[col_duration])
        
        start_pos, end_pos = reaper.GetSet_LoopTimeRange2(0, false, false, 0, 0, false)
        
        retval, measures, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, start_pos )
        
        ppq_offset = ppq_set / midi_ppq

        endppqpos = (ppqpos + duration) 
        
        sel_item =reaper.GetSelectedMediaItem( 0, 0 )
        
        sel_take = reaper.GetTake( sel_item, 0 )

        ppq_start = (fullbeats*midi_ppq) * ppq_offset -- for midi items that start on another bar
        --ppq_start = 0
        
        reaper.MIDI_InsertNote( sel_take, 0, 0, (ppqpos*ppq_offset)-ppq_start, (endppqpos*ppq_offset)-ppq_start, channel, note, velocity, 0 )
        --reaper.MIDI_InsertNote( sel_take, 0, 0, 961, 972, 13, 36, 115, 1 )
        --Msg("pos "..ppqpos.." End Pos "..endppqpos.." Ch "..channel.." Note "..note.." Vel "..velocity)
        
        
      end

    end
  end

end

function main3b()
  ---Get Midi Length
  folder = filetxt2:match[[^@?(.*[\/])[^\/]-$]]
  --Msg("filetxt2 "..filetxt2)
  for i, line in ipairs( lines2 ) do
    --Msg(line[1])
    if i > 1 then -- start on 2nd line
      --Msg(line[6])
      if i == 2 and string.match(line[6],"Tick*") then
        midi_ppq = string.gsub(line[6], "Tick", "")
        
      end
      
      col_ch = 2
      col_pqpos = 3
      col_note = 7
      col_vel = 9
      col_duration = 10
      
      is_NoteOn = tostring(line[1])
      --Msg(tostring(line[1]))
      --Msg("Pos "..tonumber(line[3]))
      if is_NoteOn == "NoteOn" then
        channel = tonumber(line[col_ch])
        ppqpos = tonumber(line[col_ppqpos])
        note = tonumber(line[col_note])
        velocity = tonumber(line[col_vel])
        duration = tonumber(line[col_duration])
      end  
    end
  end
  return ppqpos, duration, midi_ppq
end  

function main4()

  folder = tostring(filetext):match[[^@?(.*[\/])[^\/]-$]]

  for i, line in ipairs( lines ) do
    if i > 2 then
    
      local stem_name = line[col_stem]
      
      create_stem_track(stem_name)    
     
    end    
  end  
  
end

function rt_to_di_btn_click()

  sel_track = reaper.GetSelectedTrack2( 0, 0, 0 )
  
  reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items
  
  reaper.Main_OnCommand(40421,0) -- Item: Select all items in track
  
  item_count = reaper.CountTrackMediaItems( sel_track )
  
  for i = 0, item_count -1 do
    
    item2 = reaper.GetSelectedMediaItem(0, i)
    take2 = reaper.GetActiveTake(item2)
    item_source = reaper.GetMediaItemTake_Source( take2 )
    item_source_filename = reaper.GetMediaSourceFileName( item_source )
    item_folder_path = GetPath(item_source_filename)
    --ext = GetFileExtension(item_source_filename)
    --item_folder_path = item_folder_path.sub(1, -2)
    --item_folder_path = string.sub(item_folder_path, -1, 1)
    item_folder_path = item_folder_path:sub(1, #item_folder_path - 1)
    --item_folder_path = item_folder_path.." Direct Input\\"
    --item_folder_path = string.gsub(item_folder_path, item_folder_path, item_folder_path.." Direct Input\\")
    item_folder_path = string.gsub(item_folder_path, "RealTracks\\", "RealTracks\\Direct Input\\")
    input_source_file = GetFilename(item_source_filename)
    --Msg("input_source_file "..input_source_file)
    new_item_source_filename = item_folder_path.." Direct Input\\"..input_source_file
    --Msg(new_item_source_filename)
    --item_source = string.gsub(item_source, "\\", "\\".."\\")
    --Msg(filenamenoext.."_"..stem_name..extension)
    --Msg(item_source)
    if  reaper.file_exists( new_item_source_filename ) then
      reaper.BR_SetTakeSourceFromFile(take2, new_item_source_filename, true)
      --reaper.Main_OnCommand(40441,0) -- Peaks: Rebuild peaks for selected items
      reaper.Main_OnCommand(40047,0) -- Peaks: Build any missing peaks
    end
    
  end  


end


function rt_to_fx_btn_click()
  
  sel_track = reaper.GetSelectedTrack2( 0, 0, 0 )
  
  reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items
  
  reaper.Main_OnCommand(40421,0) -- Item: Select all items in track
  
  item_count = reaper.CountTrackMediaItems( sel_track )
  
  for i = 0, item_count -1 do
    
    item2 = reaper.GetSelectedMediaItem(0, i)
    take2 = reaper.GetActiveTake(item2)
    item_source = reaper.GetMediaItemTake_Source( take2 )
    item_source_filename = reaper.GetMediaSourceFileName( item_source )
    item_folder_path = GetPath(item_source_filename)
    --ext = GetFileExtension(item_source_filename)
    item_source_filename = string.gsub(item_source_filename, " Direct Input", "")
    item_source_filename = string.gsub(item_source_filename,  "Direct Input", "")
    
    --item_source = string.gsub(item_source, "\\", "\\".."\\")
    --Msg(filenamenoext.."_"..stem_name..extension)
    --Msg(item_source)
    if  reaper.file_exists( item_source_filename ) then
      reaper.BR_SetTakeSourceFromFile(take2, item_source_filename, true)
      reaper.Main_OnCommand(40047,0) -- Peaks: Build any missing peaks
    end
  end



end

function set_track_and_item_name()
  isdrum = 0
  midi_name = reaper.CF_GetClipboard()
  --Msg("Clipboard "..midi_name)
  if string.find(midi_name,"Drums") then
    isdrum = 1
    --reaper.MB(midi_name,"Drums",0)
  else
    isdrum = 0
  end
  midi_name = midi_name:match"^.-:.-:(.+)"
  --Msg(midi_name)
  reaper.Main_OnCommand(40421,0) -- Item: Select all items in track
  sel_midi_item =  reaper.GetSelectedMediaItem( 0, 0 )
  
  if not midi_name then midi_name = "Midi" end
  
    midi_take = reaper.GetMediaItemTake( sel_midi_item, 0 )
    
  if  reaper.TakeIsMIDI( midi_take ) then  
    retval, stringNeedBig = reaper.GetSetMediaItemTakeInfo_String( midi_take, "P_NAME", midi_name, true )
  end
  midi_track =  reaper.GetMediaItem_Track( sel_midi_item )
  reaper.GetSetMediaTrackInfo_String(midi_track, "P_NAME", midi_name, true)

  reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items

end

function import_cur_riff_mid_sec_new_btn_click()

  reaper.Main_OnCommand( 40001, 0 ) -- Track: Insert new track
  import_cur_riff_mid_sec_btn_click()
end


function import_cur_riff_mid_sec_btn_click()
  
  cur_pos1 = reaper.GetCursorPosition()
  -- INIT
  
  sep = "\t" -- default sep
  popup = true
  
  --[[
  col_pos = 3 -- Position column index in the CSV
  col_pos_end = 4 -- Length column index in the CS
  col_len = 5 -- Length column index in the CSV
  col_name = 2 -- Name column index in the CSV
  col_color = 6
  --]]
  col_ch = 2
  col_ppqpos = 3
  col_note = 7
  col_vel = 9
  col_duration = 10
  
  letter = GUI.Val("my_mnu3")
  drive = {"C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"}
  
  
  inipath = reaper.get_ini_file()
  
  retval_ppq, ppq_set = reaper.BR_Win32_GetPrivateProfileString("reaper", "miditicksperbeat", "", inipath) 
  --retval, filetxt = reaper.GetUserFileNameForRead("", "Import RT RD Sections text", "txt")
  filetxt2 = drive[letter]..[[:\bb\Data\trackdata.txt]]
  
  if filetxt2 then
  
    --cur_pos = reaper.GetCursorPosition()
    
    --reaper.Main_OnCommand( 40001, 0 ) -- Track: Insert new track
    
    --reaper.Main_OnCommand( 40042, 0 ) -- Transport: Go to start of project
    
    --reaper.Main_OnCommand( 40625, 0 ) -- Time selection: Set start point
    
    --reaper.Main_OnCommand( 40043, 0 ) -- Transport: Go to end of project
    
    --reaper.Main_OnCommand( 40626, 0 ) -- Time selection: Set end point
    
    --reaper.Main_OnCommand( 40042, 0 ) -- Transport: Go to start of project
    
    start_pos, end_pos = reaper.GetSet_LoopTimeRange2(0, false, false, 0, 0, false)
    
    if start_pos == end_pos then 
      reaper.MB("Select Track & Section", "Select Track & Section",0)
      goto finish
    end 
    
    --reaper.Main_OnCommand( 40718, 0 ) -- Item: Select all items on selected tracks in current time selection
    
    --reaper.Main_OnCommand( 40307, 0 ) -- Item: Cut selected area of items
  
    reaper.Main_OnCommand( 40214, 0 ) -- Insert new MIDI item...
    
    --delete_notes()
    --reaper.MB("Pause", "Pause",0)
    --goto finish
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\bb_midi_track_info.ahk"]],0) 
       
  
    --wait(3)
    
    
    reaper.PreventUIRefresh(1)
  
    reaper.Undo_BeginBlock() -- Begining of the undo block. Leave it at the top of your main function.
    
    --reaper.ClearConsole()
    
    read_lines2(filetxt2)
    
    --reaper.MoveEditCursor( start_pos, 0 )
    
  
    
    -- reaper.Main_OnCommand( reaper.NamedCommandLookup( "_SWSMARKERLIST10" ), -1) -- SWS: Delete all regions
  
    main3()
    --reaper.MB("Ready to Set track Name", "!!!!",0)
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\bb_get_midi_track_name.ahk"]],0) 
        
    
    set_track_and_item_name()
  
    reaper.Undo_EndBlock("Import Biab Midi Track Data to new item", -1) -- End of the undo block. Leave it at the bottom of your main function.
  
    
    --Delete Midi Notes start in time selection
    
    --reaper.Main_OnCommand(40421,0) -- Item: Select all items in track
    
    --reaper.Main_OnCommand(42432,0) -- Item: Glue items
    
    --reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items
    
    --reaper.Main_OnCommand(40042,0) -- Transport: Go to start of project
    
    --reaper.Main_OnCommand(40635,0) -- Time selection: Remove (unselect) time selection
    ::finish::
    reaper.UpdateArrange()
  
    reaper.PreventUIRefresh(-1)
    
    reaper.MoveEditCursor( start_pos, 0 )
  end
  
  --start_pos, end_pos = reaper.GetSet_LoopTimeRange2(0, false, false, 0, 0, false)
  --reaper.MB("Move Cursor to Loop start "..start_pos, "Notice",0)
  
  reaper.MoveEditCursor( start_pos, 0 )
  reaper.Main_OnCommand(40630,0) -- Go to start of time selection
  
  
  
end

function import_sel_mid_trk_btn_click()
  
  
  -- INIT
  
  sep = "\t" -- default sep
  popup = true
  

  col_ch = 2
  col_ppqpos = 3
  col_note = 7
  col_vel = 9
  col_duration = 10
  
  letter = GUI.Val("my_mnu3")
  drive = {"C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"}
  
  
  inipath = reaper.get_ini_file()
  
  retval_ppq, ppq_set = reaper.BR_Win32_GetPrivateProfileString("reaper", "miditicksperbeat", "", inipath) 
  --retval, filetxt = reaper.GetUserFileNameForRead("", "Import RT RD Sections text", "txt")
  filetxt2 = drive[letter]..[[:\bb\Data\trackdata.txt]]
  
  if filetxt2 then
  
    cur_pos = reaper.GetCursorPosition()
    
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\bb_midi_track_info.ahk"]],0) 
       
  
    wait(2)
    
    --set_track_and_item_name()
    
    reaper.PreventUIRefresh(1)
  
    reaper.Undo_BeginBlock() -- Begining of the undo block. Leave it at the top of your main function.
    
    --reaper.ClearConsole()
    
    read_lines2(filetxt2)
    
    --reaper.MoveEditCursor( start_pos, 0 )
    
    main3b() -- Get midi_ppq length
    
    reaper.Main_OnCommand( 40001, 0 ) -- Track: Insert new track
    
    reaper.Main_OnCommand( 40042, 0 ) -- Transport: Go to start of project
    
    reaper.Main_OnCommand( 40625, 0 ) -- Time selection: Set start point
    
    --reaper.Main_OnCommand( 40043, 0 ) -- Transport: Go to end of project
    
    ppq_offset = ppq_set / midi_ppq
    
    endppqpos = (ppqpos + duration)
    
    ---Msg("ppqpos= "..ppqpos)
    --Msg("endppqpos "..endppqpos)
    
    midi_item_end = reaper.TimeMap_QNToTime(((endppqpos*ppq_offset)/ppq_set)+ppq_offset/30)
    
    reaper.SetEditCurPos2(0, midi_item_end, 0, 0)
    
    reaper.Main_OnCommand( 40626, 0 ) -- Time selection: Set end point
    
    --reaper.MB(midi_item_end, "Pause",0)
    
    reaper.Main_OnCommand( 40042, 0 ) -- Transport: Go to start of project
    
    reaper.Main_OnCommand( 40214, 0 ) -- Insert new MIDI item...
    
    reaper.Main_OnCommand( 40042, 0 ) -- Transport: Go to start of project
    
    reaper.MoveEditCursor( cur_pos, 0 )
    
    
    
    -- reaper.Main_OnCommand( reaper.NamedCommandLookup( "_SWSMARKERLIST10" ), -1) -- SWS: Delete all regions
  
    main3()
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\bb_get_midi_track_name.ahk"]],0) 
        
    
    set_track_and_item_name()
  
    reaper.Undo_EndBlock("Import Biab Midi Track Data", -1) -- End of the undo block. Leave it at the bottom of your main function.
    
      reaper.SetEditCurPos( 0, 0, 0 )
      
      reaper.Main_OnCommand(40042,0) -- Transport: Go to start of project
      
      reaper.Main_OnCommand(40635,0) -- Time selection: Remove (unselect) time selection
      
      reaper.UpdateArrange()
    
      reaper.PreventUIRefresh(-1)
    --::finish::
    reaper.UpdateArrange()
  
    reaper.PreventUIRefresh(-1)
    
  
  end
  
  --start_pos, end_pos = reaper.GetSet_LoopTimeRange2(0, false, false, 0, 0, false)
  
  reaper.MoveEditCursor( cur_pos, 0 )
  reaper.Main_OnCommand(40630,0) -- Go to start of time selection
  
end

function set_riff_time_sel_btn_click()

  pos_start, pos_end = reaper.GetSet_LoopTimeRange2( 0, 0, 0, "", "", 0 )
  
  if pos_start == pos_end then
    reaper.MB("Select Time Selection", "Attention", 0)
    no_loop = 1
    goto set_riff_time_sel_btn_click_end
  end  
  no_loop = 0
  --Msg(pos_start.." "..pos_end)
  
   retval, start_measures, cml, start_fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, pos_start )
   
   retval, end_measures, cml, end_fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, pos_end )
   --Msg(cml)
   beats_start = start_fullbeats - (start_measures * cml ) + 1
   
   beats_end = end_fullbeats - (end_measures * cml ) + 1
   
   beats_end = math.floor(beats_end) 
   --Msg("start "..beats_start)
   beats_start = math.floor(beats_start)
   
   start_measures = start_measures -1
   
   end_measures = end_measures -1
   
  -- Msg("start "..start_measures.."."..beats_start)
  -- Msg("end "..end_measures.."."..beats_end)
   
   --riff_data = start_pos..","..end_pos..","..RTnumber..","..Style..","..bpm..","..ts..","..Bluesy..","..Simpler..","..DirectInput..","..Held
   bpm =  reaper.Master_GetTempo()
   bpm = math.floor(bpm)
   Style = "BLANK.STY"
   TB = GUI.Val("my_mnu")
   timebase = {"Normal-Time","Half-Time","Double-Time","Triple-Time"}
   RTnumber = "1515"
   --Msg("TB "..timebase[TB])
   opts = GUI.Val("my_chk")
   Blue,Simp,DI,H = bool_num(opts[1]), bool_num(opts[2]), bool_num(opts[3]), bool_num(opts[4])
   --Msg("H "..H)
   reaper.CF_SetClipboard( start_measures.."."..beats_start..","..end_measures.."."..beats_end..","..RTnumber..","..Style..","..bpm..","..cml..","..timebase[TB]..","..Blue..","..Simp..","..DI..","..H )
 
   reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Set F8 to Reaper time selection.ahk"]],0) 
   
::set_riff_time_sel_btn_click_end::
end

function import_sec_cus_btn_click()
  pos_start, pos_end = reaper.GetSet_LoopTimeRange2( 0, 0, 0, "", "", 0 )
  import_riff = 1
  reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items
  gen_cur_track_sec_btn_click()

end

function import_sec_cus_new_trk_btn_click()
  reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items
  reaper.Main_OnCommand( 40001, 0 ) -- Track: Insert new track
  pos_start, pos_end = reaper.GetSet_LoopTimeRange2( 0, 0, 0, "", "", 0 )
  import_riff = 1
  gen_cur_track_sec_btn_click()


end

function import_sel_trk_btn_click()

  reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items
  reaper.Main_OnCommand( 40001, 0 ) -- Track: Insert new track
  import_riff = 1
  gen_cur_track_sec_btn_click()


end

function gen_cur_track_sec_btn_click()

  reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items
  
  if import_riff == 1 then goto ImportRiff end
  
  get_riff_section()
  
  if no_loop == 1 then
  
    goto gen_cur_track_sec_end
  end
  
  
  
  ::ImportRiff::
  import_riff = 0
  
  cur_pos2 = reaper.GetCursorPosition()
  --wait(10)
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\bb_track_info.ahk"]],0)
  --reaper.MB("Wait for temp.txt","wait",0)
  --wait(3)
  
  
  sep = "\t" -- default sep
  popup = true
  
  --[[
  col_pos = 3 -- Position column index in the CSV
  col_pos_end = 4 -- Length column index in the CS
  col_len = 5 -- Length column index in the CSV
  col_name = 2 -- Name column index in the CSV
  col_color = 6
  --]]
  col_id = 1
  col_data = 3
  col_source = 4
  col_bpm = 5
  col_timesig = 8
  col_source_start = 9 -- - (beats * 1200) 
  col_source_offset = 12
  col_source_end = 13 -- / 1200 (/col_timesig)
  col_source_dest = 18
  col_bar_dest = 20 -- +3 including count-in
  col_transpose = 23
  col_is_drums = 29
  
  
  retval_ppq, ppq_set = reaper.BR_Win32_GetPrivateProfileString("reaper", "miditicksperbeat", "", inipath) 
  --retval, filetxt = reaper.GetUserFileNameForRead("", "Import RT RD Sections text", "txt")
  --Msg("Run bb_track_info.ahk")
  --reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[ & "AutoHotkey.exe" "scripts/bb_track_info.ahk"]],-2)
  
  --wait(3)
  letter = GUI.Val("my_mnu3")
  drive = {"C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"}
  filetxt = drive[letter]..[[:\bb\Data\temp.txt]]
  if filetxt then
  
    --reaper.Main_OnCommand( 40289, 0 ) -- Item: Unselect (clear selection of) all items
    
    --reaper.Main_OnCommand( 40001, 0 ) -- Track: Insert new track
    
    
    reaper.PreventUIRefresh(1)
  
    reaper.Undo_BeginBlock() -- Begining of the undo block. Leave it at the top of your main function.
    
    reaper.ClearConsole()
  
    read_lines(filetxt)
    
    --reaper.SetEditCurPos( pos_start, 0, 0 )
    
  
    
    -- reaper.Main_OnCommand( reaper.NamedCommandLookup( "_SWSMARKERLIST10" ), -1) -- SWS: Delete all regions
  
    main2()
  
    reaper.Undo_EndBlock("Import RT RD Sections", -1) -- End of the undo block. Leave it at the bottom of your main function.
    --Msg("pos_start "..pos_start)
    --reaper.SetEditCurPos( pos_start, 0, 0 )
    --reaper.MoveEditCursor( cur_pos2, 0 )
    
    reaper.Main_OnCommand(40042,0)
    
    reaper.UpdateArrange()
  
    reaper.PreventUIRefresh(-1)
  
  end
  --reaper.MoveEditCursor( cur_pos2, 0 )
  --reaper.Main_OnCommand(40848, 0) -- View: Restore previous zoom/scroll position
  
::gen_cur_track_sec_end::
no_loop = 0

pos_start, pos_end = reaper.GetSet_LoopTimeRange2(0, false, false, 0, 0, false)
reaper.MoveEditCursor( pos_start, 0 )
 
end

function get_region()
  time = reaper.GetCursorPosition()
  markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, time )
  retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
end

function btn_click_verse_post_fill()
  get_region()
  reaper.SetProjectMarker4( 0, markrgnindexnumber, 1, pos, rgnend, name, reaper.ColorToNative(17, 39, 174)|0x1000000, 0)
  reaper.SetEditCurPos2( 0, rgnend, 0, 0 )
end

function btn_click_chorus_post_fill()
  get_region()
  reaper.SetProjectMarker4( 0, markrgnindexnumber, 1, pos, rgnend, name, reaper.ColorToNative(11, 116, 39)|0x1000000, 0)
  reaper.SetEditCurPos2( 0, rgnend, 0, 0 )
end

function btn_click_normal_region()
  get_region()
  reaper.SetProjectMarker4( 0, markrgnindexnumber, 1, pos, rgnend, name, reaper.ColorToNative(192, 192, 192)|0x1000000, 0)
  reaper.SetEditCurPos2( 0, rgnend, 0, 0 )
end

function btn_click_edit_chord()
  reaper.Main_OnCommand( 40616, 0 ) -- Markers: Edit region near cursor
  
end

function btn_insert_region()

  retval_measures, insert_measures_retvals_csv = reaper.GetUserInputs( "Insert Measures", 1, "Number of Measures", "" )
  
  
  time = reaper.GetCursorPosition()
  
  reaper.Main_OnCommand(40625,0) -- Time selection: Set start point
  
  if retval_measures == true then
    for i = 0, insert_measures_retvals_csv - 1 do
      reaper.Main_OnCommand(41042,0) -- Move edit cursor forward one measure
    end
  
    reaper.Main_OnCommand(40626,0) -- Time selection: Set end point
  
    reaper.Main_OnCommand(40174,0) -- Markers: Insert region from time selection
  
    reaper.Main_OnCommand(40635,0)  -- Time selection: Remove time selection 
  
  
    ----Snap all regions to grid
  
              
    reaper.SetEditCurPos(time, 1, 0)
    
    reaper.Main_OnCommand(40616, 0)  -- Markers: Edit region near cursor
  
  end
  
  reaper.Main_OnCommand(40754, 0) -- Enable snap
  
  region_count , num_markersOut, num_regionsOut = reaper.CountProjectMarkers(0)
  
  for i=0, region_count -1 do
  
    --EnumProjectMarkers(i, is_region, region_start, region_end, #name, region_id)
    retval, isrgnOut, posOut, rgnendOut, region_name, markrgnindexnumberOut, colorOut = reaper.EnumProjectMarkers3(0, i)      
  
    region_snapped_start =  reaper.SnapToGrid(0, posOut)
    region_snapped_end =  reaper.SnapToGrid(0, rgnendOut) 
   
    reaper.SetProjectMarker3( 0, markrgnindexnumberOut, isrgnOut, region_snapped_start, region_snapped_end, region_name , colorOut )
   
  end
  
end

local function btn_split_region()
    
    reaper.Undo_BeginBlock() 
    
    retval, num_markers, num_regionsOut = reaper.CountProjectMarkers(0)
    
    desired_region_id = num_regionsOut
    
    time = reaper.GetCursorPosition()
    
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion(0, time)
    
    retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3(0, regionidx)
    
    if time == pos then goto finish end
    
    if time < rgnend then
    
    reaper.SetProjectMarker3( 0, markrgnindexnumber, 1, pos, time, name, color )
    
    reaper.AddProjectMarker2(0, 1, time, rgnend, name, desired_region_id, color) 

    end
    ::finish::
    reaper.Undo_EndBlock("Split Region", -1) 
end 

local function btn_chords_mid_item()

  reaper.Undo_BeginBlock2(0)
  --reaper.Main_OnCommand(40421,0) --Item: Select all items in track 40421
  reaper.Main_OnCommand(40153,0) --Item: Open in built-in MIDI editor (set default behavior in preferences) 40153
  hwnd = reaper.MIDIEditor_GetActive()
  --reaper.MIDIEditor_OnCommand( hwnd, 40954 ) --Mode: Notation3
  reaper.MIDIEditor_OnCommand( hwnd, 41281 ) --Notation: Identify chords on editor grid
  
  reaper.SN_FocusMIDIEditor()
  reaper.MIDIEditor_OnCommand(40954,0) --Mode: Notation3
  reaper.MIDIEditor_OnCommand(41281,0) --Notation: Identify chords on editor grid
  
    
  take = reaper.MIDIEditor_GetTake(reaper.MIDIEditor_GetActive())
  reaper.MIDI_Sort(take)
  MIDIOK, MIDI = reaper.MIDI_GetAllEvts(take, "")
  tChords = {}
  stringPos, ticks = 1, 0
  while stringPos < MIDI:len() do
      offset, flags, msg, stringPos = string.unpack("i4Bs4", MIDI, stringPos)
      ticks = ticks + offset
      if msg:byte(1) == 0xFF then
          chord = msg:match("text (.+)")
          if chord then
              tChords[#tChords+1] = {chord = chord, ticks = ticks}
          end
      end
  end
  tChords[#tChords+1] = {ticks = ticks}
  for i = 1, #tChords do
      tChords[i].time = reaper.MIDI_GetProjTimeFromPPQPos(take, tChords[i].ticks)
  end
  for i = 1, #tChords-1 do
      -- Set Region Color RGB > reaper.ColorToNative(55,118,235)
      if tChords[i].chord ~= last_chord then
         reaper.AddProjectMarker2(0, false, tChords[i].time, tChords[i+1].time, tChords[i].chord, 1, reaper.ColorToNative(192,192,192)|0x1000000) 
         last_chord = tChords[i].chord
      end
       
  end
  
  commandID2 = reaper.NamedCommandLookup("_SWSMARKERLIST13")
  reaper.Main_OnCommand(commandID2, 0) -- SWS: Convert markers to regions
  reaper.Undo_EndBlock2(0, "Chords from midi item", -1)
  reaper.MIDIEditor_OnCommand( hwnd, 2 ) --File: Close window
  
end

local function btn_click_chord_pre()
    edit_pos = reaper.GetCursorPosition()
    
    play = reaper.GetPlayState()
    if play > 0 then
      pos = reaper.GetPlayPosition()
    else
      pos = edit_pos
    end
    
    count_markers_regions, count_markersOut, count_regionsOut = reaper.CountProjectMarkers(0)
    
    i=1
    repeat
      iRetval, bIsrgnOut, iPosOut, iRgnendOut, sNameOut, iMarkrgnindexnumberOut, iColorOur = reaper.EnumProjectMarkers3(0,count_markers_regions-i)
      if iRetval >= 1 then
        if bIsrgnOut == true and iPosOut < pos then
          -- ACTION ON REGIONS HERE
          reaper.SetEditCurPos(iPosOut,true,true) -- moveview and seekplay
          break
        end
        i = i+1
      end
    until iRetval == 0
      
   
end
 
local function btn_click_bar_pre()
    reaper.Main_OnCommand(41043, 0) -- Move edit cursor back one measure
    time = reaper.GetCursorPosition()
    grid_pos = reaper.SnapToGrid(0, time)
    reaper.SetEditCurPos2(0, grid_pos, false, false)
end

local function btn_click_beat_pre()
    reaper.Main_OnCommand(41045, 0) -- Move edit cursor back one beat
    time = reaper.GetCursorPosition()
    grid_pos = reaper.SnapToGrid(0, time)
    reaper.SetEditCurPos2(0, grid_pos, false, false)
end
  
local function btn_click_chord_next()
    edit_pos = reaper.GetCursorPosition()
    
    play = reaper.GetPlayState()
    if play > 0 then
      pos = reaper.GetPlayPosition()
    else
      pos = edit_pos
    end
    
    i=0
    repeat
      iRetval, bIsrgnOut, iPosOut, iRgnendOut, sNameOut, iMarkrgnindexnumberOut, iColorOur = reaper.EnumProjectMarkers3(0,i)
      if iRetval >= 1 then
        if bIsrgnOut == true and iPosOut > pos then
          -- ACTION ON REGIONS HERE
          reaper.SetEditCurPos(iPosOut,true,true) -- moveview and seekplay
          break
        end
        i = i+1
      end
    until iRetval == 0
      
    
end

local function btn_click_bar_next()
    --reaper.Main_OnCommand(41040, 0) -- Move edit cursor to start of next measure
    reaper.Main_OnCommand(41042, 0) -- Move edit cursor forward one measure
    time = reaper.GetCursorPosition()
    grid_pos = reaper.SnapToGrid(0, time)
    reaper.SetEditCurPos2(0, grid_pos, false, false)    
end

local function btn_click_beat_next()
    reaper.Main_OnCommand(41044, 0) -- Move edit cursor forward one beat
    time = reaper.GetCursorPosition()
    grid_pos = reaper.SnapToGrid(0, time)
    reaper.SetEditCurPos2(0, grid_pos, false, false)    
end

function btn_save_project()

  reaper.Main_OnCommand(40026, 0) -- File: Save project

end

function btn_set_item_name()

  sel_item = reaper.GetSelectedMediaItem( 0, 0 )
  if sel_item then  
    take = reaper.GetMediaItemTake( sel_item, 0 )
    source = reaper.GetMediaItemTake_Source( take )
    item_start = reaper.GetMediaItemTakeInfo_Value( take, "D_STARTOFFS" )
    
    reaper.SetTakeMarker( take, 0, sel_item_name, item_start, reaper.ColorToNative(80, 237, 123 )|0x1000000)
  end
end

function btn_del_item_name()

  sel_item = reaper.GetSelectedMediaItem( 0, 0 )
  if sel_item then  
    take = reaper.GetMediaItemTake( sel_item, 0 )
    source = reaper.GetMediaItemTake_Source( take )
    item_start = reaper.GetMediaItemTakeInfo_Value( take, "D_STARTOFFS" )
    
    reaper.Main_OnCommand( 40318, 0) -- Item navigation: Move cursor left to edge of item
    reaper.Main_OnCommand( 42386, 0 ) -- Item: Delete take marker at cursor
  end
end

function rt_list_btn_click()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Create RealTrack List.ahk"]],0) 
  

end

function rd_list_btn_click()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Create RealDrum List.ahk"]],0) 
  

end

function batch_btn_click()

  reaper.Main_OnCommand(41076,0) -- File: Batch file converter

end

function reapeaks_folder_btn_click()

  retval, reapeaks_folder = reaper.JS_Dialog_BrowseForFolder( "Browse for Folder that needs File Type reapeaks", "" )
  
  GUI.New("lbl_reapeaks_folder", "Label", 6, 20, 80, reapeaks_folder,true ,3,"white", "wnd_bg")
  
  --GUI.elms.create_reapeaks_btn:ondelete() 
  GUI.New("create_reapeaks_btn",   "Button",     6, 220, 28, 120, 20, "Create ReaPeaks ", create_reapeaks_btn_click)
  GUI.elms.create_reapeaks_btn.col_txt = "btn_txt1"
  GUI.elms.create_reapeaks_btn.col_fill = "chorus_post_fill"
  GUI.elms.create_reapeaks_btn:init()
end

function create_reapeaks_btn_click()

  RTextension = GUI.Val("my_mnu2")
  
  file_type = {".wma",".wav",".aiff",".flac",".mp3",".wv",".ogg"}
  
  ext = file_type[tonumber(RTextension)]
  
  --ext =".wav"
  
  path = reapeaks_folder
  
  --path = "C:\\bb\\BBPlugin\\SavedTracks"
  
  A,B=GetAllResourcePathFiles(path,ext)
  
  rea_go =reaper.MB("There are "..tablelength(mediafiles).." Files this may take some time", "Attention",1)
  
  if rea_go == 2 then goto create_reapeaks end
  
 -- Msg("mediafiles "..tablelength(mediafiles))
  
  media_count = tablelength(mediafiles)
  for i = 1, media_count do
    if  reaper.file_exists( mediafiles[i] ) then
      --Msg("Create reapeak "..mediafiles[i])
      src = reaper.PCM_Source_CreateFromFile( mediafiles[i] )
     
      reaper.PCM_Source_BuildPeaks( src, 0 )
     
      repeat
        per =  reaper.PCM_Source_BuildPeaks( src, 1 )
      until( per == 0 )
      reaper.PCM_Source_BuildPeaks( src, 2 )
      --Msg("Done "..mediafiles[i])
    end
  
  end
  
  ::create_reapeaks::
  
  GUI.elms.create_reapeaks_btn:ondelete() 
  GUI.New("create_reapeaks_btn",   "Button",     5, 220, 28, 120, 20, "Create ReaPeaks ", create)
  --GUI.elms.create_reapeaks_btn.col_txt = "gray"
  --GUI.elms.create_reapeaks_btn.col_fill = "chorus_post_fill"
  GUI.elms.create_reapeaks_btn:init()
  
  GUI.elms.lbl_reapeaks_folder:ondelete()
  GUI.New("lbl_reapeaks_folder", "Label", 5, 20, 80, "",true ,3,"white", "wnd_bg")
  GUI.elms.lbl_reapeaks_folder:init()
  
  reapeaks_folder = ""
  
end

function GetAllResourcePathFiles(path,ext)
  reaper.EnumerateFiles(path, -1) -- refresh the cache,
  Msg("Path "..path)                                                    -- after this, the filelist will be updated
  reaper.EnumerateSubdirectories( path, -1 )               -- to the most recent one
  mediafiles = {}
  
  index=0
  filelist={}
  while reaper.EnumerateFiles(path, index)~=nil do
    filelist[index+1]=reaper.EnumerateFiles(path, index)
    
    --Msg(folderlist[subdirindex+1].."\\"..filelist[index+1])
    --Msg(folderlist[subdirindex+1])
    --Msg(filelist[index+1])
    filext = filelist[index+1]:match("(%.%w+)$")
    --Msg(filext)
    
    if tostring(filext) == ext then
      --Msg(filext)
      --Msg(path.."\\"..folderlist[subdirindex+1].."\\"..filelist[index+1])
      --Msg(path.."\\"..folderlist[subdirindex+1].."\\"..filelist[index+1])
      table.insert(mediafiles, path.."\\"..filelist[index+1])
      
    end  
    index=index+1
    
  end
  --Msg("index "..index)
  local subdirindex=0
  local folderlist={}
  --folderlist[1]=reaper.EnumerateSubdirectories(path, 1)
  while reaper.EnumerateSubdirectories(path, subdirindex)~=nil do
  folderlist[subdirindex+1]=reaper.EnumerateSubdirectories(path, subdirindex)
  --Msg(path.."\\"..folderlist[subdirindex+1])
  -- get all current files in resourcepath
    --Msg("While Subs")
    local index=0
    --local filelist={}
    
    --while reaper.EnumerateFiles(path.."\\"..folderlist[subdirindex+1], index)~=nil do
    while reaper.EnumerateFiles(path.."\\"..folderlist[subdirindex+1], index)~=nil do
      filelist[index+1]=reaper.EnumerateFiles(path.."\\"..folderlist[subdirindex+1], index)
      --Msg("While Files")
      --Msg(folderlist[subdirindex+1].."\\"..filelist[index+1])
      --Msg(folderlist[subdirindex+1])
      --Msg(filelist[index+1])
      filext = filelist[index+1]:match("(%.%w+)$")
      --Msg(filext)
      
      if tostring(filext) == ext then
        --Msg(filext)
        --Msg(path.."\\"..folderlist[subdirindex+1].."\\"..filelist[index+1])
        --Msg(path.."\\"..folderlist[subdirindex+1].."\\"..filelist[index+1])
        table.insert(mediafiles, path.."\\"..folderlist[subdirindex+1].."\\"..filelist[index+1])
        
      end  
      index=index+1
    end
    subdirindex=subdirindex+1
  end
  return index, filelist, subdirindex, folderlist, mediafiles 
end

local function fade_lbl()
   
   -- Fade out the label
    if GUI.elms.my_lbl.z == 3 then
        GUI.elms.my_lbl:fade(1, 3, 6)
        
    -- Bring it back
    else
        GUI.elms.my_lbl:fade(1, 3, 6, -3)
    end
    
end


function btn_click()
  
  
  opts = GUI.Val("my_chk")
  Blue, Simp, DI, H = bool_num(opts[1]), bool_num(opts[2]), bool_num(opts[3]), bool_num(opts[4])
  --Msg("Checklist ".."Bluesy ".. Blue.." Simpler "..Simp.." DirectInput "..DI.." Held "..H)
  
  letter = GUI.Val("my_mnu3")
  --Msg("letter "..letter)
  drive = {"C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"}
  --Msg("Drive "..drive[letter])
  
  menu_val = GUI.Val("my_mnu")
    -- Open the Window element
  GUI.elms.wnd_test:open()
  
end


function timebase_on()

  if TB > 1 then 
    start_on_off = "*"
  else
    start_on_off = " "
  end  

  GUI.elms.lbl_my_mnu:ondelete() 
  GUI.New("lbl_my_mnu", "Label", 3, 200, 30, start_on_off,true , 1 ,"play_anywhere", "wnd_bg" )
  GUI.elms.lbl_my_mnu:init()

end

function getRandomInstrument(sel_bb_track,sel_bb_track_instrument,sel_bb_track_type)
  
  letter = GUI.Val("my_mnu3")
  drive = {"C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"}
  RTtxt = drive[letter]..[[:\bb\Data\RealTracksList.txt]]
  
  check_file =  reaper.file_exists( RTtxt )
  
  if not check_file then
    
    reaper.MB("No RT List, In RT Picker select Copy List", "Notice",0)
    RT_number = "000"
    goto random_linesRT_end
    
  end
  
  RTfeel_val = GUI.Val("my_mnu6")
  RTfeel_choice = {"Ev8","Ev16","Sw8","Sw16"}
  RTfeel_set = RTfeel_choice[RTfeel_val]
  
  RTtimeSig_val = GUI.Val("my_mnu7")
  RTtimeSig_choice = {"4","3"}
  RTtimeSig_set = tonumber(RTtimeSig_choice[RTtimeSig_val])
  
  RTtempo_val = GUI.Val("my_mnu75")
  RTtempo_choice = {"120","40","50","55","60","65","70","75","80","85","90","95","100","110","120","130","140","150","165","170","180","190","200","220","260"}
  RTtempo_set = tonumber(RTtempo_choice[RTtempo_val])
  
  
  -- Get number of lines
  RTtxt_line_count = 0
  for line in io.lines(RTtxt) do
     RTtxt_line_count = RTtxt_line_count + 1
  end
  
  RTtxt_loop_count = 0
  
  read_linesRT(RTtxt)
  
  --LOOP START
  RTrandom_loop_count = 0
  
  ::start_RTrandom_loop::
  
  RTtxt_random_line = math.random(2,RTtxt_line_count)
  --Msg("Line "..RTtxt_random_line)
  
  folder = RTtxt:match[[^@?(.*[\/])[^\/]-$]]
  --Msg("Instrument name "..instrument_name)
  
  for i, line in ipairs( linesRT ) do
    if i == RTtxt_random_line then
  
      RT_name = line[1]
      local RT_class = line[2]
      local RT_type = line[3]
      --local RT_feel = line[4]
      local RT_tempo = line[5]
      RT_number = line[7]
      
      --Msg(RT_class.." "..RT_type.." "..RT_tempo)
      if RT_type == "Backgound" then RT_type = "Rhythm" end
      
      if string.match(RT_name,"Waltz") then
        RTtimeSig = 3
      else 
        RTtimeSig = 4
      end
      
      if string.match(RT_name,"Ev ") then
        RT_feel = "Ev8"
      elseif string.match(RT_name,"Ev16") then  
        RT_feel = "Ev16"
      elseif string.match(RT_name,"Sw ") then  
        RT_feel = "Sw8"  
      elseif string.match(RT_name,"Sw16") then  
        RT_feel = "Sw16"
      end  
      
      
      
      --Msg("Set Tempo "..RTtempo_set)
      --Msg("RT_tempo "..RT_tempo)
      
      if tonumber(RT_tempo) > RTtempo_set -16 and tonumber(RT_tempo) < RTtempo_set +16 then
        RTtempo_match = 1
      else
        RTtempo_match = 0
      end  
      --if RT_name then
        --Msg("RTname "..RT_name)
      --end
     -- Msg(instrument_name)
      --if i == 937 then
      
        --Msg("RT_name "..RT_name)
      --end
      if sel_bb_track_instrument == RT_class and RT_type == sel_bb_track_type and RTfeel_set == RT_feel and RTtimeSig_set == RTtimeSig and RTtempo_match == 1 then
        --Msg("Found RT# "..RT_number..":"..RT_name)
        --Msg("RTname "..RT_name)
        --Msg(RT_type.." "..sel_bb_track_type)
        goto random_linesRT_send
        --return RT_number
        --break
      end
    end
  end 
  
  
  
  RTrandom_loop_count = RTrandom_loop_count +1
  
  if RTrandom_loop_count > 10000 then
    --Msg("No Match")
    RT_match = ""
    instrument_no_match()
    goto random_linesRT_end
  end  
  
  goto start_RTrandom_loop
  
  
::random_linesRT_send::
  --Msg("sel_bb_track "..sel_bb_track)
  --Msg("Found RT# "..RT_number)
  instrument_match()
  RT_match = RT_number..":"..RT_name
 -- Msg("RT_match "..RT_match)
  reaper.CF_SetClipboard( sel_bb_track..","..RT_number )
    
   
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RT3 picker.ahk"]],0)
  
  
::random_linesRT_end::


end

function getRandomDrum(BBtrack)

    letter = GUI.Val("my_mnu3")
    drive = {"C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"}
    RDtxt = drive[letter]..[[:\bb\Data\RealDrumsList.txt]]
    
    check_file =  reaper.file_exists( RDtxt )
    
    if not check_file then
      
      reaper.MB("No RT List, In RT Picker select Copy List", "Notice",0)
      --RD_number = "000"
      goto random_linesRD_end
      
    end
    
    RTfeel_val = GUI.Val("my_mnu6")
    RTfeel_choice = {"Ev8","Ev16","Sw8","Sw16"}
    RDfeel_set = RTfeel_choice[RTfeel_val]
    
    RTtimeSig_val = GUI.Val("my_mnu7")
    RTtimeSig_choice = {"4","3"}
    RDtimeSig_set = tonumber(RTtimeSig_choice[RTtimeSig_val])
    
    RTtempo_val = GUI.Val("my_mnu75")
    RTtempo_choice = {"120","40","50","55","60","65","70","75","80","85","90","95","100","110","120","130","140","150","165","170","180","190","200","220","260"}
    RDtempo_set = tonumber(RTtempo_choice[RTtempo_val])
    
    
    -- Get number of lines
    RDtxt_line_count = 0
    for line in io.lines(RDtxt) do
       RDtxt_line_count = RDtxt_line_count + 1
    end
    
    RDtxt_loop_count = 0
    
    read_linesRD(RDtxt)
    
    --LOOP START
    RDrandom_loop_count = 0
    
    ::start_RDrandom_loop::
    
    RDtxt_random_line = math.random(2,RDtxt_line_count)
    --Msg("Line "..RDtxt_random_line)
    
    folder = RDtxt:match[[^@?(.*[\/])[^\/]-$]]
    --Msg("Instrument name "..instrument_name)
    
    for i, line in ipairs( linesRD ) do
      if i == RDtxt_random_line then
    
        RD_name = line[2]
        --local RD_class = line[2]
        --local RD_type = line[3]
        local RD_feel = line[7]
        local RD_feel_beat = line[8]
        local RD_tempo_lo = line[9]
        local RD_tempo_hi = line[10]
       -- RD_number = line[7]
        --Msg(RT_class.." "..RT_type.." "..RT_tempo)
        --if RT_type == "Backgound" then RT_type = "Rhythm" end
        
        if string.match(RD_name,"Waltz") then
          RDtimeSig = 3
        else 
          RDtimeSig = 4
        end
        --[[
        if string.match(RT_name,"Ev ") then
          RT_feel = "Ev8"
        elseif string.match(RT_name,"Ev16") then  
          RT_feel = "Ev16"
        elseif string.match(RT_name,"Sw ") then  
          RT_feel = "Sw8"  
        elseif string.match(RT_name,"Sw16") then  
          RT_feel = "Sw16"
        end  
        --]]
        
        --Msg(RD_name.." "..RD_feel.." "..RDtimeSig.."/4 "..RD_tempo_lo.." "..RD_tempo_hi)
        
        --Msg("RD_tempo_lo "..RD_tempo_lo)
        --Msg("RD_tempo_hi "..RD_tempo_hi)
        
        
        --Msg("Set Tempo "..RTtempo_set)
        --Msg("RT_tempo "..RT_tempo)
        
        if tonumber(RDtempo_set) > tonumber(RD_tempo_lo) and  tonumber(RDtempo_set) < tonumber(RD_tempo_hi) then
          RDtempo_match = 1
        else
          RDtempo_match = 0
        end  
        --if RT_name then
          --Msg("RTname "..RT_name)
        --end
       -- Msg(instrument_name)
        --if i == 937 then
        
          --Msg("RT_name "..RT_name)
        --end
        
        --if RDfeel_set == RD_feel..RD_feel_beat then Msg("Feel match") end
        --if RDtimeSig_set == RDtimeSig then Msg("Tempo match") end
        --if RDtimeSig_set == RDtimeSig then Msg("TS match") end 
        --Msg("-------------------back to 10000")
        
        if RDfeel_set == RD_feel..RD_feel_beat and tonumber(RDtimeSig_set) == RDtimeSig and RDtempo_match == 1 then
          
          --Msg("RDname "..RD_name)
          if RT_name ~= "Blank" then
            goto random_linesRD_send
          end  
          --return RT_number
          --break
        end
      end
    end 
    
    
    
    RDrandom_loop_count = RDrandom_loop_count +1
    --Msg("Loop "..RDrandom_loop_count)
    if RDrandom_loop_count > 10000 then
      --Msg("No Match")
      instrument_no_match()
      goto random_linesRD_end
    end  
    
    goto start_RDrandom_loop
    
    
  ::random_linesRD_send::
    --Msg("sel_bb_track "..sel_bb_track)
    --Msg("Found "..RD_name)
    instrument_match()
    RT_match = RD_name
    
    if sec_drums ==1 then
    
      reaper.CF_SetClipboard( RD_name..","..BBtrack )
            
      reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RD picker secondary.ahk"]],0)
          
      sec_drums = 0
    else
      reaper.CF_SetClipboard( RD_name )
      
      reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RD picker.ahk"]],0)
    end
    
  ::random_linesRD_end::
  
  
end
  
function btn_click_blank_style()

  --BLANK.STY
  --BLANKE16.STY
  --BLANKSW.STY
  --BLANKS16.STY
  --BLANK34.STY
  --BLANK3SW.STY
  
  style_feel_val = GUI.Val("my_mnu6")
  style_ts_val = GUI.Val("my_mnu7")
  style_bpm_val = GUI.Val("my_mnu75")
  
  style_feel_choice = {"Ev8","Ev16","Sw8","Sw16"}
  style_feel = style_feel_choice[style_feel_val]
  
  style_bpm_choice = {"120","40","50","55","60","65","70","75","80","85","90","95","100","110","120","130","140","150","165","170","180","190","200","220","260"}
  style_bpm = tonumber(style_bpm_choice[style_bpm_val])
  

  
  
  
  if style_feel == "Ev8" and style_ts_val == 1 then
    set_style = "BLANK.STY"
    --Msg("BLANK.STY")
  end
  
  if style_feel == "Ev16" and style_ts_val == 1 then
    set_style = "BLANKE16.STY"
    --Msg("BLANKE16.STY")
  end
  
  if style_feel == "Sw8" and style_ts_val == 1 then
    set_style = "BLANKSW.STY"
    --Msg("BLANKSW.STY")
  end
  
  if style_feel == "Sw16" and style_ts_val == 1 then
    set_style = "BLANKS16.STY"
    --Msg("BLANKS16.STY")
  end
  
  if (style_feel == "Ev8") or( style_feel == "Ev16") then
    if style_ts_val == 2 then
      set_style = "BLANK34.STY"
      --Msg("BLANK34.STY")
    end  
  end
  
  if (style_feel == "Sw8" or style_feel == "Sw16") then
    if  style_ts_val == 2 then
      set_style = "BLANK3SW.STY"
     -- Msg("BLANK3SW.STY")
    end
  end  
  
  
  --Msg(set_style..","..style_bpm..","..style_ts_val)
  
  reaper.CF_SetClipboard( set_style..","..style_bpm )
    
   
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Set blank style.ahk"]],0)
  

end


function btn_click_bb_min_max()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\BB min max.ahk"]],0)
    
end

function btn_click_bbmix_min()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\BBmix min.ahk"]],0)
    
end

function btn_click_bbmix_max()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\BBmix max.ahk"]],0)
    
end

function btn_click_bb_play_start()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\BB play start.ahk"]],0)
  
end

function btn_click_bb_play()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\BB play.ahk"]],0)
  
end

function btn_click_gen()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\BB gen.ahk"]],0)
  
end

function btn_click_track1_pick()
  BBtrack = 1
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RT custom pick.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_1:ondelete()
  GUI.New("lbl_instr_match_1", "Label", 5, 60+x2, 215+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_1:init()
end

function btn_click_track2_pick()
  BBtrack = 2
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RT custom pick.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_2:ondelete()
  GUI.New("lbl_instr_match_2", "Label", 5, 60+x2, 270+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_2:init()
end

function btn_click_track3_pick()
  BBtrack = 3
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RD custom pick.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_3:ondelete()
  GUI.New("lbl_instr_match_3", "Label", 5, 60+x2, 325+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_3:init()
end

function btn_click_track4_pick()
  BBtrack = 4
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RT custom pick.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_4:ondelete()
  GUI.New("lbl_instr_match_4", "Label", 5, 60+x2, 380+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_4:init()
end

function btn_click_track5_pick()
  BBtrack = 5
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RT custom pick.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_5:ondelete()
  GUI.New("lbl_instr_match_5", "Label", 5, 60+x2, 435+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_5:init()
end

function btn_click_track6_pick()
  BBtrack = 6
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RT custom pick.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_6:ondelete()
  GUI.New("lbl_instr_match_6", "Label", 5, 60+x2, 490+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_6:init()
end

function btn_click_track7_pick()
  BBtrack = 7
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RT custom pick.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_7:ondelete()
  GUI.New("lbl_instr_match_7", "Label", 5, 60+x2, 545+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_7:init()
end

function btn_click_util01_pick()
  
  reaper.CF_SetClipboard( BBtrack )
  if GUI.Val("my_mnu17b") == 3 then
    BBtrack = 16--TMixerPanel16del_itme_name.. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RD custom pick secondary.ahk"]],0)
  else
    BBtrack = 9
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RT custom pick.ahk"]],0)
  end
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  track_name = track_name:gsub ("RealDrums=", "")
  GUI.elms.lbl_instr_match_util01:ondelete()
  GUI.New("lbl_instr_match_util01", "Label", 5, 60+x2, 620+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_util01:init()  
end

function btn_click_util02_pick()
  
  reaper.CF_SetClipboard( BBtrack )
  if GUI.Val("my_mnu18b") == 3 then
    BBtrack = 15 --TMixerPanel15
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RD custom pick secondary.ahk"]],0)
  else
    BBtrack = 10
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\RT custom pick.ahk"]],0)
  end
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  track_name = track_name:gsub ("RealDrums=", "")
  GUI.elms.lbl_instr_match_util02:ondelete()
  GUI.New("lbl_instr_match_util02", "Label", 5, 60+x2, 675+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_util02:init()  
end

function btn_click_track1_random()

  sel_bb_track = 1
  
  track1_RS = GUI.Val("my_mnu10b")
  
  if track1_RS == 1 then sel_bb_track_type = "Rhythm" end
  
  if track1_RS == 2 then sel_bb_track_type = "Soloist" end
  
  track1_val = GUI.Val("my_mnu10")
  
  sel_bb_track_instrument = bass_instruments[track1_val]
  
  if track1_val == 1 then
    reaper.MB("Choose Instrument","Notice",0)
    goto track1_end
  end
  
  getRandomInstrument(sel_bb_track,sel_bb_track_instrument,sel_bb_track_type)
  --Msg("RT_match1 "..RT_match)
  GUI.elms.lbl_instr_match_1:ondelete()
  GUI.New("lbl_instr_match_1", "Label", 5, 60+x2, 215+y2, RT_match,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_1:init()
  
  ::track1_end::
end

function btn_click_track2_random()

  sel_bb_track = 2
  
  track2_RS = GUI.Val("my_mnu11b")
  
  if track2_RS == 1 then sel_bb_track_type = "Rhythm" end
  
  if track2_RS == 2 then sel_bb_track_type = "Soloist" end
  
  track2_val = GUI.Val("my_mnu11")
  
  
  sel_bb_track_instrument = guitar_instruments[track2_val]
  
  if track2_val == 1 then
    reaper.MB("Choose Instrument","Notice",0)
    goto track2_end
  end
  
  getRandomInstrument(sel_bb_track,sel_bb_track_instrument,sel_bb_track_type)
  GUI.elms.lbl_instr_match_2:ondelete()
  GUI.New("lbl_instr_match_2", "Label", 5, 60+x2, 270+y2, RT_match,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_2:init()
  
  ::track2_end::
end


function btn_click_track3_random()

--DRUMS
  sel_bb_track = 3
  
  track3_RS = GUI.Val("my_mnu12b")
  
  if track3_RS == 1 then sel_bb_track_type = "Rhythm" end
  
  if track3_RS == 2 then sel_bb_track_type = "Soloist" end
  
  track3_val = GUI.Val("my_mnu12")
  
  sel_bb_track_instrument = bass_instruments[track1_val]
  
  if track3_val == 1 then
    reaper.MB("Choose Instrument","Notice",0)
    goto track3_end
  end
  
  getRandomDrum()
  --Msg("RT_match1 "..RT_match)
  GUI.elms.lbl_instr_match_3:ondelete()
  GUI.New("lbl_instr_match_3", "Label", 5, 60+x2, 325+y2, RT_match,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_3:init()
  
  ::track3_end::

end


function btn_click_track4_random()

  sel_bb_track = 4
  
  track4_RS = GUI.Val("my_mnu13b")
  
  if track4_RS == 1 then sel_bb_track_type = "Rhythm" end
  
  if track4_RS == 2 then sel_bb_track_type = "Soloist" end
  
  track4_val = GUI.Val("my_mnu13")
  
  
  sel_bb_track_instrument = guitar_instruments[track4_val]
  
  if track4_val == 1 then
    reaper.MB("Choose Instrument","Notice",0)
    goto track4_end
  end
  
  getRandomInstrument(sel_bb_track,sel_bb_track_instrument,sel_bb_track_type)
  GUI.elms.lbl_instr_match_4:ondelete()
  GUI.New("lbl_instr_match_4", "Label", 5, 60+x2, 380+y2, RT_match,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_4:init()
  
  ::track4_end::
end


function btn_click_track5_random()

  sel_bb_track = 5
  
  track5_RS = GUI.Val("my_mnu14b")
  
  if track5_RS == 1 then sel_bb_track_type = "Rhythm" end
  
  if track5_RS == 2 then sel_bb_track_type = "Soloist" end
  
  track5_val = GUI.Val("my_mnu14")
  
  
  sel_bb_track_instrument = piano_instruments[track5_val]
  
  if track5_val == 1 then
    reaper.MB("Choose Instrument","Notice",0)
    goto track5_end
  end
  
  getRandomInstrument(sel_bb_track,sel_bb_track_instrument,sel_bb_track_type)
  GUI.elms.lbl_instr_match_5:ondelete()
  GUI.New("lbl_instr_match_5", "Label", 5, 60+x2, 435+y2, RT_match,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_5:init()
  
  
  ::track5_end::
end


function btn_click_track6_random()

  sel_bb_track = 6
  
  track6_RS = GUI.Val("my_mnu15b")
  
  if track6_RS == 1 then sel_bb_track_type = "Rhythm" end
  
  if track6_RS == 2 then sel_bb_track_type = "Soloist" end
  
  track6_val = GUI.Val("my_mnu15")
  
  
  sel_bb_track_instrument = country_instruments[track6_val]
  
  if track6_val == 1 then
    reaper.MB("Choose Instrument","Notice",0)
    goto track6_end
  end
  
  getRandomInstrument(sel_bb_track,sel_bb_track_instrument,sel_bb_track_type)
  GUI.elms.lbl_instr_match_6:ondelete()
  GUI.New("lbl_instr_match_6", "Label", 5, 60+x2, 490+y2, RT_match,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_6:init()
  
  
  ::track6_end::
end


function btn_click_track7_random()

  sel_bb_track = 7
  
  track7_RS = GUI.Val("my_mnu16b")
  
  if track7_RS == 2 then sel_bb_track_type = "Rhythm" end
  
  if track7_RS == 1 then sel_bb_track_type = "Soloist" end
  
  track7_val = GUI.Val("my_mnu16")
  
  
  sel_bb_track_instrument = solo_instruments[track7_val]
  
  if track7_val == 1 then
    reaper.MB("Choose Instrument","Notice",0)
    goto track7_end
  end
  
  getRandomInstrument(sel_bb_track,sel_bb_track_instrument,sel_bb_track_type)
  GUI.elms.lbl_instr_match_7:ondelete()
  GUI.New("lbl_instr_match_7", "Label", 5, 60+x2, 545+y2, RT_match,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_7:init()
  
  
  ::track7_end::
end



function btn_click_util01_random()

  if GUI.Val("my_mnu17b") == 3 then 
    btn_click_util01_random_drums()
  else
    sel_bb_track = 9
    
    track9_RS = GUI.Val("my_mnu17b")
    
    if track9_RS == 1 then sel_bb_track_type = "Rhythm" end
    
    if track9_RS == 2 then sel_bb_track_type = "Soloist" end
    
    track9_val = GUI.Val("my_mnu17")
    
    
    sel_bb_track_instrument = all_instruments[track9_val]
    
    if track9_val == 1 then
      reaper.MB("Choose Instrument or Drums in Rhythm drop down","Notice",0)
      goto track9_end
    end
    
    getRandomInstrument(sel_bb_track,sel_bb_track_instrument,sel_bb_track_type)
    GUI.elms.lbl_instr_match_util01:ondelete()
    GUI.New("lbl_instr_match_util01", "Label", 5, 60+x2, 620+y2, RT_match,true , 3 ,"chorus_fill", "wnd_bg" )
    GUI.elms.lbl_instr_match_util01:init()
    
    
    ::track9_end::
  end  
end

function btn_click_util01_random_drums()

  BBtrack = 16 --TMixerPanel16
  
  sec_drums = 1
  --track3_RS = GUI.Val("my_mnu12b")
  
  --if track3_RS == 1 then sel_bb_track_type = "Rhythm" end
  
  --if track3_RS == 2 then sel_bb_track_type = "Soloist" end
  
  --track9_val = GUI.Val("my_mnu17")
  
  --sel_bb_track_instrument = bass_instruments[track1_val]
  
  --if track9_val == 1 then
  --  reaper.MB("Choose Instrument","Notice",0)
  --  goto track9_end_drums
  --end
  
  getRandomDrum(BBtrack)
  --Msg("RT_match1 "..RT_match)
  GUI.elms.lbl_instr_match_util01:ondelete()
  GUI.New("lbl_instr_match_util01", "Label", 5, 60+x2, 620+y2, RT_match,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_util01:init()
  
  ::track9_end_drums::

end


function btn_click_util02_random()

  if GUI.Val("my_mnu18b") == 3 then 
    btn_click_util02_random_drums()
  else
    sel_bb_track = 10
    
    track10_RS = GUI.Val("my_mnu18b")
    
    if track10_RS == 1 then sel_bb_track_type = "Rhythm" end
    
    if track10_RS == 2 then sel_bb_track_type = "Soloist" end
    
    track10_val = GUI.Val("my_mnu18")
    
    
    sel_bb_track_instrument = all_instruments[track10_val]
    
    if track10_val == 1 then
      reaper.MB("Choose Instrument or Drums in Rhythm drop down","Notice",0)
      goto track10_end
    end
    
    getRandomInstrument(sel_bb_track,sel_bb_track_instrument,sel_bb_track_type)
    GUI.elms.lbl_instr_match_util02:ondelete()
    GUI.New("lbl_instr_match_util02", "Label", 5, 60+x2, 675+y2, RT_match,true , 3 ,"chorus_fill", "wnd_bg" )
    GUI.elms.lbl_instr_match_util02:init()
    
    
    
    ::track10_end::
  end  
end

function btn_click_util02_random_drums()

  BBtrack = 15 --TMixerPanel15
  
  sec_drums = 1
  
  --track3_RS = GUI.Val("my_mnu12b")
  
  --if track3_RS == 1 then sel_bb_track_type = "Rhythm" end
  
  --if track3_RS == 2 then sel_bb_track_type = "Soloist" end
  
  --track10_val = GUI.Val("my_mnu18")
  
  --sel_bb_track_instrument = bass_instruments[track1_val]
  
  --if track10_val == 1 then
  --  reaper.MB("Choose Instrument","Notice",0)
  --  goto track10_end_drums
  --end
  
  getRandomDrum(BBtrack)
  --Msg("RT_match1 "..RT_match)
  GUI.elms.lbl_instr_match_util02:ondelete()
  GUI.New("lbl_instr_match_util02", "Label", 5, 60+x2, 675+y2, RT_match,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_util02:init()
  
  ::track10_end_drums::

end


function btn_click_util03_random()

  sel_bb_track = 11
  
  track11_RS = GUI.Val("my_mnu19b")
  
  if track11_RS == 1 then sel_bb_track_type = "Rhythm" end
  
  if track11_RS == 2 then sel_bb_track_type = "Soloist" end
  
  track11_val = GUI.Val("my_mnu19")
  
  
  sel_bb_track_instrument = all_instruments[track11_val]
  
  if track11_val == 1 then
    reaper.MB("Choose Instrument","Notice",0)
    goto track11_end
  end
  
  getRandomInstrument(sel_bb_track,sel_bb_track_instrument,sel_bb_track_type)
  
  
  ::track11_end::
end


function btn_click_util04_random()

  sel_bb_track = 12
  
  track12_RS = GUI.Val("my_mnu20b")
  
  if track12_RS == 1 then sel_bb_track_type = "Rhythm" end
  
  if track12_RS == 2 then sel_bb_track_type = "Soloist" end
  
  track12_val = GUI.Val("my_mnu20")
  
  
  sel_bb_track_instrument = all_instruments[track12_val]
  
  if track12_val == 1 then
    reaper.MB("Choose Instrument","Notice",0)
    goto track12_end
  end
  
  getRandomInstrument(sel_bb_track,sel_bb_track_instrument,sel_bb_track_type)
  
  
  ::track12_end::
end

function btn_click_track1_clear()

  clear_track =  reaper.MB( "Are you sure ?", "Notice", 4 )
  --Msg("Clear "..clear_track)
  if clear_track == 6 then
    BBtrack = 1
    --Msg("Clear Track")
    reaper.CF_SetClipboard( BBtrack )
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Erase mixer track.ahk"]],0)
  
    GUI.elms.lbl_instr_match_1:ondelete()
    GUI.New("lbl_instr_match_1", "Label", 5, 60+x2, 215+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )
    GUI.elms.lbl_instr_match_1:init()
    
    GUI.elms.track1_freeze_btn:ondelete()
    GUI.New("track1_freeze_btn",      "Button",           5, 35+x2, 215+y2, 15, 20, "✴", btn_click_track1_freeze)
    GUI.elms.track1_freeze_btn.col_txt = "black"
    GUI.elms.track1_freeze_btn.col_fill = "silver"
    GUI.elms.track1_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track1_freeze_btn:init()
    
    GUI.elms.track1_mute_btn:ondelete()
    GUI.New("track1_mute_btn",      "Button",           5, 5+x2, 215+y2, 15, 20, "M", btn_click_track1_mute)
    GUI.elms.track1_mute_btn.col_txt = "black"
    GUI.elms.track1_mute_btn.col_fill = "silver"
    GUI.elms.track1_mute_btn:init()
    track1_mute_state = 0
    
    GUI.elms.track1_solo_btn:ondelete()
    GUI.New("track1_solo_btn",      "Button",           5, 20+x2, 215+y2, 15, 20, "S", btn_click_track1_solo)
    GUI.elms.track1_solo_btn.col_txt = "black"
    GUI.elms.track1_solo_btn.col_fill = "silver"
    GUI.elms.track1_solo_btn:init()
    track1_solo_state = 0 
  end

end

function btn_click_track2_clear()

  clear_track =  reaper.MB( "Are you sure ?", "Notice", 4 )
  --Msg("Clear "..clear_track)
  if clear_track == 6 then
    BBtrack = 2
    --Msg("Clear Track")
    reaper.CF_SetClipboard( BBtrack )
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Erase mixer track.ahk"]],0)
  
    GUI.elms.lbl_instr_match_2:ondelete()
    GUI.New("lbl_instr_match_2", "Label", 5, 60+x2, 270+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )
    GUI.elms.lbl_instr_match_2:init()
    
    GUI.elms.track2_freeze_btn:ondelete()
    GUI.New("track2_freeze_btn",      "Button",           5, 35+x2, 270+y2, 15, 20, "✴", btn_click_track2_freeze)
    GUI.elms.track2_freeze_btn.col_txt = "black"
    GUI.elms.track2_freeze_btn.col_fill = "silver"
    GUI.elms.track2_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track2_freeze_btn:init()
    
    GUI.elms.track2_mute_btn:ondelete()
    GUI.New("track2_mute_btn",      "Button",           5, 5+x2, 270+y2, 15, 20, "M", btn_click_track2_mute)
    GUI.elms.track2_mute_btn.col_txt = "black"
    GUI.elms.track2_mute_btn.col_fill = "silver"
    GUI.elms.track2_mute_btn:init()
    track2_mute_state = 0
    
    GUI.elms.track2_solo_btn:ondelete()
    GUI.New("track2_solo_btn",      "Button",           5, 20+x2, 270+y2, 15, 20, "S", btn_click_track2_solo)
    GUI.elms.track2_solo_btn.col_txt = "black"
    GUI.elms.track2_solo_btn.col_fill = "silver"
    GUI.elms.track2_solo_btn:init()
    track2_solo_state = 0 
  end

end

function btn_click_track3_clear()

  clear_track =  reaper.MB( "Are you sure ?", "Notice", 4 )
  --Msg("Clear "..clear_track)
  if clear_track == 6 then
    BBtrack = 3
    --Msg("Clear Track")
    reaper.CF_SetClipboard( BBtrack )
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Erase mixer track.ahk"]],0)
  
    GUI.elms.lbl_instr_match_3:ondelete()
    GUI.New("lbl_instr_match_3", "Label", 5, 60+x2, 325+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )
    GUI.elms.lbl_instr_match_3:init()
    
    GUI.elms.track3_freeze_btn:ondelete()
    GUI.New("track3_freeze_btn",      "Button",           5, 35+x2, 325+y2, 15, 20, "✴", btn_click_track3_freeze)
    GUI.elms.track3_freeze_btn.col_txt = "black"
    GUI.elms.track3_freeze_btn.col_fill = "silver"
    GUI.elms.track3_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track3_freeze_btn:init()
    
    GUI.elms.track3_mute_btn:ondelete()
    GUI.New("track3_mute_btn",      "Button",           5, 5+x2, 325+y2, 15, 20, "M", btn_click_track3_mute)
    GUI.elms.track3_mute_btn.col_txt = "black"
    GUI.elms.track3_mute_btn.col_fill = "silver"
    GUI.elms.track3_mute_btn:init()
    track3_mute_state = 0
    
    GUI.elms.track3_solo_btn:ondelete()
    GUI.New("track3_solo_btn",      "Button",           5, 20+x2, 325+y2, 15, 20, "S", btn_click_track3_solo)
    GUI.elms.track3_solo_btn.col_txt = "black"
    GUI.elms.track3_solo_btn.col_fill = "silver"
    GUI.elms.track3_solo_btn:init()
    track3_solo_state = 0 
  end

end

function btn_click_track4_clear()

  clear_track =  reaper.MB( "Are you sure ?", "Notice", 4 )
  --Msg("Clear "..clear_track)
  if clear_track == 6 then
    BBtrack = 4
    --Msg("Clear Track")
    reaper.CF_SetClipboard( BBtrack )
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Erase mixer track.ahk"]],0)
  
    GUI.elms.lbl_instr_match_4:ondelete()
    GUI.New("lbl_instr_match_4", "Label", 5, 60+x2, 380+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )
    GUI.elms.lbl_instr_match_4:init()
    
    GUI.elms.track4_freeze_btn:ondelete()
    GUI.New("track4_freeze_btn",      "Button",           5, 35+x2, 380+y2, 15, 15, "✴", btn_click_track4_freeze)
    GUI.elms.track4_freeze_btn.col_txt = "black"
    GUI.elms.track4_freeze_btn.col_fill = "silver"
    GUI.elms.track4_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track4_freeze_btn:init()
    
    GUI.elms.track4_mute_btn:ondelete()
    GUI.New("track4_mute_btn",      "Button",           5, 5+x2, 380+y2, 15, 15, "M", btn_click_track4_mute)
    GUI.elms.track4_mute_btn.col_txt = "black"
    GUI.elms.track4_mute_btn.col_fill = "silver"
    GUI.elms.track4_mute_btn:init()
    track4_mute_state = 0
    
    GUI.elms.track4_solo_btn:ondelete()
    GUI.New("track4_solo_btn",      "Button",           5, 20+x2, 380+y2, 15, 15, "S", btn_click_track4_solo)
    GUI.elms.track4_solo_btn.col_txt = "black"
    GUI.elms.track4_solo_btn.col_fill = "silver"
    GUI.elms.track4_solo_btn:init()
    track4_solo_state = 0 
  end

end

function btn_click_track5_clear()

  clear_track =  reaper.MB( "Are you sure ?", "Notice", 4 )
  --Msg("Clear "..clear_track)
  if clear_track == 6 then
    BBtrack = 5
    --Msg("Clear Track")
    reaper.CF_SetClipboard( BBtrack )
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Erase mixer track.ahk"]],0)
  
    GUI.elms.lbl_instr_match_5:ondelete()
    GUI.New("lbl_instr_match_5", "Label", 5, 60+x2, 435+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )
    GUI.elms.lbl_instr_match_5:init()
    
    GUI.elms.track5_freeze_btn:ondelete()
    GUI.New("track5_freeze_btn",      "Button",           5, 35+x2, 435+y2, 15, 20, "✴", btn_click_track5_freeze)
    GUI.elms.track5_freeze_btn.col_txt = "black"
    GUI.elms.track5_freeze_btn.col_fill = "silver"
    GUI.elms.track5_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track5_freeze_btn:init()
    
    GUI.elms.track5_mute_btn:ondelete()
    GUI.New("track5_mute_btn",      "Button",           5, 5+x2, 435+y2, 15, 20, "M", btn_click_track5_mute)
    GUI.elms.track5_mute_btn.col_txt = "black"
    GUI.elms.track5_mute_btn.col_fill = "silver"
    GUI.elms.track5_mute_btn:init()
    track5_mute_state = 0
    
    GUI.elms.track5_solo_btn:ondelete()
    GUI.New("track5_solo_btn",      "Button",           5, 20+x2, 435+y2, 15, 20, "S", btn_click_track5_solo)
    GUI.elms.track5_solo_btn.col_txt = "black"
    GUI.elms.track5_solo_btn.col_fill = "silver"
    GUI.elms.track5_solo_btn:init()
    track5_solo_state = 0 
  end

end

function btn_click_track6_clear()

  clear_track =  reaper.MB( "Are you sure ?", "Notice", 4 )
  --Msg("Clear "..clear_track)
  if clear_track == 6 then
    BBtrack = 6
    --Msg("Clear Track")
    reaper.CF_SetClipboard( BBtrack )
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Erase mixer track.ahk"]],0)
  
    GUI.elms.lbl_instr_match_6:ondelete()
    GUI.New("lbl_instr_match_6", "Label", 5, 60+x2, 490+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )
    GUI.elms.lbl_instr_match_6:init()
    
    GUI.elms.track6_freeze_btn:ondelete()
    GUI.New("track6_freeze_btn",      "Button",           5, 35+x2, 490+y2, 15, 20, "✴", btn_click_track6_freeze)
    GUI.elms.track6_freeze_btn.col_txt = "black"
    GUI.elms.track6_freeze_btn.col_fill = "silver"
    GUI.elms.track6_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track6_freeze_btn:init()
    
    GUI.elms.track6_mute_btn:ondelete()
    GUI.New("track6_mute_btn",      "Button",           5, 5+x2, 490+y2, 15, 20, "M", btn_click_track6_mute)
    GUI.elms.track6_mute_btn.col_txt = "black"
    GUI.elms.track6_mute_btn.col_fill = "silver"
    GUI.elms.track6_mute_btn:init()
    track6_mute_state = 0
    
    GUI.elms.track6_solo_btn:ondelete()
    GUI.New("track6_solo_btn",      "Button",           5, 20+x2, 490+y2, 15, 20, "S", btn_click_track6_solo)
    GUI.elms.track6_solo_btn.col_txt = "black"
    GUI.elms.track6_solo_btn.col_fill = "silver"
    GUI.elms.track6_solo_btn:init()
    track6_solo_state = 0 
  end

end

function btn_click_track7_clear()

  clear_track =  reaper.MB( "Are you sure ?", "Notice", 4 )
  --Msg("Clear "..clear_track)
  if clear_track == 6 then
    BBtrack = 7
    --Msg("Clear Track")
    reaper.CF_SetClipboard( BBtrack )
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Erase mixer track.ahk"]],0)
  
    GUI.elms.lbl_instr_match_7:ondelete()
    GUI.New("lbl_instr_match_7", "Label", 5, 60+x2, 545+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )
    GUI.elms.lbl_instr_match_7:init()
    
    GUI.elms.track7_freeze_btn:ondelete()
    GUI.New("track7_freeze_btn",      "Button",           5, 35+x2, 545+y2, 15, 20, "✴", btn_click_track7_freeze)
    GUI.elms.track7_freeze_btn.col_txt = "black"
    GUI.elms.track7_freeze_btn.col_fill = "silver"
    GUI.elms.track7_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track7_freeze_btn:init()
    
    GUI.elms.track7_mute_btn:ondelete()
    GUI.New("track7_mute_btn",      "Button",           5, 5+x2, 545+y2, 15, 20, "M", btn_click_track7_mute)
    GUI.elms.track7_mute_btn.col_txt = "black"
    GUI.elms.track7_mute_btn.col_fill = "silver"
    GUI.elms.track7_mute_btn:init()
    track7_mute_state = 0
    
    GUI.elms.track7_solo_btn:ondelete()
    GUI.New("track7_solo_btn",      "Button",           5, 20+x2, 545+y2, 15, 20, "S", btn_click_track7_solo)
    GUI.elms.track7_solo_btn.col_txt = "black"
    GUI.elms.track7_solo_btn.col_fill = "silver"
    GUI.elms.track7_solo_btn:init()
    track7_solo_state = 0 
  end

end

function btn_click_util01_clear()

  clear_track =  reaper.MB( "Are you sure ?", "Notice", 4 )
  --Msg("Clear "..clear_track)
  if clear_track == 6 then
    BBtrack = 9
    --Msg("Clear Track")
    reaper.CF_SetClipboard( BBtrack )
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Erase mixer track.ahk"]],0)
  
    GUI.elms.lbl_instr_match_util01:ondelete()
    GUI.New("lbl_instr_match_util01", "Label", 5, 60+x2, 620+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )
    GUI.elms.lbl_instr_match_util01:init()
    
    GUI.elms.util01_freeze_btn:ondelete()
    GUI.New("util01_freeze_btn",      "Button",           5, 35+x2, 620+y2, 15, 20, "✴", btn_click_util01_freeze)
    GUI.elms.util01_freeze_btn.col_txt = "black"
    GUI.elms.util01_freeze_btn.col_fill = "silver"
    GUI.elms.util01_freeze_btn.font = {"Impact",18,b}
    GUI.elms.util01_freeze_btn:init()
    
    GUI.elms.util01_mute_btn:ondelete()
    GUI.New("util01_mute_btn",      "Button",           5, 5+x2, 620+y2, 15, 20, "M", btn_click_util01_mute)
    GUI.elms.util01_mute_btn.col_txt = "black"
    GUI.elms.util01_mute_btn.col_fill = "silver"
    GUI.elms.util01_mute_btn:init()
    util01_mute_state = 0
    
    GUI.elms.util01_solo_btn:ondelete()
    GUI.New("util01_solo_btn",      "Button",           5, 20+x2, 620+y2, 15, 20, "S", btn_click_util01_solo)
    GUI.elms.util01_solo_btn.col_txt = "black"
    GUI.elms.util01_solo_btn.col_fill = "silver"
    GUI.elms.util01_solo_btn:init()
    util01_solo_state = 0 
  end

end

function btn_click_util02_clear()

  clear_track =  reaper.MB( "Are you sure ?", "Notice", 4 )
  --Msg("Clear "..clear_track)
  if clear_track == 6 then
    BBtrack = 10
    --Msg("Clear Track")
    reaper.CF_SetClipboard( BBtrack )
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Erase mixer track.ahk"]],0)
  
    GUI.elms.lbl_instr_match_util02:ondelete()
    GUI.New("lbl_instr_match_util02", "Label", 5, 60+x2, 675+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )
    GUI.elms.lbl_instr_match_util02:init()
    
    GUI.elms.util02_freeze_btn:ondelete()
    GUI.New("util02_freeze_btn",      "Button",           5, 35+x2, 675+y2, 15, 20, "✴", btn_click_util02_freeze)
    GUI.elms.util02_freeze_btn.col_txt = "black"
    GUI.elms.util02_freeze_btn.col_fill = "silver"
    GUI.elms.util02_freeze_btn.font = {"Impact",18,b}
    GUI.elms.util02_freeze_btn:init()
    
    GUI.elms.util02_mute_btn:ondelete()
    GUI.New("util02_mute_btn",      "Button",           5, 5+x2, 675+y2, 15, 20, "M", btn_click_util02_mute)
    GUI.elms.util02_mute_btn.col_txt = "black"
    GUI.elms.util02_mute_btn.col_fill = "silver"
    GUI.elms.util02_mute_btn:init()
    util02_mute_state = 0
    
    GUI.elms.util02_solo_btn:ondelete()
    GUI.New("util02_solo_btn",      "Button",           5, 20+x2, 675+y2, 15, 20, "S", btn_click_util02_solo)
    GUI.elms.util02_solo_btn.col_txt = "black"
    GUI.elms.util02_solo_btn.col_fill = "silver"
    GUI.elms.util02_solo_btn:init()
    util02_solo_state = 0
  end

end

function btn_click_track1_mute()

  BBtrack = 27  -- TMixerPanel27
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Mute mixer track.ahk"]],0)
  
  if track1_mute_state == 0 then
    GUI.elms.track1_mute_btn:ondelete()
    GUI.New("track1_mute_btn",      "Button",           5, 5+x2, 215+y2, 15, 20, "M", btn_click_track1_mute)
    GUI.elms.track1_mute_btn.col_txt = "black"
    GUI.elms.track1_mute_btn.col_fill = "red"
    GUI.elms.track1_mute_btn:init()
    track1_mute_state = 1
  else
    GUI.elms.track1_mute_btn:ondelete()
    GUI.New("track1_mute_btn",      "Button",           5, 5+x2, 215+y2, 15, 20, "M", btn_click_track1_mute)
    GUI.elms.track1_mute_btn.col_txt = "black"
    GUI.elms.track1_mute_btn.col_fill = "silver"
    GUI.elms.track1_mute_btn:init()
    track1_mute_state = 0  
  end
  

end

function btn_click_track1_solo()

  BBtrack = 27 -- TMixerPanel27
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Solo mixer track.ahk"]],0)
  
  if track1_solo_state == 0 then
    GUI.elms.track1_solo_btn:ondelete()
    GUI.New("track1_solo_btn",      "Button",           5, 20+x2, 215+y2, 15, 20, "S", btn_click_track1_solo)
    GUI.elms.track1_solo_btn.col_txt = "black"
    GUI.elms.track1_solo_btn.col_fill = "pre_chorus"
    GUI.elms.track1_solo_btn:init()
    track1_solo_state = 1
  else
    GUI.elms.track1_solo_btn:ondelete()
    GUI.New("track1_solo_btn",      "Button",           5, 20+x2, 215+y2, 15, 20, "S", btn_click_track1_solo)
    GUI.elms.track1_solo_btn.col_txt = "black"
    GUI.elms.track1_solo_btn.col_fill = "silver"
    GUI.elms.track1_solo_btn:init()
    track1_solo_state = 0  
  end

end

function btn_click_track2_mute()

  BBtrack = 25  -- TMixerPanel25
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Mute mixer track.ahk"]],0)
  
  if track2_mute_state == 0 then
    GUI.elms.track2_mute_btn:ondelete()
    GUI.New("track2_mute_btn",      "Button",           5, 5+x2, 270+y2, 15, 20, "M", btn_click_track2_mute)
    GUI.elms.track2_mute_btn.col_txt = "black"
    GUI.elms.track2_mute_btn.col_fill = "red"
    GUI.elms.track2_mute_btn:init()
    track2_mute_state = 1
  else
    GUI.elms.track2_mute_btn:ondelete()
    GUI.New("track2_mute_btn",      "Button",           5, 5+x2, 270+y2, 15, 20, "M", btn_click_track2_mute)
    GUI.elms.track2_mute_btn.col_txt = "black"
    GUI.elms.track2_mute_btn.col_fill = "silver"
    GUI.elms.track2_mute_btn:init()
    track2_mute_state = 0  
  end
  

end

function btn_click_track2_solo()

  BBtrack = 25 -- TMixerPanel25
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Solo mixer track.ahk"]],0)
  
  if track2_solo_state == 0 then
    GUI.elms.track2_solo_btn:ondelete()
    GUI.New("track2_solo_btn",      "Button",           5, 20+x2, 270+y2, 15, 20, "S", btn_click_track2_solo)
    GUI.elms.track2_solo_btn.col_txt = "black"
    GUI.elms.track2_solo_btn.col_fill = "pre_chorus"
    GUI.elms.track2_solo_btn:init()
    track2_solo_state = 1
  else
    GUI.elms.track2_solo_btn:ondelete()
    GUI.New("track2_solo_btn",      "Button",           5, 20+x2, 270+y2, 15, 20, "S", btn_click_track2_solo)
    GUI.elms.track2_solo_btn.col_txt = "black"
    GUI.elms.track2_solo_btn.col_fill = "silver"
    GUI.elms.track2_solo_btn:init()
    track2_solo_state = 0  
  end

end

function btn_click_track3_mute()

  BBtrack = 26  -- TMixerPanel26
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Mute mixer track drums.ahk"]],0)
  
  if track3_mute_state == 0 then
    GUI.elms.track3_mute_btn:ondelete()
    GUI.New("track3_mute_btn",      "Button",           5, 5+x2, 325+y2, 15, 20, "M", btn_click_track3_mute)
    GUI.elms.track3_mute_btn.col_txt = "black"
    GUI.elms.track3_mute_btn.col_fill = "red"
    GUI.elms.track3_mute_btn:init()
    track3_mute_state = 1
  else
    GUI.elms.track3_mute_btn:ondelete()
    GUI.New("track3_mute_btn",      "Button",           5, 5+x2, 325+y2, 15, 20, "M", btn_click_track3_mute)
    GUI.elms.track3_mute_btn.col_txt = "black"
    GUI.elms.track3_mute_btn.col_fill = "silver"
    GUI.elms.track3_mute_btn:init()
    track3_mute_state = 0  
  end
  

end

function btn_click_track3_solo()

  BBtrack = 26 -- TMixerPanel26
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Solo mixer track drums.ahk"]],0)
  
  if track3_solo_state == 0 then
    GUI.elms.track3_solo_btn:ondelete()
    GUI.New("track3_solo_btn",      "Button",           5, 20+x2, 325+y2, 15, 20, "S", btn_click_track3_solo)
    GUI.elms.track3_solo_btn.col_txt = "black"
    GUI.elms.track3_solo_btn.col_fill = "pre_chorus"
    GUI.elms.track3_solo_btn:init()
    track3_solo_state = 1
  else
    GUI.elms.track3_solo_btn:ondelete()
    GUI.New("track3_solo_btn",      "Button",           5, 20+x2, 325+y2, 15, 20, "S", btn_click_track3_solo)
    GUI.elms.track3_solo_btn.col_txt = "black"
    GUI.elms.track3_solo_btn.col_fill = "silver"
    GUI.elms.track3_solo_btn:init()
    track3_solo_state = 0  
  end

end

function btn_click_track4_mute()

  BBtrack = 24  -- TMixerPanel24
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Mute mixer track drums.ahk"]],0)
  
  if track4_mute_state == 0 then
    GUI.elms.track4_mute_btn:ondelete()
    GUI.New("track4_mute_btn",      "Button",           5, 5+x2, 380+y2, 15, 20, "M", btn_click_track4_mute)
    GUI.elms.track4_mute_btn.col_txt = "black"
    GUI.elms.track4_mute_btn.col_fill = "red"
    GUI.elms.track4_mute_btn:init()
    track4_mute_state = 1
  else
    GUI.elms.track4_mute_btn:ondelete()
    GUI.New("track4_mute_btn",      "Button",           5, 5+x2, 380+y2, 15, 20, "M", btn_click_track4_mute)
    GUI.elms.track4_mute_btn.col_txt = "black"
    GUI.elms.track4_mute_btn.col_fill = "silver"
    GUI.elms.track4_mute_btn:init()
    track4_mute_state = 0  
  end
  

end

function btn_click_track4_solo()

  BBtrack = 24 -- TMixerPanel24
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Solo mixer track.ahk"]],0)
  
  if track4_solo_state == 0 then
    GUI.elms.track4_solo_btn:ondelete()
    GUI.New("track4_solo_btn",      "Button",           5, 20+x2, 380+y2, 15, 20, "S", btn_click_track4_solo)
    GUI.elms.track4_solo_btn.col_txt = "black"
    GUI.elms.track4_solo_btn.col_fill = "pre_chorus"
    GUI.elms.track4_solo_btn:init()
    track4_solo_state = 1
  else
    GUI.elms.track4_solo_btn:ondelete()
    GUI.New("track4_solo_btn",      "Button",           5, 20+x2, 380+y2, 15, 20, "S", btn_click_track4_solo)
    GUI.elms.track4_solo_btn.col_txt = "black"
    GUI.elms.track4_solo_btn.col_fill = "silver"
    GUI.elms.track4_solo_btn:init()
    track4_solo_state = 0  
  end

end

function btn_click_track5_mute()

  BBtrack = 23  -- TMixerPanel23
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Mute mixer track.ahk"]],0)
  
  if track5_mute_state == 0 then
    GUI.elms.track5_mute_btn:ondelete()
    GUI.New("track5_mute_btn",      "Button",           5, 5+x2, 435+y2, 15, 20, "M", btn_click_track5_mute)
    GUI.elms.track5_mute_btn.col_txt = "black"
    GUI.elms.track5_mute_btn.col_fill = "red"
    GUI.elms.track5_mute_btn:init()
    track5_mute_state = 1
  else
    GUI.elms.track5_mute_btn:ondelete()
    GUI.New("track5_mute_btn",      "Button",           5, 5+x2, 435+y2, 15, 20, "M", btn_click_track5_mute)
    GUI.elms.track5_mute_btn.col_txt = "black"
    GUI.elms.track5_mute_btn.col_fill = "silver"
    GUI.elms.track5_mute_btn:init()
    track5_mute_state = 0  
  end
  

end

function btn_click_track5_solo()

  BBtrack = 23 -- TMixerPanel23
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Solo mixer track.ahk"]],0)
  
  if track5_solo_state == 0 then
    GUI.elms.track5_solo_btn:ondelete()
    GUI.New("track5_solo_btn",      "Button",           5, 20+x2, 435+y2, 15, 20, "S", btn_click_track5_solo)
    GUI.elms.track5_solo_btn.col_txt = "black"
    GUI.elms.track5_solo_btn.col_fill = "pre_chorus"
    GUI.elms.track5_solo_btn:init()
    track5_solo_state = 1
  else
    GUI.elms.track5_solo_btn:ondelete()
    GUI.New("track5_solo_btn",      "Button",           5, 20+x2, 435+y2, 15, 20, "S", btn_click_track5_solo)
    GUI.elms.track5_solo_btn.col_txt = "black"
    GUI.elms.track5_solo_btn.col_fill = "silver"
    GUI.elms.track5_solo_btn:init()
    track5_solo_state = 0  
  end

end

function btn_click_track6_mute()

  BBtrack = 22  -- TMixerPanel22
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Mute mixer track.ahk"]],0)
  
  if track6_mute_state == 0 then
    GUI.elms.track6_mute_btn:ondelete()
    GUI.New("track6_mute_btn",      "Button",           5, 5+x2, 490+y2, 15, 20, "M", btn_click_track6_mute)
    GUI.elms.track6_mute_btn.col_txt = "black"
    GUI.elms.track6_mute_btn.col_fill = "red"
    GUI.elms.track6_mute_btn:init()
    track6_mute_state = 1
  else
    GUI.elms.track6_mute_btn:ondelete()
    GUI.New("track6_mute_btn",      "Button",           5, 5+x2, 490+y2, 15, 20, "M", btn_click_track6_mute)
    GUI.elms.track6_mute_btn.col_txt = "black"
    GUI.elms.track6_mute_btn.col_fill = "silver"
    GUI.elms.track6_mute_btn:init()
    track6_mute_state = 0  
  end
  

end

function btn_click_track6_solo()

  BBtrack = 22 -- TMixerPanel22
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Solo mixer track.ahk"]],0)
  
  if track6_solo_state == 0 then
    GUI.elms.track6_solo_btn:ondelete()
    GUI.New("track6_solo_btn",      "Button",           5, 20+x2, 490+y2, 15, 20, "S", btn_click_track6_solo)
    GUI.elms.track6_solo_btn.col_txt = "black"
    GUI.elms.track6_solo_btn.col_fill = "pre_chorus"
    GUI.elms.track6_solo_btn:init()
    track6_solo_state = 1
  else
    GUI.elms.track6_solo_btn:ondelete()
    GUI.New("track6_solo_btn",      "Button",           5, 20+x2, 490+y2, 15, 20, "S", btn_click_track6_solo)
    GUI.elms.track6_solo_btn.col_txt = "black"
    GUI.elms.track6_solo_btn.col_fill = "silver"
    GUI.elms.track6_solo_btn:init()
    track6_solo_state = 0  
  end

end

function btn_click_track7_mute()

  BBtrack = 21  -- TMixerPanel21
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Mute mixer track.ahk"]],0)
  
  if track7_mute_state == 0 then
    GUI.elms.track7_mute_btn:ondelete()
    GUI.New("track7_mute_btn",      "Button",           5, 5+x2, 545+y2, 15, 20, "M", btn_click_track7_mute)
    GUI.elms.track7_mute_btn.col_txt = "black"
    GUI.elms.track7_mute_btn.col_fill = "red"
    GUI.elms.track7_mute_btn:init()
    track7_mute_state = 1
  else
    GUI.elms.track7_mute_btn:ondelete()
    GUI.New("track7_mute_btn",      "Button",           5, 5+x2, 545+y2, 15, 20, "M", btn_click_track7_mute)
    GUI.elms.track7_mute_btn.col_txt = "black"
    GUI.elms.track7_mute_btn.col_fill = "silver"
    GUI.elms.track7_mute_btn:init()
    track7_mute_state = 0  
  end
  

end

function btn_click_track7_solo()

  BBtrack = 21 -- TMixerPanel21
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Solo mixer track.ahk"]],0)
  
  if track7_solo_state == 0 then
    GUI.elms.track7_solo_btn:ondelete()
    GUI.New("track7_solo_btn",      "Button",           5, 20+x2, 545+y2, 15, 20, "S", btn_click_track7_solo)
    GUI.elms.track7_solo_btn.col_txt = "black"
    GUI.elms.track7_solo_btn.col_fill = "pre_chorus"
    GUI.elms.track7_solo_btn:init()
    track7_solo_state = 1
  else
    GUI.elms.track7_solo_btn:ondelete()
    GUI.New("track7_solo_btn",      "Button",           5, 20+x2, 545+y2, 15, 20, "S", btn_click_track7_solo)
    GUI.elms.track7_solo_btn.col_txt = "black"
    GUI.elms.track7_solo_btn.col_fill = "silver"
    GUI.elms.track7_solo_btn:init()
    track7_solo_state = 0  
  end

end

function btn_click_util01_mute()

  BBtrack = 16  -- TMixerPanel16
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Mute mixer track.ahk"]],0)
  
  if util01_mute_state == 0 then
    GUI.elms.util01_mute_btn:ondelete()
    GUI.New("util01_mute_btn",      "Button",           5, 5+x2, 620+y2, 15, 20, "M", btn_click_util01_mute)
    GUI.elms.util01_mute_btn.col_txt = "black"
    GUI.elms.util01_mute_btn.col_fill = "red"
    GUI.elms.util01_mute_btn:init()
    util01_mute_state = 1
  else
    GUI.elms.util01_mute_btn:ondelete()
    GUI.New("util01_mute_btn",      "Button",           5, 5+x2, 620+y2, 15, 20, "M", btn_click_util01_mute)
    GUI.elms.util01_mute_btn.col_txt = "black"
    GUI.elms.util01_mute_btn.col_fill = "silver"
    GUI.elms.util01_mute_btn:init()
    util01_mute_state = 0  
  end
  

end

function btn_click_util01_solo()

  BBtrack = 16 -- TMixerPanel16
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Solo mixer track.ahk"]],0)
  
  if util01_solo_state == 0 then
    GUI.elms.util01_solo_btn:ondelete()
    GUI.New("util01_solo_btn",      "Button",           5, 20+x2, 620+y2, 15, 20, "S", btn_click_util01_solo)
    GUI.elms.util01_solo_btn.col_txt = "black"
    GUI.elms.util01_solo_btn.col_fill = "pre_chorus"
    GUI.elms.util01_solo_btn:init()
    util01_solo_state = 1
  else
    GUI.elms.util01_solo_btn:ondelete()
    GUI.New("util01_solo_btn",      "Button",           5, 20+x2, 620+y2, 15, 20, "S", btn_click_util01_solo)
    GUI.elms.util01_solo_btn.col_txt = "black"
    GUI.elms.util01_solo_btn.col_fill = "silver"
    GUI.elms.util01_solo_btn:init()
    util01_solo_state = 0  
  end

end

function btn_click_util02_mute()

  BBtrack = 15  -- TMixerPanel15
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Mute mixer track.ahk"]],0)
  
  if util02_mute_state == 0 then
    GUI.elms.util02_mute_btn:ondelete()
    GUI.New("util02_mute_btn",      "Button",           5, 5+x2, 675+y2, 15, 20, "M", btn_click_util02_mute)
    GUI.elms.util02_mute_btn.col_txt = "black"
    GUI.elms.util02_mute_btn.col_fill = "red"
    GUI.elms.util02_mute_btn:init()
    util02_mute_state = 1
  else
    GUI.elms.util02_mute_btn:ondelete()
    GUI.New("util02_mute_btn",      "Button",           5, 5+x2, 675+y2, 15, 20, "M", btn_click_util02_mute)
    GUI.elms.util02_mute_btn.col_txt = "black"
    GUI.elms.util02_mute_btn.col_fill = "silver"
    GUI.elms.util02_mute_btn:init()
    util02_mute_state = 0  
  end
  

end

function btn_click_util02_solo()

  BBtrack = 15 -- TMixerPanel15
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Solo mixer track.ahk"]],0)
  
  if util02_solo_state == 0 then
    GUI.elms.util02_solo_btn:ondelete()
    GUI.New("util02_solo_btn",      "Button",           5, 20+x2, 675+y2, 15, 20, "S", btn_click_util02_solo)
    GUI.elms.util02_solo_btn.col_txt = "black"
    GUI.elms.util02_solo_btn.col_fill = "pre_chorus"
    GUI.elms.util02_solo_btn:init()
    util02_solo_state = 1
  else
    GUI.elms.util02_solo_btn:ondelete()
    GUI.New("util02_solo_btn",      "Button",           5, 20+x2, 675+y2, 15, 20, "S", btn_click_util02_solo)
    GUI.elms.util02_solo_btn.col_txt = "black"
    GUI.elms.util02_solo_btn.col_fill = "silver"
    GUI.elms.util02_solo_btn:init()
    util02_solo_state = 0  
  end

end

function btn_click_track1_freeze()

  BBtrack = 27 -- TMixerPanel27
  reaper.CF_SetClipboard( BBtrack )
  
  if track1_freeze_state == 0 then
    GUI.elms.track1_freeze_btn:ondelete()
    GUI.New("track1_freeze_btn",      "Button",           5, 35+x2, 215+y2, 15, 20, "✴", btn_click_track1_freeze)
    GUI.elms.track1_freeze_btn.col_txt = "verse"
    GUI.elms.track1_freeze_btn.col_fill = "silver"
    GUI.elms.track1_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track1_freeze_btn:init()
    track1_freeze_state = 1
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Freeze mixer track.ahk"]],0)
      
  else
    GUI.elms.track1_freeze_btn:ondelete()
    GUI.New("track1_freeze_btn",      "Button",           5, 35+x2, 215+y2, 15, 20, "✴", btn_click_track1_freeze)
    GUI.elms.track1_freeze_btn.col_txt = "black"
    GUI.elms.track1_freeze_btn.col_fill = "silver"
    GUI.elms.track1_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track1_freeze_btn:init()
    track1_freeze_state = 0 
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Unfreeze mixer track.ahk"]],0)
      
  end

end

function btn_click_track2_freeze()

  BBtrack = 25 -- TMixerPanel25
  reaper.CF_SetClipboard( BBtrack )
  
  if track2_freeze_state == 0 then
    GUI.elms.track2_freeze_btn:ondelete()
    GUI.New("track2_freeze_btn",      "Button",           5, 35+x2, 270+y2, 15, 20, "✴", btn_click_track2_freeze)
    GUI.elms.track2_freeze_btn.col_txt = "verse"
    GUI.elms.track2_freeze_btn.col_fill = "silver"
    GUI.elms.track2_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track2_freeze_btn:init()
    track2_freeze_state = 1
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Freeze mixer track.ahk"]],0)
      
  else
    GUI.elms.track2_freeze_btn:ondelete()
    GUI.New("track2_freeze_btn",      "Button",           5, 35+x2, 270+y2, 15, 20, "✴", btn_click_track2_freeze)
    GUI.elms.track2_freeze_btn.col_txt = "black"
    GUI.elms.track2_freeze_btn.col_fill = "silver"
    GUI.elms.track2_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track2_freeze_btn:init()
    track2_freeze_state = 0 
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Unfreeze mixer track.ahk"]],0)
      
  end

end

function btn_click_track3_freeze()

  BBtrack = 26 -- TMixerPanel26
  reaper.CF_SetClipboard( BBtrack )
  
  if track3_freeze_state == 0 then
    GUI.elms.track3_freeze_btn:ondelete()
    GUI.New("track3_freeze_btn",      "Button",           5, 35+x2, 325+y2, 15, 20, "✴", btn_click_track3_freeze)
    GUI.elms.track3_freeze_btn.col_txt = "verse"
    GUI.elms.track3_freeze_btn.col_fill = "silver"
    GUI.elms.track3_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track3_freeze_btn:init()
    track3_freeze_state = 1
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Freeze mixer track drums.ahk"]],0)
      
  else
    GUI.elms.track3_freeze_btn:ondelete()
    GUI.New("track3_freeze_btn",      "Button",           5, 35+x2, 325+y2, 15, 20, "✴", btn_click_track3_freeze)
    GUI.elms.track3_freeze_btn.col_txt = "black"
    GUI.elms.track3_freeze_btn.col_fill = "silver"
    GUI.elms.track3_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track3_freeze_btn:init()
    track3_freeze_state = 0 
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Unfreeze mixer track drums.ahk"]],0)
      
  end

end

function btn_click_track4_freeze()

  BBtrack = 24 -- TMixerPanel24
  reaper.CF_SetClipboard( BBtrack )
  
  if track4_freeze_state == 0 then
    GUI.elms.track4_freeze_btn:ondelete()
    GUI.New("track4_freeze_btn",      "Button",           5, 35+x2, 380+y2, 15, 20, "✴", btn_click_track4_freeze)
    GUI.elms.track4_freeze_btn.col_txt = "verse"
    GUI.elms.track4_freeze_btn.col_fill = "silver"
    GUI.elms.track4_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track4_freeze_btn:init()
    track4_freeze_state = 1
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Freeze mixer track.ahk"]],0)
      
  else
    GUI.elms.track4_freeze_btn:ondelete()
    GUI.New("track4_freeze_btn",      "Button",           5, 35+x2, 380+y2, 15, 20, "✴", btn_click_track4_freeze)
    GUI.elms.track4_freeze_btn.col_txt = "black"
    GUI.elms.track4_freeze_btn.col_fill = "silver"
    GUI.elms.track4_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track4_freeze_btn:init()
    track4_freeze_state = 0 
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Unfreeze mixer track.ahk"]],0)
      
  end

end

function btn_click_track5_freeze()

  BBtrack = 23 -- TMixerPanel23
  reaper.CF_SetClipboard( BBtrack )
  
  if track5_freeze_state == 0 then
    GUI.elms.track5_freeze_btn:ondelete()
    GUI.New("track5_freeze_btn",      "Button",           5, 35+x2, 435+y2, 15, 20, "✴", btn_click_track5_freeze)
    GUI.elms.track5_freeze_btn.col_txt = "verse"
    GUI.elms.track5_freeze_btn.col_fill = "silver"
    GUI.elms.track5_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track5_freeze_btn:init()
    track5_freeze_state = 1
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Freeze mixer track.ahk"]],0)
      
  else
    GUI.elms.track5_freeze_btn:ondelete()
    GUI.New("track5_freeze_btn",      "Button",           5, 35+x2, 435+y2, 15, 20, "✴", btn_click_track5_freeze)
    GUI.elms.track5_freeze_btn.col_txt = "black"
    GUI.elms.track5_freeze_btn.col_fill = "silver"
    GUI.elms.track5_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track5_freeze_btn:init()
    track5_freeze_state = 0 
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Unfreeze mixer track.ahk"]],0)
      
  end

end

function btn_click_track6_freeze()

  BBtrack = 22 -- TMixerPanel22
  reaper.CF_SetClipboard( BBtrack )
  
  if track6_freeze_state == 0 then
    GUI.elms.track6_freeze_btn:ondelete()
    GUI.New("track6_freeze_btn",      "Button",           5, 35+x2, 490+y2, 15, 20, "✴", btn_click_track6_freeze)
    GUI.elms.track6_freeze_btn.col_txt = "verse"
    GUI.elms.track6_freeze_btn.col_fill = "silver"
    GUI.elms.track6_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track6_freeze_btn:init()
    track6_freeze_state = 1
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Freeze mixer track.ahk"]],0)
      
  else
    GUI.elms.track6_freeze_btn:ondelete()
    GUI.New("track6_freeze_btn",      "Button",           5, 35+x2, 490+y2, 15, 20, "✴", btn_click_track6_freeze)
    GUI.elms.track6_freeze_btn.col_txt = "black"
    GUI.elms.track6_freeze_btn.col_fill = "silver"
    GUI.elms.track6_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track6_freeze_btn:init()
    track6_freeze_state = 0 
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Unfreeze mixer track.ahk"]],0)
      
  end

end

function btn_click_track7_freeze()

  BBtrack = 21 -- TMixerPanel22
  reaper.CF_SetClipboard( BBtrack )
  
  if track7_freeze_state == 0 then
    GUI.elms.track7_freeze_btn:ondelete()
    GUI.New("track7_freeze_btn",      "Button",           5, 35+x2, 545+y2, 15, 20, "✴", btn_click_track7_freeze)
    GUI.elms.track7_freeze_btn.col_txt = "verse"
    GUI.elms.track7_freeze_btn.col_fill = "silver"
    GUI.elms.track7_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track7_freeze_btn:init()
    track7_freeze_state = 1
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Freeze mixer track.ahk"]],0)
      
  else
    GUI.elms.track7_freeze_btn:ondelete()
    GUI.New("track7_freeze_btn",      "Button",           5, 35+x2, 545+y2, 15, 20, "✴", btn_click_track7_freeze)
    GUI.elms.track7_freeze_btn.col_txt = "black"
    GUI.elms.track7_freeze_btn.col_fill = "silver"
    GUI.elms.track7_freeze_btn.font = {"Impact",18,b}
    GUI.elms.track7_freeze_btn:init()
    track7_freeze_state = 0 
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Unfreeze mixer track.ahk"]],0)
      
  end

end

function btn_click_util01_freeze()

  BBtrack = 16 -- TMixerPanel16
  reaper.CF_SetClipboard( BBtrack )
  
  if util01_freeze_state == 0 then
    GUI.elms.util01_freeze_btn:ondelete()
    GUI.New("util01_freeze_btn",      "Button",           5, 35+x2, 620+y2, 15, 20, "✴", btn_click_util01_freeze)
    GUI.elms.util01_freeze_btn.col_txt = "verse"
    GUI.elms.util01_freeze_btn.col_fill = "silver"
    GUI.elms.util01_freeze_btn.font = {"Impact",18,b}
    GUI.elms.util01_freeze_btn:init()
    util01_freeze_state = 1
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Freeze mixer track.ahk"]],0)
      
  else
    GUI.elms.util01_freeze_btn:ondelete()
    GUI.New("util01_freeze_btn",      "Button",           5, 35+x2, 620+y2, 15, 20, "✴", btn_click_util01_freeze)
    GUI.elms.util01_freeze_btn.col_txt = "black"
    GUI.elms.util01_freeze_btn.col_fill = "silver"
    GUI.elms.util01_freeze_btn.font = {"Impact",18,b}
    GUI.elms.util01_freeze_btn:init()
    util01_freeze_state = 0 
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Unfreeze mixer track.ahk"]],0)
      
  end

end

function btn_click_util02_freeze()

  BBtrack =15 -- TMixerPanel15
  reaper.CF_SetClipboard( BBtrack )
  
  if util02_freeze_state == 0 then
    GUI.elms.util02_freeze_btn:ondelete()
    GUI.New("util02_freeze_btn",      "Button",           5, 35+x2, 675+y2, 15, 20, "✴", btn_click_util02_freeze)
    GUI.elms.util02_freeze_btn.col_txt = "verse"
    GUI.elms.util02_freeze_btn.col_fill = "silver"
    GUI.elms.util02_freeze_btn.font = {"Impact",18,b}
    GUI.elms.util02_freeze_btn:init()
    util02_freeze_state = 1
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Freeze mixer track.ahk"]],0)
      
  else
    GUI.elms.util02_freeze_btn:ondelete()
    GUI.New("util02_freeze_btn",      "Button",           5, 35+x2, 675+y2, 15, 20, "✴", btn_click_util02_freeze)
    GUI.elms.util02_freeze_btn.col_txt = "black"
    GUI.elms.util02_freeze_btn.col_fill = "silver"
    GUI.elms.util02_freeze_btn.font = {"Impact",18,b}
    GUI.elms.util02_freeze_btn:init()
    util02_freeze_state = 0 
    
    reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Unfreeze mixer track.ahk"]],0)
      
  end

end


function btn_click_track1_name()

  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Get track1 name.ahk"]],0)
    
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_1:ondelete()
  GUI.New("lbl_instr_match_1", "Label", 5, 60+x2, 215+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_1:init() 
 
end

function btn_click_track2_name()
  
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Get track2 name.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_2:ondelete()
  GUI.New("lbl_instr_match_2", "Label", 5, 60+x2, 270+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_2:init()
end

function btn_click_track3_name()
  
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Get track3 name.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  track_name = track_name:gsub ("RealDrums=", "")
  GUI.elms.lbl_instr_match_3:ondelete()
  GUI.New("lbl_instr_match_3", "Label", 5, 60+x2, 325+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_3:init()
end

function btn_click_track4_name()
  
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Get track4 name.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_4:ondelete()
  GUI.New("lbl_instr_match_4", "Label", 5, 60+x2, 380+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_4:init()
end

function btn_click_track5_name()
  
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Get track5 name.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_5:ondelete()
  GUI.New("lbl_instr_match_5", "Label", 5, 60+x2, 435+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_5:init()
end

function btn_click_track6_name()
  
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Get track6 name.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_6:ondelete()
  GUI.New("lbl_instr_match_6", "Label", 5, 60+x2, 490+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_6:init()
end

function btn_click_track7_name()
  
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Get track7 name.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  GUI.elms.lbl_instr_match_7:ondelete()
  GUI.New("lbl_instr_match_7", "Label", 5, 60+x2, 545+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_7:init()
end

function btn_click_util01_name()
  
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Get track9 name.ahk"]],0)
 
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  track_name = track_name:gsub ("RealDrums=", "")
  GUI.elms.lbl_instr_match_util01:ondelete()
  GUI.New("lbl_instr_match_util01", "Label", 5, 60+x2, 620+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_util01:init()  
end

function btn_click_util02_name()
  
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Get track10 name.ahk"]],0)
  
  track_name = reaper.CF_GetClipboard():match"^.-:.-:(.+)"
  track_name = track_name:gsub ("RealDrums=", "")
  GUI.elms.lbl_instr_match_util02:ondelete()
  GUI.New("lbl_instr_match_util02", "Label", 5, 60+x2, 675+y2, track_name,true , 3 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match_util02:init()  
end

function btn_click_track1_audio_inject()
  BBtrack = 1
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_trk_btn_click()
end

function btn_click_track1_midi_inject()
  BBtrack = 1
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_mid_trk_btn_click()
end

function btn_click_track2_audio_inject()
  BBtrack = 2
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_trk_btn_click()
end

function btn_click_track2_midi_inject()
  BBtrack = 2
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_mid_trk_btn_click()
end

function btn_click_track3_audio_inject()
  BBtrack = 3
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_trk_btn_click()
end

function btn_click_track3_midi_inject()
  BBtrack = 3
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_mid_trk_btn_click()
end

function btn_click_track4_audio_inject()
  BBtrack = 4
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_trk_btn_click()
end

function btn_click_track4_midi_inject()
  BBtrack = 4
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_mid_trk_btn_click()
end

function btn_click_track5_audio_inject()
  BBtrack = 5
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_trk_btn_click()
end

function btn_click_track5_midi_inject()
  BBtrack = 5
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_mid_trk_btn_click()
end

function btn_click_track6_audio_inject()
  BBtrack = 6
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_trk_btn_click()
end

function btn_click_track6_midi_inject()
  BBtrack = 6
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_mid_trk_btn_click()
end

function btn_click_track7_audio_inject()
  BBtrack = 7
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_trk_btn_click()
end

function btn_click_track7_midi_inject()
  BBtrack = 7
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_mid_trk_btn_click()
end

function btn_click_util01_audio_inject()
  BBtrack = 9
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_trk_btn_click()
end

function btn_click_util01_midi_inject()
  BBtrack = 9
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_mid_trk_btn_click()
end

function btn_click_util02_audio_inject()
  BBtrack = 10
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_trk_btn_click()
end

function btn_click_util02_midi_inject()
  BBtrack = 10
  reaper.CF_SetClipboard( BBtrack )
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. [[C:\\Program Files\\AutoHotkey & AutoHotkey.exe]]..[[ "]]..script_path..[[ahk\scripts\Select BB track to inject.ahk"]],0)
  import_sel_mid_trk_btn_click()
end




function instrument_match()

  GUI.elms.lbl_instr_match:ondelete()
  GUI.New("lbl_instr_match", "Label", 5, 190+x3, 60+y3, "Match Found",true , 4 ,"chorus_fill", "wnd_bg" )
  GUI.elms.lbl_instr_match:init()

end


function instrument_no_match()

  GUI.elms.lbl_instr_match:ondelete()
  GUI.New("lbl_instr_match", "Label", 5, 190+x3, 60+y3, "No Match",true , 4 ,"play_anywhere", "wnd_bg" )
  GUI.elms.lbl_instr_match:init()

end






local function wnd_OK()

    -- Close the Window element
    GUI.elms.wnd_test:close()
    
end


-- Returns a list of every element on the specified z-layer and
-- a second list of each element's values
local function get_values_for_tab(tab_num)
    
  -- The '+ 2' here is just to translate from a tab number to its' 
  -- associated z layer. More complicated scripts would have to 
  -- actually access GUI.elms.tabs.z_sets[tab_num] and iterate over
  -- the table's contents (see the call to GUI.elms.tabs:update_sets
  -- below)
    local strs_v, strs_val = {}, {}
  for k, v in pairs(GUI.elms_list[tab_num + 2]) do
    
        strs_v[#strs_v + 1] = v
    local val = GUI.Val(v)
    if type(val) == "table" then
      local strs = {}
      for k, v in pairs(val) do
                local str = tostring(v) 
                
                -- For conciseness, reduce boolean values to T/F
        if str == "true" then
                    str = "T"
                elseif str == "false" then
                    str = "F"
                end
                strs[#strs + 1] = str
      end
      val = table.concat(strs, ", ")
    end
        
        -- Limit the length of the returned string so it doesn't
        -- spill out past the edge of the window
    strs_val[#strs_val + 1] = string.len(tostring(val)) <= 35
                                and tostring(val)
                                or  string.sub(val, 1, 32) .. "..."
    
  end
    
    return strs_v, strs_val
    
end




------------------------------------
-------- Window settings -----------
------------------------------------


GUI.name = "Biab Track Injector"
GUI.x, GUI.y, GUI.w, GUI.h = 0, 0, 520, 660
GUI.anchor, GUI.corner = "mouse", "C"


--[[  

  Button    z,   x,   y,   w,   h, caption, func[, ...]
  Checklist  z,   x,   y,   w,   h, caption, opts[, dir, pad]
  Frame    z,   x,   y,   w,   h[, shadow, fill, color, round]
  Knob    z,   x,   y,   w,   caption, min, max, default[, inc, vals]  
  Label    z,   x,   y,    caption[, shadow, font, color, bg]
  Menubox    z,   x,   y,   w,   h, caption, opts
  Radio    z,   x,   y,   w,   h, caption, opts[, dir, pad]
  Slider    z,   x,   y,   w,   caption, min, max, defaults[, inc, dir]
  Tabs    z,   x,   y,     tab_w, tab_h, opts[, pad]
  Textbox    z,   x,   y,   w,   h[, caption, pad]
    Window      z,  x,  y,  w,  h,  caption, z_set[, center]
  
]]--


-- Elements can be created in any order you want. I find it easiest to organize them
-- by tab, or by what part of the script they're involved in.




------------------------------------
-------- General elements ----------
------------------------------------


GUI.New("tabs",   "Tabs",     1, 0, 0, 64, 20, "Riffs,Tracks,Style,Settings", 16)
GUI.New("tab_bg",  "Frame",    2, 0, 0, 448, 20, false, true, "elm_bg", 0)
--GUI.New("my_btn",   "Button",     3, 168, 228, 96, 20, "Go!", btn_click)
GUI.New("btn_frm",  "Frame",    3, 0, 426, GUI.w, 4, true, true)

-- Telling the tabs which z layers to display
-- See Classes/Tabs.lua for more detail
GUI.elms.tabs:update_sets(
  --  Tab
  --      Layers
  {  [1] =  {3},
    [2] =  {4},
    [3] =  {5},
    [4] =  {6},
  }
)

-- Notice that layers 1 and 2 aren't assigned to a tab; this leaves them visible
-- all the time.




------------------------------------
-------- Tab 1 Elements ------------
------------------------------------
x1=0
y1=-34


--GUI.New("my_lbl",   "Label",     3, 56, 26, "Biab Track Injector", true, 1)

GUI.New("my_chk",   "Checklist",   3, 22, 76, 130, 120, "Track Options:", "Bluesy,Simpler,Direct Input,Held", "v", 4)
GUI.elms.my_chk.col_txt = "yellow"
GUI.elms.my_chk.col_fill = "verse"

GUI.New("my_mnu",   "Menubox",     3, 86, 36, 104, 20, "Timebase:", "Normal-Time,Half-Time,Double-Time,Triple-Time")

GUI.New("lbl_my_mnu", "Label", 3, 200, 30, " ",true , 1 ,"play_anywhere", "wnd_bg" )

GUI.New("my_chk2",   "Checklist",     4, 10, 30, 100, 595, "Tracks:", "Track 1,Track 2,Track 3,Track 4,Track 5,Track 6,Track 7,Audio,Utility#1,Utility#2,Utility#3,Utility#4,Utility#5,Utility#6,Utility#7,Utility#8,Utility#9,Utility#10,Utility#11,Utility#12,Utility#13,Utility#14,Utility#15,Utility#16", "v", 4)
GUI.elms.my_chk2.col_txt = "yellow"
GUI.elms.my_chk2.col_fill = "verse"

GUI.New("import_all_chk_tracks_btn",     "Button",          4, 120+x1, 80+y1, 180, 24, "Import All Selected Tracks", import_all_chk_tracks_btn_click)
GUI.elms.import_all_chk_tracks_btn.col_txt = "yellow"
GUI.elms.import_all_chk_tracks_btn.col_fill = "verse"

--GUI.New("import_sel_tracks_btn",     "Button",          3, 152+x1, 80+y1, 135, 24, "Import Selected Tracks", import_sel_tracks_btn_click)
--GUI.elms.import_sel_tracks_btn.col_txt = "yellow"
--GUI.elms.import_sel_tracks_btn.col_fill = "gray"

--GUI.New("my_mnu4",   "Menubox",     3, 286, 36, 104, 20, "Time Signature:", "4/4,3/4")
GUI.New("my_mnu2",   "Menubox",     6, 86, 240, 104, 20, "File Type:", ".wma,.wav,.aiff,.flac,.mp3,.wv,.ogg")

GUI.New("lbl_file", "Label", 6, 210, 240, "RealTracks/Drums File Type",true , 2 ,"chorus_fill", "wnd_bg" )

GUI.New("my_mnu3",   "Menubox",     6, 86, 270, 104, 20, "Drive Letter:", "C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z")

GUI.New("lbl_drive", "Label", 6, 210, 270, "Biab Application Drive",true , 2 ,"chorus_fill", "wnd_bg" )

GUI.New("rt_list_btn",   "Button",     6, 20, 108, 96, 20, "Create RT List", rt_list_btn_click)



GUI.New("rd_list_btn",   "Button",     6, 20, 138, 96, 20, "Create RD List", rd_list_btn_click)

--GUI.New("batch_btn",   "Button",     6, 20, 140, 150, 20, "Batch Convert wma Files", batch_btn_click)

GUI.New("reapeaks_folder_btn",   "Button",     6, 20, 28, 170, 20, "Browse Folder for ReaPeaks ", reapeaks_folder_btn_click)

GUI.New("lbl_rt_list", "Label", 6, 130, 108, "Create Text File List of RealTracks (Needed)",true , 2 ,"chorus_fill", "wnd_bg" )

GUI.New("lbl_rd_list", "Label", 6, 130, 138, "Create Text File List of RealDrums (Needed)",true , 2 ,"chorus_fill", "wnd_bg" )

--GUI.New("lbl_batch", "Label", 5, 180, 138, "Convert wma Files to Another Format".."\n".."if you don't have .wav files",true , 2 ,"chorus_fill", "wnd_bg" )

  --RTextension = GUI.Val("my_mnu2")
  
  --file_type = {".wma",".wav",".aiff",".flac",".mp3",".wv",".ogg"}
  
  --ext = file_type[tonumber(RTextension)]


inipath = reaper.get_ini_file() 

retval_folder, RTextension = reaper.BR_Win32_GetPrivateProfileString("reaper", "bb_file_type", "", inipath)

if not tonumber(RTextension) then RTextension = 1 end
--Msg("RTextension "..RTextension)
retval_folder, RTdrive = reaper.BR_Win32_GetPrivateProfileString("reaper", "bb_drive", "", inipath)

if not tonumber(RTdrive) then RTdrive = 1 end



GUI.Val("my_mnu2", RTextension) --Set default file extension to use by number

GUI.Val("my_mnu3", RTdrive)
 --Msg("RTextension "..RTextension)
 file_type = {".wma",".wav",".aiff",".flac",".mp3",".wv",".ogg"}
  
 ext = file_type[tonumber(RTextension)]

 --Msg("ext "..ext)

GUI.New("lbl_reapeaks", "Label", 6, 20, 58, "Create Reapeaks for "..ext.." in:",true , 2 ,"chorus_fill", "wnd_bg" )
--GUI.New("my_btn2",  "Button",       3, 256, 256, 64, 20, "Click me!", fade_lbl)
--GUI.New("my_txt",   "Textbox",     3, 96, 224, 96, 20, "Text:", 4)
GUI.New("set_riff_time_sel_btn",     "Button",          3, 230+x1, 95+y1, 200, 24, "Set Riff Range to Time Selection", set_riff_time_sel_btn_click)
GUI.elms.set_riff_time_sel_btn.col_txt = "white"
GUI.elms.set_riff_time_sel_btn.col_fill = "verse"

GUI.New("gen_cur_track_sec_cus_btn",     "Button",          3, 230+x1, 132+y1, 200, 40, "Generate Current Track".."\n".."      Section Custom", get_riff_section_custom_btn_click)
GUI.elms.gen_cur_track_sec_cus_btn.col_txt = "white"
GUI.elms.gen_cur_track_sec_cus_btn.col_fill = "bridge_post_fill"

GUI.New("import_sec_cus_btn",     "Button",          3, 230+x1, 182+y1, 200, 24, "Import Riff to Track Section", import_sec_cus_btn_click)
GUI.elms.import_sec_cus_btn.col_txt = "white"
GUI.elms.import_sec_cus_btn.col_fill = "bridge"

GUI.New("import_sec_cus_new_trk_btn",     "Button",          3, 230+x1, 216+y1, 200, 24, "Import Riff to New Track Section", import_sec_cus_new_trk_btn_click)
GUI.elms.import_sec_cus_new_trk_btn.col_txt = "white"
GUI.elms.import_sec_cus_new_trk_btn.col_fill = "bridge_fill"

--GUI.New("lbl_note", "Label", 3, 10, 430, "Set AHK to Control name not lable name".."\n".."Encode & Reapeak Holds",true , 4)

GUI.New("import_cur_riff_mid_sec_btn",     "Button",          3, 230+x1, 245+y1, 200, 24, "Import Riff MIDI Section", import_cur_riff_mid_sec_btn_click)
GUI.elms.import_cur_riff_mid_sec_btn.col_txt = "white"
GUI.elms.import_cur_riff_mid_sec_btn.col_fill = "intro_post_fill"

GUI.New("import_cur_riff_mid_sec_new_btn",     "Button",          3, 230+x1, 275+y1, 200, 24, "Import Riff MIDI New Track Section", import_cur_riff_mid_sec_new_btn_click)
GUI.elms.import_cur_riff_mid_sec_new_btn.col_txt = "white"
GUI.elms.import_cur_riff_mid_sec_new_btn.col_fill = "intro"

GUI.New("gen_cur_track_sec_btn",     "Button",          3, 230+x1, 317+y1, 200, 34, "Generate Current Track Section", gen_cur_track_sec_btn_click)
GUI.elms.gen_cur_track_sec_btn.col_txt = "white"
GUI.elms.gen_cur_track_sec_btn.col_fill = "chorus_post_fill"

GUI.New("import_sel_trk_btn",     "Button",          3, 230+x1, 360+y1, 200, 24, "Import Selected Mixer Track", import_sel_trk_btn_click)
GUI.elms.import_sel_trk_btn.col_txt = "white"
GUI.elms.import_sel_trk_btn.col_fill = "chorus"

GUI.New("import_sel_mid_trk_btn",     "Button",          3, 230+x1, 390+y1, 200, 24, "Import Selected Mixer MIDI Track", import_sel_mid_trk_btn_click)
GUI.elms.import_sel_mid_trk_btn.col_txt = "white"
GUI.elms.import_sel_mid_trk_btn.col_fill = "intro_post_fill"


GUI.New("rt_to_di_btn",     "Button",          3, 22+x1, 240+y1, 165, 24, "Change Track to Direct Input", rt_to_di_btn_click)
GUI.elms.rt_to_di_btn.col_txt = "yellow"
GUI.elms.rt_to_di_btn.col_fill = "gray"

GUI.New("rt_to_fx_btn",     "Button",          3, 22+x1, 270+y1, 165, 24, "Change Track to FX", rt_to_fx_btn_click)
GUI.elms.rt_to_fx_btn.col_txt = "yellow"
GUI.elms.rt_to_fx_btn.col_fill = "gray"

GUI.New("stereo_drums_to_stems_btn",     "Button",          3, 22+x1, 300+y1, 165, 40, "Selected Stereo Drums".."\n".."       Track to Stems", stereo_drums_to_stems_btn_click)
GUI.elms.stereo_drums_to_stems_btn.col_txt = "white"
GUI.elms.stereo_drums_to_stems_btn.col_fill = "drum_riff"

GUI.New("unfold_btn",     "Button",          3, 22+x1, 345+y1, 165, 20, "Unfold Biab Chord Sheet", unfold_btn_click)
GUI.elms.unfold_btn.col_txt = "black"
GUI.elms.unfold_btn.col_fill = "hold"

--GUI.New("lbl_rt", "Label", 3, 20, 400, "",true , 4,"chorus_fill", "wnd_bg" )
--GUI.elms.lbl_rt.font = {"Arial", 40, "i"}

GUI.New("btn_save_project",     "Button",          3, 22+x1, 370+y1, 165, 20, "Save Reaper Project", btn_save_project)
GUI.elms.btn_save_project.col_txt = "white"
GUI.elms.btn_save_project.col_fill = "play_anywhere"

GUI.New("lbl_no_move", "Label", 3, 22+x1, 395+y1, "(Copy But Don't Move Source Files)",true , 4,"white", "wnd_bg")

GUI.New("lbl_sel_item", "Label", 3, 20, 380, "Selected Item Instrument",true , 4,"white", "wnd_bg")

GUI.New("btn_set_item_name",     "Button",          3, 5+x1, 435+y1, 20, 20, "Set", btn_set_item_name)
GUI.elms.btn_set_item_name.col_txt = "green"
GUI.elms.btn_set_item_name.col_fill = "hold"

GUI.New("btn_del_item_name",     "Button",          3, 495+x1, 435+y1, 20, 20, "Del", btn_del_item_name)
GUI.elms.btn_del_item_name.col_txt = "green"
GUI.elms.btn_del_item_name.col_fill = "hold"




GUI.New("import_sgu_btn",     "Button",          3, 22+x1, 500+y1, 135, 24, "Import SGU Chords", import_sgu_btn_click)
GUI.elms.import_sgu_btn.col_txt = "yellow"
GUI.elms.import_sgu_btn.col_fill = "gray"

GUI.New("my_mnu5",   "Menubox",     3, 226+x1, 470+y1, 104, 20, "Key:", "C,C#,D,D#,E,F,F#,G,G#,A,A#,B,Cm,C#m,Dm,D#m,Em,Fm,F#m,Gm,G#m,Am,A#m,Bm")

GUI.New("send_chords_biab_btn",     "Button",          3, 182+x1, 500+y1, 205, 24, "Send Chords to Biab (Set Key above)", send_chords_biab_btn_click)
GUI.elms.send_chords_biab_btn.col_txt = "yellow"
GUI.elms.send_chords_biab_btn.col_fill = "gray"

GUI.New("verse_post_fill_btn",      "Button",           3, 22+x1, 530+y1, 95, 20, "Set to A", btn_click_verse_post_fill)
GUI.elms.verse_post_fill_btn.col_txt = "btn_txt1"
GUI.elms.verse_post_fill_btn.col_fill = "verse_post_fill"

GUI.New("chorus_post_fill_btn",      "Button",           3, 122+x1, 530+y1, 95, 20, "Set to B", btn_click_chorus_post_fill)
GUI.elms.chorus_post_fill_btn.col_txt = "btn_txt1"
GUI.elms.chorus_post_fill_btn.col_fill = "chorus_post_fill"

GUI.New("btn_click_normal_region",      "Button",           3, 222+x1, 530+y1, 95, 20, "Set to Normal", btn_click_normal_region)
GUI.elms.btn_click_normal_region.col_txt = "black"
GUI.elms.btn_click_normal_region.col_fill = "light_gray"

GUI.New("btn_click_edit_chord",      "Button",           3, 322+x1, 530+y1, 95, 20, "Edit Chord", btn_click_edit_chord)
GUI.elms.btn_click_edit_chord.col_txt = "red"
GUI.elms.btn_click_edit_chord.col_fill = "light_gray"

GUI.New("btn_insert_region",     "Button",          3, 22+x1, 558+y1, 95, 20, "Insert Region", btn_insert_region)
GUI.elms.btn_insert_region.col_txt = "black"
GUI.elms.btn_insert_region.col_fill = "chorus"

GUI.New("btn_split_region",     "Button",          3, 122+x1, 558+y1, 95, 20, "Split Region", btn_split_region)
GUI.elms.btn_split_region.col_txt = "green"
GUI.elms.btn_split_region.col_fill = "light_gray"

GUI.New("btn_chords_mid_item",     "Button",          3, 222+x1, 558+y1, 125, 20, "Chords from Midi", btn_chords_mid_item)
GUI.elms.btn_chords_mid_item.col_txt = "green"
GUI.elms.btn_chords_mid_item.col_fill = "light_gray"

GUI.New("chord_pre_btn",      "Button",           3, 80+x1, 590+y1, 115, 20, "< Previous Region", btn_click_chord_pre)
GUI.elms.chord_pre_btn.col_txt = "yellow"
GUI.elms.chord_pre_btn.col_fill = "shot"

GUI.New("chord_next_btn",      "Button",           3, 200+x1, 590+y1, 95, 20, "Next Region >", btn_click_chord_next)
GUI.elms.chord_next_btn.col_txt = "yellow"
GUI.elms.chord_next_btn.col_fill = "shot"

GUI.New("bar_pre_btn",      "Button",           3, 60+x1, 615+y1, 50, 20, "< Bar", btn_click_bar_pre)
GUI.elms.bar_pre_btn.col_txt = "yellow"
GUI.elms.bar_pre_btn.col_fill = "shot"

GUI.New("bar_next_btn",      "Button",          3, 260+x1, 615+y1, 50, 20, "Bar >", btn_click_bar_next)
GUI.elms.bar_next_btn.col_txt = "yellow"
GUI.elms.bar_next_btn.col_fill = "shot"

GUI.New("beat_pre_btn",      "Button",           3, 130+x1, 615+y1, 45, 20, "< Beat", btn_click_beat_pre)
GUI.elms.beat_pre_btn.col_txt = "yellow"
GUI.elms.beat_pre_btn.col_fill = "shot"

GUI.New("beat_next_btn",      "Button",           3, 195+x1, 615+y1, 45, 20, "Beat >", btn_click_beat_next)
GUI.elms.beat_next_btn.col_txt = "yellow"
GUI.elms.beat_next_btn.col_fill = "shot"

--GUI.New("riff_frame",     "Frame",          2, 20, 460, 100, 15, false, false, "white", 1)

x3=0
y3=30


x2=0
y2= -70

sec_drums = 0

track1_mute_state = 0
track2_mute_state = 0
track3_mute_state = 0
track4_mute_state = 0
track5_mute_state = 0
track6_mute_state = 0
track7_mute_state = 0
util01_mute_state = 0
util02_mute_state = 0
util03_mute_state = 0
util04_mute_state = 0

track1_solo_state = 0
track2_solo_state = 0
track3_solo_state = 0
track4_solo_state = 0
track5_solo_state = 0
track6_solo_state = 0
track7_solo_state = 0
util01_solo_state = 0
util02_solo_state = 0
util03_solo_state = 0
util04_solo_state = 0

track1_freeze_state = 0
track2_freeze_state = 0
track3_freeze_state = 0
track4_freeze_state = 0
track5_freeze_state = 0
track6_freeze_state = 0
track7_freeze_state = 0
util01_freeze_state = 0
util02_freeze_state = 0
util03_freeze_state = 0
util04_freeze_state = 0

all_instruments = {"none","Sel Drums in drop down >>",
"Acoustic Piano (1)",
"Electric Piano (5)",
"Draw Bar Organ (17)",
"Jazz Organ (18)",
"Rock Organ (19)",
"Church Organ (20)",
"Accordion (22)","",
"Acoustic Guitar (26)",
"Nylon String Guitar (25)",
"Jazz Electric Guitar (27)",
"Clean Electric Guit (28)",
"Muted Electric Guit (29)",
"Overdrive Guitar (30)",
"Distorted Rock Guit (31)","",
"Acoustic String Bass (33)",
"Finger Electric Bass (34)",
"Picked Electric Bass (35)",
"Fretless Elec. Bass (36)",
"Syn Bass 1 (39)","",
"Soprano Sax (65)",
"Alto Sax (66)",
"Tenor Sax (67)",
"Baritone Sax (68)","",
"Clarinet (72)",
"Flute (74)",
"Shakuhachi (78)","",
"Trombone (58)",
"Trumpet (57)",
"Tuba (59)",
"Muted Trumpet (60)",
"Brass Section (62)","",
"Banjo (106)",
"Fiddle",
"Harmonica (23)",
"Mandolin",
"Pedal Steel","",
"Voice Oohs (54)","",
"Clav     (8)",
"Vibes (12)",
"Pad-New Age (89)",
"Pad-Poly Synth (91)",
"Pad-Warm (Slow) (90)",
"Calliope Lead (83)",
"Saw Wave Lead (82)",
"Square Wave Lead (81)",
"Strings (49)",
"Synth Strings 1 (51)","",
"Violin (41)",
"Viola (42)",
"Cello (43)",
"Contra Bass (44)","",
"Koto (108)",
"Kalimba (109)"}

guitar_instruments = {"none","Nylon String Guitar (25)","Acoustic Guitar (26)","Jazz Electric Guitar (27)","Clean Electric Guit (28)","Muted Electric Guit (29)","Overdrive Guitar (30)","Distorted Rock Guit (31)"}

bass_instruments = {"none","Acoustic String Bass (33)","Finger Electric Bass (34)","Picked Electric Bass (35)","Fretless Elec. Bass (36)","Syn Bass 1 (39)"}
  
piano_instruments = {"none","Acoustic Piano (1)","Electric Piano (5)","Draw Bar Organ (17)","Jazz Organ (18)","Rock Organ (19)","Church Organ (20)"}  
 
country_instruments = {"none","Banjo (106)","Mandolin","Pedal Steel","Fiddle","Harmonica (23)"}  
  
solo_instruments = {"none",
"Acoustic Piano (1)",
"Electric Piano (5)",
"Jazz Organ (18)","",
"Nylon String Guitar (25)",
"Acoustic Guitar (26)",
"Jazz Electric Guitar (27)",
"Clean Electric Guit (28)",
"Overdrive Guitar (30)",
"Distorted Rock Guit (31)","",
"Harmonica (23)",
"Fiddle,Mandolin",
"Banjo (106)",
"Pedal Steel","",
"Trumpet (57)",
"Trombone (58)",
"Alto Sax (66)",
"Soprano Sax (65)",
"Tenor Sax (67)",
"Baritone Sax (68)",
"Clarinet (72)",
"Flute (74)",
"Vibes (12)"}


GUI.New("lbl_instr_match", "Label", 5, 190, 58, "",true , 2 ,"chorus_fill", "wnd_bg" )

  
  

GUI.New("my_mnu6",   "Menubox",   5, 40+x3, 0+y3, 70, 20, "Feel:", "Ev8,Ev16,Sw8,Sw16")

GUI.New("my_mnu7",   "Menubox",   5, 170+x3, 0+y3, 70, 20, "Time Sig:", "4-4,3-4")

GUI.New("my_mnu75",   "Menubox",   5, 290+x3, 0+y3, 70, 20, "Tempo:", "120,40,50,55,60,65,70,75,80,85,90,95,100,110,120,130,140,150,165,170,180,190,200,220,260")
GUI.New("my_mnu75b",   "Menubox",   5, 370+x3, 0+y3, 70, 20, ">", "+-15,+-20,+-25,+-30,+-35,+-40")

GUI.New("unmute_all_btn",      "Button",           5, 5+x3, 60+y3, 70, 20, "Un-Mute All", btn_unmute_all)
GUI.elms.unmute_all_btn.col_txt = "black"
GUI.elms.unmute_all_btn.col_fill = "silver"

GUI.New("blank_style_btn",      "Button",           5, 5+x3, 30+y3, 120, 20, "Set BB to Blank Style", btn_click_blank_style)
GUI.elms.blank_style_btn.col_txt = "btn_txt1"
GUI.elms.blank_style_btn.col_fill = "chorus_post_fill"

GUI.New("bb_min_max_btn",      "Button",           5, 130+x3, 30+y3, 50, 20, "BB - □", btn_click_bb_min_max)
GUI.elms.bb_min_max_btn.col_txt = "btn_txt1"
GUI.elms.bb_min_max_btn.col_fill = "bridge_post_fill"

GUI.New("bbmix_min_btn",      "Button",           5, 185+x3, 30+y3, 50, 20, "BBmix -", btn_click_bbmix_min)
GUI.elms.bbmix_min_btn.col_txt = "btn_txt1"
GUI.elms.bbmix_min_btn.col_fill = "bridge_post_fill"

GUI.New("bbmix_max_btn",      "Button",           5, 235+x3, 30+y3, 55, 20, "BBmix □", btn_click_bbmix_max)
GUI.elms.bbmix_max_btn.col_txt = "btn_txt1"
GUI.elms.bbmix_max_btn.col_fill = "bridge_post_fill"

GUI.New("bb_play_start_btn",      "Button",           5, 285+x3, 60+y3, 25, 20, "<<", btn_click_bb_play_start)
GUI.elms.bb_play_start_btn.col_txt = "black"
GUI.elms.bb_play_start_btn.col_fill = "silver"

GUI.New("bb_play_btn",      "Button",           5, 320+x3, 60+y3, 60, 20, "Play/Stop", btn_click_bb_play)
GUI.elms.bb_play_btn.col_txt = "black"
GUI.elms.bb_play_btn.col_fill = "silver"

GUI.New("bb_gen_btn",      "Button",           5, 390+x3, 60+y3, 50, 20, "Re-Gen", btn_click_gen)
GUI.elms.bb_gen_btn.col_txt = "black"
GUI.elms.bb_gen_btn.col_fill = "silver"

GUI.New("lbl_inject", "Label", 5, 470+x3, 55+y3, "Inject",true , 4 ,"pre_chorus", "wnd_bg" )
GUI.New("lbl_inject_aud_mid", "Label", 5, 450+x3, 70+y3, "Audio|Midi",true , 4 ,"pre_chorus", "wnd_bg" )


--GUI.New("lbl_blank_style", "Label", 5, 20, 60, " ",true , 1 ,"play_anywhere", "wnd_bg" )
GUI.New("my_mnu10",   "Menubox",     5, 110+x2, 190+y2, 180, 20, "Bass:", bass_instruments) --"none,Acoustic String Bass (33),Finger Electric Bass (34),Picked Electric Bass (35),Fretless Elec. Bass (36),Syn Bass 1 (39)")
GUI.New("my_mnu10b",   "Menubox",     5, 300+x2, 190+y2, 70, 20, "", "Rhythm,Solo")

GUI.New("track1_pick_btn",      "Button",           5, 375+x2, 190+y2, 35, 20, "Pick", btn_click_track1_pick)
GUI.elms.track1_pick_btn.col_txt = "btn_txt1"
GUI.elms.track1_pick_btn.col_fill = "verse_post_fill"

GUI.New("track1_btn",      "Button",           5, 417+x2, 190+y2, 50, 20, "Random", btn_click_track1_random)
GUI.elms.track1_btn.col_txt = "btn_txt1"
GUI.elms.track1_btn.col_fill = "chorus_post_fill"

GUI.New("track1_clear_btn",      "Button",           5, 475+x2, 190+y2, 40, 20, "*Clear", btn_click_track1_clear)
GUI.elms.track1_clear_btn.col_txt = "white"
GUI.elms.track1_clear_btn.col_fill = "dark_red"

GUI.New("track1_mute_btn",      "Button",           5, 5+x2, 215+y2, 15, 20, "M", btn_click_track1_mute)
GUI.elms.track1_mute_btn.col_txt = "black"
GUI.elms.track1_mute_btn.col_fill = "silver"

GUI.New("track1_solo_btn",      "Button",           5, 20+x2, 215+y2, 15, 20, "S", btn_click_track1_solo)
GUI.elms.track1_solo_btn.col_txt = "black"
GUI.elms.track1_solo_btn.col_fill = "silver"

GUI.New("track1_freeze_btn",      "Button",           5, 35+x2, 215+y2, 15, 20, "✴", btn_click_track1_freeze)
GUI.elms.track1_freeze_btn.col_txt = "black"
GUI.elms.track1_freeze_btn.col_fill = "silver"
GUI.elms.track1_freeze_btn.font = {"Impact",18,b}

GUI.New("track1_name_btn",      "Button",           5, 50+x2, 215+y2, 10, 20, "n", btn_click_track1_name)
GUI.elms.track1_name_btn.col_txt = "green"
GUI.elms.track1_name_btn.col_fill = "silver"

GUI.New("track1_audio_insert_btn",      "Button",           5, 485+x2, 215+y2, 15, 20, "A", btn_click_track1_audio_inject)
GUI.elms.track1_audio_insert_btn.col_txt = "white"
GUI.elms.track1_audio_insert_btn.col_fill = "chorus"

GUI.New("track1_midi_insert_btn",      "Button",           5, 500+x2, 215+y2, 15, 20, "M", btn_click_track1_midi_inject)
GUI.elms.track1_midi_insert_btn.col_txt = "white"
GUI.elms.track1_midi_insert_btn.col_fill = "intro_post_fill"

GUI.New("lbl_instr_match_1", "Label", 5, 210+x3, 60+y3, "",true , 4 ,"chorus_fill", "wnd_bg" )
--GUI.elms.lbl_instr_match_1.font = {"Impact",18,b}


GUI.New("my_mnu11",   "Menubox",     5, 110+x2, 245+y2, 180, 20, "Guitar 1:", guitar_instruments) --"none,Nylon String Guitar (25),Acoustic Guitar (26),Jazz Electric Guitar (27),Clean Electric Guit (28),Muted Electric Guit (29),Overdrive Guitar (30),Distorted Rock Guit (31)")
GUI.New("my_mnu11b",   "Menubox",     5, 300+x2, 245+y2, 70, 20, "", "Rhythm,Solo")

GUI.New("track2_pick_btn",      "Button",           5, 375+x2, 245+y2, 35, 20, "Pick", btn_click_track2_pick)
GUI.elms.track2_pick_btn.col_txt = "btn_txt1"
GUI.elms.track2_pick_btn.col_fill = "verse_post_fill"

GUI.New("track2_btn",      "Button",           5, 417+x2, 245+y2, 50, 20, "Random", btn_click_track2_random)
GUI.elms.track2_btn.col_txt = "btn_txt1"
GUI.elms.track2_btn.col_fill = "chorus_post_fill"

GUI.New("track2_clear_btn",      "Button",           5, 475+x2, 245+y2, 40, 20, "*Clear", btn_click_track2_clear)
GUI.elms.track2_clear_btn.col_txt = "white"
GUI.elms.track2_clear_btn.col_fill = "dark_red"

GUI.New("track2_mute_btn",      "Button",           5, 5+x2, 270+y2, 15, 20, "M", btn_click_track2_mute)
GUI.elms.track2_mute_btn.col_txt = "black"
GUI.elms.track2_mute_btn.col_fill = "silver"

GUI.New("track2_solo_btn",      "Button",           5, 20+x2, 270+y2, 15, 20, "S", btn_click_track2_solo)
GUI.elms.track2_solo_btn.col_txt = "black"
GUI.elms.track2_solo_btn.col_fill = "silver"

GUI.New("track2_freeze_btn",      "Button",           5, 35+x2, 270+y2, 15, 20, "✴", btn_click_track2_freeze)
GUI.elms.track2_freeze_btn.col_txt = "black"
GUI.elms.track2_freeze_btn.col_fill = "silver"
GUI.elms.track2_freeze_btn.font = {"Impact",18,b}

GUI.New("track2_name_btn",      "Button",           5, 50+x2, 270+y2, 10, 20, "n", btn_click_track2_name)
GUI.elms.track2_name_btn.col_txt = "green"
GUI.elms.track2_name_btn.col_fill = "silver"

GUI.New("track2_audio_insert_btn",      "Button",           5, 485+x2, 270+y2, 15, 20, "A", btn_click_track2_audio_inject)
GUI.elms.track2_audio_insert_btn.col_txt = "white"
GUI.elms.track2_audio_insert_btn.col_fill = "chorus"

GUI.New("track2_midi_insert_btn",      "Button",           5, 500+x2, 270+y2, 15, 20, "M", btn_click_track2_midi_inject)
GUI.elms.track2_midi_insert_btn.col_txt = "white"
GUI.elms.track2_midi_insert_btn.col_fill = "intro_post_fill"

GUI.New("lbl_instr_match_2", "Label", 5, 50+x2, 270+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )


GUI.New("my_mnu12",   "Menubox",   5, 110+x2, 300+y2, 180, 20, "Drum:", "none,Drums-Percussion")

GUI.New("track3_pick_btn",      "Button",           5, 375+x2, 300+y2, 35, 20, "Pick", btn_click_track3_pick)
GUI.elms.track3_pick_btn.col_txt = "btn_txt1"
GUI.elms.track3_pick_btn.col_fill = "verse_post_fill"

GUI.New("track3_btn",      "Button",           5, 417+x2, 300+y2, 50, 20, "Random", btn_click_track3_random)
GUI.elms.track3_btn.col_txt = "btn_txt1"
GUI.elms.track3_btn.col_fill = "chorus_post_fill"

GUI.New("track3_clear_btn",      "Button",           5, 475+x2, 300+y2, 40, 20, "*Clear", btn_click_track3_clear)
GUI.elms.track3_clear_btn.col_txt = "white"
GUI.elms.track3_clear_btn.col_fill = "dark_red"

GUI.New("track3_mute_btn",      "Button",           5, 5+x2, 325+y2, 15, 20, "M", btn_click_track3_mute)
GUI.elms.track3_mute_btn.col_txt = "black"
GUI.elms.track3_mute_btn.col_fill = "silver"

GUI.New("track3_solo_btn",      "Button",           5, 20+x2, 325+y2, 15, 20, "S", btn_click_track3_solo)
GUI.elms.track3_solo_btn.col_txt = "black"
GUI.elms.track3_solo_btn.col_fill = "silver"

GUI.New("track3_freeze_btn",      "Button",           5, 35+x2, 325+y2, 15, 20, "✴", btn_click_track3_freeze)
GUI.elms.track3_freeze_btn.col_txt = "black"
GUI.elms.track3_freeze_btn.col_fill = "silver"
GUI.elms.track3_freeze_btn.font = {"Impact",18,b}

GUI.New("track3_name_btn",      "Button",           5, 50+x2, 325+y2, 10, 20, "n", btn_click_track3_name)
GUI.elms.track3_name_btn.col_txt = "green"
GUI.elms.track3_name_btn.col_fill = "silver"

GUI.New("track3_audio_insert_btn",      "Button",           5, 485+x2, 325+y2, 15, 20, "A", btn_click_track3_audio_inject)
GUI.elms.track3_audio_insert_btn.col_txt = "white"
GUI.elms.track3_audio_insert_btn.col_fill = "chorus"

GUI.New("track3_midi_insert_btn",      "Button",           5, 500+x2, 325+y2, 15, 20, "M", btn_click_track3_midi_inject)
GUI.elms.track3_midi_insert_btn.col_txt = "white"
GUI.elms.track3_midi_insert_btn.col_fill = "intro_post_fill"

GUI.New("lbl_instr_match_3", "Label", 5, 50+x2, 325+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )


GUI.New("my_mnu13",   "Menubox",   5, 110+x2, 355+y2, 180, 20, "Guitar 2:", guitar_instruments) --"none,Nylon String Guitar (25),Acoustic Guitar (26),Jazz Electric Guitar (27),Clean Electric Guit (28),Muted Electric Guit (29),Overdrive Guitar (30),Distorted Rock Guit (31)")
GUI.New("my_mnu13b",   "Menubox",     5, 300+x2, 355+y2, 70, 20, "", "Rhythm,Solo")

GUI.New("track4_pick_btn",      "Button",           5, 375+x2, 355+y2, 35, 20, "Pick", btn_click_track4_pick)
GUI.elms.track4_pick_btn.col_txt = "btn_txt1"
GUI.elms.track4_pick_btn.col_fill = "verse_post_fill"

GUI.New("track4_btn",      "Button",           5, 417+x2, 355+y2, 50, 20, "Random", btn_click_track4_random)
GUI.elms.track4_btn.col_txt = "btn_txt1"
GUI.elms.track4_btn.col_fill = "chorus_post_fill"

GUI.New("track4_clear_btn",      "Button",           5, 475+x2, 355+y2, 40, 20, "*Clear", btn_click_track4_clear)
GUI.elms.track4_clear_btn.col_txt = "white"
GUI.elms.track4_clear_btn.col_fill = "dark_red"

GUI.New("track4_mute_btn",      "Button",           5, 5+x2, 380+y2, 15, 20, "M", btn_click_track4_mute)
GUI.elms.track4_mute_btn.col_txt = "black"
GUI.elms.track4_mute_btn.col_fill = "silver"

GUI.New("track4_solo_btn",      "Button",           5, 20+x2, 380+y2, 15, 20, "S", btn_click_track4_solo)
GUI.elms.track4_solo_btn.col_txt = "black"
GUI.elms.track4_solo_btn.col_fill = "silver"

GUI.New("track4_freeze_btn",      "Button",           5, 35+x2, 380+y2, 15, 20, "✴", btn_click_track4_freeze)
GUI.elms.track4_freeze_btn.col_txt = "black"
GUI.elms.track4_freeze_btn.col_fill = "silver"
GUI.elms.track4_freeze_btn.font = {"Impact",18,b}

GUI.New("track4_name_btn",      "Button",           5, 50+x2, 380+y2, 10, 20, "n", btn_click_track4_name)
GUI.elms.track4_name_btn.col_txt = "green"
GUI.elms.track4_name_btn.col_fill = "silver"

GUI.New("track4_audio_insert_btn",      "Button",           5, 485+x2, 380+y2, 15, 20, "A", btn_click_track4_audio_inject)
GUI.elms.track4_audio_insert_btn.col_txt = "white"
GUI.elms.track4_audio_insert_btn.col_fill = "chorus"

GUI.New("track4_midi_insert_btn",      "Button",           5, 500+x2, 380+y2, 15, 20, "M", btn_click_track4_midi_inject)
GUI.elms.track4_midi_insert_btn.col_txt = "white"
GUI.elms.track4_midi_insert_btn.col_fill = "intro_post_fill"

GUI.New("lbl_instr_match_4", "Label", 5, 50+x2, 380+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )


GUI.New("my_mnu14",   "Menubox",   5, 110+x2, 410+y2, 180, 20, "Piano-Keys-Organ:", piano_instruments)
GUI.New("my_mnu14b",   "Menubox",     5, 300+x2, 410+y2, 70, 20, "", "Rhythm,Solo")

GUI.New("track5_pick_btn",      "Button",           5, 375+x2, 410+y2, 35, 20, "Pick", btn_click_track5_pick)
GUI.elms.track5_pick_btn.col_txt = "btn_txt1"
GUI.elms.track5_pick_btn.col_fill = "verse_post_fill"

GUI.New("track5_btn",      "Button",           5, 417+x2, 410+y2, 50, 20, "Random", btn_click_track5_random)
GUI.elms.track5_btn.col_txt = "btn_txt1"
GUI.elms.track5_btn.col_fill = "chorus_post_fill"

GUI.New("track5_clear_btn",      "Button",           5, 475+x2, 410+y2, 40, 20, "*Clear", btn_click_track5_clear)
GUI.elms.track5_clear_btn.col_txt = "white"
GUI.elms.track5_clear_btn.col_fill = "dark_red"

GUI.New("track5_mute_btn",      "Button",           5, 5+x2, 435+y2, 15, 20, "M", btn_click_track5_mute)
GUI.elms.track5_mute_btn.col_txt = "black"
GUI.elms.track5_mute_btn.col_fill = "silver"

GUI.New("track5_solo_btn",      "Button",           5, 20+x2, 435+y2, 15, 20, "S", btn_click_track5_solo)
GUI.elms.track5_solo_btn.col_txt = "black"
GUI.elms.track5_solo_btn.col_fill = "silver"

GUI.New("track5_freeze_btn",      "Button",           5, 35+x2, 435+y2, 15, 20, "✴", btn_click_track5_freeze)
GUI.elms.track5_freeze_btn.col_txt = "black"
GUI.elms.track5_freeze_btn.col_fill = "silver"
GUI.elms.track5_freeze_btn.font = {"Impact",18,b}

GUI.New("track5_name_btn",      "Button",           5, 50+x2, 435+y2, 10, 20, "n", btn_click_track5_name)
GUI.elms.track5_name_btn.col_txt = "green"
GUI.elms.track5_name_btn.col_fill = "silver"

GUI.New("track5_audio_insert_btn",      "Button",           5, 485+x2, 435+y2, 15, 20, "A", btn_click_track5_audio_inject)
GUI.elms.track5_audio_insert_btn.col_txt = "white"
GUI.elms.track5_audio_insert_btn.col_fill = "chorus"

GUI.New("track5_midi_insert_btn",      "Button",           5, 500+x2, 435+y2, 15, 20, "M", btn_click_track5_midi_inject)
GUI.elms.track5_midi_insert_btn.col_txt = "white"
GUI.elms.track5_midi_insert_btn.col_fill = "intro_post_fill"

GUI.New("lbl_instr_match_5", "Label", 5, 50+x2, 435+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )


GUI.New("my_mnu15",   "Menubox",   5, 110+x2, 465+y2, 180, 20, "Banjo, Fiddle etc..:", country_instruments)
GUI.New("my_mnu15b",   "Menubox",     5, 300+x2, 465+y2, 70, 20, "", "Rhythm,Solo")

GUI.New("track6_pick_btn",      "Button",           5, 375+x2, 465+y2, 35, 20, "Pick", btn_click_track6_pick)
GUI.elms.track6_pick_btn.col_txt = "btn_txt1"
GUI.elms.track6_pick_btn.col_fill = "verse_post_fill"

GUI.New("track6_btn",      "Button",           5, 417+x2, 465+y2, 50, 20, "Random", btn_click_track6_random)
GUI.elms.track6_btn.col_txt = "btn_txt1"
GUI.elms.track6_btn.col_fill = "chorus_post_fill"

GUI.New("track6_clear_btn",      "Button",           5, 475+x2, 465+y2, 40, 20, "*Clear", btn_click_track6_clear)
GUI.elms.track6_clear_btn.col_txt = "white"
GUI.elms.track6_clear_btn.col_fill = "dark_red"

GUI.New("track6_mute_btn",      "Button",           5, 5+x2, 490+y2, 15, 20, "M", btn_click_track6_mute)
GUI.elms.track6_mute_btn.col_txt = "black"
GUI.elms.track6_mute_btn.col_fill = "silver"

GUI.New("track6_solo_btn",      "Button",           5, 20+x2, 490+y2, 15, 20, "S", btn_click_track6_solo)
GUI.elms.track6_solo_btn.col_txt = "black"
GUI.elms.track6_solo_btn.col_fill = "silver"

GUI.New("track6_freeze_btn",      "Button",           5, 35+x2, 490+y2, 15, 20, "✴", btn_click_track6_freeze)
GUI.elms.track6_freeze_btn.col_txt = "black"
GUI.elms.track6_freeze_btn.col_fill = "silver"
GUI.elms.track6_freeze_btn.font = {"Impact",18,b}

GUI.New("track6_name_btn",      "Button",           5, 50+x2, 490+y2, 10, 20, "n", btn_click_track6_name)
GUI.elms.track6_name_btn.col_txt = "green"
GUI.elms.track6_name_btn.col_fill = "silver"

GUI.New("track6_audio_insert_btn",      "Button",           5, 485+x2, 490+y2, 15, 20, "A", btn_click_track6_audio_inject)
GUI.elms.track6_audio_insert_btn.col_txt = "white"
GUI.elms.track6_audio_insert_btn.col_fill = "chorus"

GUI.New("track6_midi_insert_btn",      "Button",           5, 500+x2, 490+y2, 15, 20, "M", btn_click_track6_midi_inject)
GUI.elms.track6_midi_insert_btn.col_txt = "white"
GUI.elms.track6_midi_insert_btn.col_fill = "intro_post_fill"

GUI.New("lbl_instr_match_6", "Label", 5, 50+x2, 490+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )


GUI.New("my_mnu16",   "Menubox",   5, 110+x2, 520+y2, 180, 20, "Soloist:", solo_instruments)
GUI.New("my_mnu16b",   "Menubox",     5, 300+x2, 520+y2, 70, 20, "", "Solo,Rhythm")

GUI.New("track7_pick_btn",      "Button",           5, 375+x2, 520+y2, 35, 20, "Pick", btn_click_track7_pick)
GUI.elms.track7_pick_btn.col_txt = "btn_txt1"
GUI.elms.track7_pick_btn.col_fill = "verse_post_fill"

GUI.New("track7_btn",      "Button",           5, 417+x2, 520+y2, 50, 20, "Random", btn_click_track7_random)
GUI.elms.track7_btn.col_txt = "btn_txt1"
GUI.elms.track7_btn.col_fill = "chorus_post_fill"

GUI.New("track7_clear_btn",      "Button",           5, 475+x2, 520+y2, 40, 20, "*Clear", btn_click_track7_clear)
GUI.elms.track7_clear_btn.col_txt = "white"
GUI.elms.track7_clear_btn.col_fill = "dark_red"

GUI.New("track7_mute_btn",      "Button",           5, 5+x2, 545+y2, 15, 20, "M", btn_click_track7_mute)
GUI.elms.track7_mute_btn.col_txt = "black"
GUI.elms.track7_mute_btn.col_fill = "silver"

GUI.New("track7_solo_btn",      "Button",           5, 20+x2, 545+y2, 15, 20, "S", btn_click_track7_solo)
GUI.elms.track7_solo_btn.col_txt = "black"
GUI.elms.track7_solo_btn.col_fill = "silver"

GUI.New("track7_freeze_btn",      "Button",           5, 35+x2, 545+y2, 15, 20, "✴", btn_click_track7_freeze)
GUI.elms.track7_freeze_btn.col_txt = "black"
GUI.elms.track7_freeze_btn.col_fill = "silver"
GUI.elms.track7_freeze_btn.font = {"Impact",18,b}

GUI.New("track7_name_btn",      "Button",           5, 50+x2, 545+y2, 10, 20, "n", btn_click_track7_name)
GUI.elms.track7_name_btn.col_txt = "green"
GUI.elms.track7_name_btn.col_fill = "silver"

GUI.New("track7_audio_insert_btn",      "Button",           5, 485+x2, 545+y2, 15, 20, "A", btn_click_track7_audio_inject)
GUI.elms.track7_audio_insert_btn.col_txt = "white"
GUI.elms.track7_audio_insert_btn.col_fill = "chorus"

GUI.New("track7_midi_insert_btn",      "Button",           5, 500+x2, 545+y2, 15, 20, "M", btn_click_track7_midi_inject)
GUI.elms.track7_midi_insert_btn.col_txt = "white"
GUI.elms.track7_midi_insert_btn.col_fill = "intro_post_fill"

GUI.New("lbl_instr_match_7", "Label", 5, 50+x2, 545+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )


GUI.New("lbl_util_tracks", "Label", 5, 20+x2, 570+y2, "Utility Tracks",true , 2 ,"pre_chorus", "wnd_bg" )
GUI.New("my_mnu17",   "Menubox",   5, 110+x2, 595+y2, 180, 20, "Instrument/Drum:", all_instruments)
GUI.New("my_mnu17b",   "Menubox",     5, 300+x2, 595+y2, 70, 20, "", "Rhythm,Solo,Drums")

GUI.New("util01_pick_btn",      "Button",           5, 375+x2, 595+y2, 35, 20, "Pick", btn_click_util01_pick)
GUI.elms.util01_pick_btn.col_txt = "btn_txt1"
GUI.elms.util01_pick_btn.col_fill = "verse_post_fill"

GUI.New("util01_btn",      "Button",           5, 417+x2, 595+y2, 50, 20, "Random", btn_click_util01_random)
GUI.elms.util01_btn.col_txt = "btn_txt1"
GUI.elms.util01_btn.col_fill = "chorus_post_fill"

GUI.New("util01_clear_btn",      "Button",           5, 475+x2, 595+y2, 40, 20, "*Clear", btn_click_util01_clear)
GUI.elms.util01_clear_btn.col_txt = "white"
GUI.elms.util01_clear_btn.col_fill = "dark_red"

GUI.New("util01_mute_btn",      "Button",           5, 5+x2, 620+y2, 15, 20, "M", btn_click_util01_mute)
GUI.elms.util01_mute_btn.col_txt = "black"
GUI.elms.util01_mute_btn.col_fill = "silver"

GUI.New("util01_solo_btn",      "Button",           5, 20+x2, 620+y2, 15, 20, "S", btn_click_util01_solo)
GUI.elms.util01_solo_btn.col_txt = "black"
GUI.elms.util01_solo_btn.col_fill = "silver"

GUI.New("util01_freeze_btn",      "Button",           5, 35+x2, 620+y2, 15, 20, "✴", btn_click_util01_freeze)
GUI.elms.util01_freeze_btn.col_txt = "black"
GUI.elms.util01_freeze_btn.col_fill = "silver"
GUI.elms.util01_freeze_btn.font = {"Impact",18,b}

GUI.New("util01_name_btn",      "Button",           5, 50+x2, 620+y2, 10, 20, "n", btn_click_util01_name)
GUI.elms.util01_name_btn.col_txt = "green"
GUI.elms.util01_name_btn.col_fill = "silver"

GUI.New("util01_audio_insert_btn",      "Button",           5, 485+x2, 620+y2, 15, 20, "A", btn_click_util01_audio_inject)
GUI.elms.util01_audio_insert_btn.col_txt = "white"
GUI.elms.util01_audio_insert_btn.col_fill = "chorus"

GUI.New("util01_midi_insert_btn",      "Button",           5, 500+x2, 620+y2, 15, 20, "M", btn_click_util01_midi_inject)
GUI.elms.util01_midi_insert_btn.col_txt = "white"
GUI.elms.util01_midi_insert_btn.col_fill = "intro_post_fill"

GUI.New("lbl_instr_match_util01", "Label", 5, 50+x2, 620+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )


GUI.New("my_mnu18",   "Menubox",   5, 110+x2, 650+y2, 180, 20, "Instrument/Drum:", all_instruments)
GUI.New("my_mnu18b",   "Menubox",     5, 300+x2, 650+y2, 70, 20, "", "Rhythm,Solo,Drums")

GUI.New("util02_pick_btn",      "Button",           5, 375+x2, 650+y2, 35, 20, "Pick", btn_click_util02_pick)
GUI.elms.util02_pick_btn.col_txt = "btn_txt1"
GUI.elms.util02_pick_btn.col_fill = "verse_post_fill"

GUI.New("util02_btn",      "Button",           5, 417+x2, 650+y2, 50, 20, "Random", btn_click_util02_random)
GUI.elms.util02_btn.col_txt = "btn_txt1"
GUI.elms.util02_btn.col_fill = "chorus_post_fill"

GUI.New("util02_clear_btn",      "Button",           5, 475+x2, 650+y2, 40, 20, "*Clear", btn_click_util02_clear)
GUI.elms.util02_clear_btn.col_txt = "white"
GUI.elms.util02_clear_btn.col_fill = "dark_red"

GUI.New("util02_mute_btn",      "Button",           5, 5+x2, 675+y2, 15, 20, "M", btn_click_util02_mute)
GUI.elms.util02_mute_btn.col_txt = "black"
GUI.elms.util02_mute_btn.col_fill = "silver"

GUI.New("util02_solo_btn",      "Button",           5, 20+x2, 675+y2, 15, 20, "S", btn_click_util02_solo)
GUI.elms.util02_solo_btn.col_txt = "black"
GUI.elms.util02_solo_btn.col_fill = "silver"

GUI.New("util02_freeze_btn",      "Button",           5, 35+x2, 675+y2, 15, 20, "✴", btn_click_util02_freeze)
GUI.elms.util02_freeze_btn.col_txt = "black"
GUI.elms.util02_freeze_btn.col_fill = "silver"
GUI.elms.util02_freeze_btn.font = {"Impact",18,b}

GUI.New("util02_name_btn",      "Button",           5, 50+x2, 675+y2, 10, 20, "n", btn_click_util02_name)
GUI.elms.util02_name_btn.col_txt = "green"
GUI.elms.util02_name_btn.col_fill = "silver"

GUI.New("util02_audio_insert_btn",      "Button",           5, 485+x2, 675+y2, 15, 20, "A", btn_click_util02_audio_inject)
GUI.elms.util02_audio_insert_btn.col_txt = "white"
GUI.elms.util02_audio_insert_btn.col_fill = "chorus"

GUI.New("util02_midi_insert_btn",      "Button",           5, 500+x2, 675+y2, 15, 20, "M", btn_click_util02_midi_inject)
GUI.elms.util02_midi_insert_btn.col_txt = "white"
GUI.elms.util02_midi_insert_btn.col_fill = "intro_post_fill"

GUI.New("lbl_instr_match_util02", "Label", 5, 50+x2, 675+y2, "",true , 3 ,"chorus_fill", "wnd_bg" )

--[[
GUI.New("my_mnu19",   "Menubox",   5, 110+x2, 540+y2, 180, 20, "Instrument:", all_instruments) 
GUI.New("my_mnu19b",   "Menubox",     5, 300+x2, 540+y2, 70, 20, "", "Rhythm,Solo")

GUI.New("util03_btn",      "Button",           5, 380+x2, 540+y2, 60, 20, "Random", btn_click_util03)
GUI.elms.util03_btn.col_txt = "btn_txt1"
GUI.elms.util03_btn.col_fill = "chorus_post_fill"

GUI.New("my_mnu20",   "Menubox",   5, 110+x2, 570+y2, 180, 20, "Instrument:", all_instruments) 
GUI.New("my_mnu20b",   "Menubox",     5, 300+x2, 570+y2, 70, 20, "", "Rhythm,Solo")

GUI.New("util04_btn",      "Button",           5, 380+x2, 570+y2, 60, 20, "Random", btn_click_util04)
GUI.elms.util04_btn.col_txt = "btn_txt1"
GUI.elms.util04_btn.col_fill = "chorus_post_fill"
--]]

function GUI.elms.my_mnu:onmouseup()
    -- Run the original method
    GUI.Menubox.onmouseup(self)
    
    -- And then your function
    TB = GUI.Val("my_mnu")
    timebase_on()

end

function GUI.elms.my_mnu2:onmouseup()
    -- Run the original method
    GUI.Menubox.onmouseup(self)
    --Msg("Change file type")
    -- And then your function
    RTextension = GUI.Val("my_mnu2")
    --Msg("Write "..RTextension)
    --inipath = reaper.get_ini_file() 
    
    
    
    file_type = {".wma",".wav",".aiff",".flac",".mp3",".wv",".ogg"}
      
    ext = file_type[tonumber(RTextension)]
    
    reaper.BR_Win32_WritePrivateProfileString( "reaper", "bb_file_type", RTextension, inipath )
    
    GUI.elms.lbl_reapeaks:ondelete()
    GUI.New("lbl_reapeaks", "Label", 6, 20, 58, "Create Reapeaks for "..ext.." in:",true , 2 ,"chorus_fill", "wnd_bg" )
    GUI.elms.lbl_reapeaks:init()
    
end

function GUI.elms.my_mnu3:onmouseup()
    -- Run the original method
    GUI.Menubox.onmouseup(self)
    
    -- And then your function
    RTdrive = GUI.Val("my_mnu3")
    --Msg("Write "..RTdrive)
    inipath = reaper.get_ini_file() 
    
    reaper.BR_Win32_WritePrivateProfileString( "reaper", "bb_drive", RTdrive, inipath )
end


-- We have too many values to be legible if we draw them all; we'll disable them, and
-- have the knob's caption update itself to show the value instead.




------------------------------------
-------- Tab 2 Elements ------------
------------------------------------





------------------------------------
-------- Tab 3 Elements ------------
------------------------------------


--GUI.New("my_chk",   "Checklist",   3, 32, 96, 160, 160, "Checklist:", "Bluesy,Simpler,Diret Input,Held", "v", 4)
--GUI.New("my_opt",   "Radio",     5, 50, 96, 160, 160, "Options:", "Bluesy,Simpler,Diret Input,Held", "v", 4)
--GUI.New("my_chk2",  "Checklist",  5, 32, 280, 384, 64, "Whoa, another Checklist", "A,B,C,_,D,E,F,_,G,H,I", "h", 4)
--GUI.New("my_opt2",  "Radio",    5, 32, 364, 384, 64, "Horizontal options", "A,A#,B,C,C#,D,D#,E,F,F#,G,G#", "h", 4)

--GUI.elms.my_opt.swap = true
--GUI.elms.my_chk2.swap = true




------------------------------------
-------- Subwindow and -------------
-------- its elements  -------------
------------------------------------


GUI.New("wnd_test", "Window", 10, 0, 0, 312, 244, "Dialog Box", {9, 10})
GUI.New("lbl_elms", "Label", 9, 16, 16, "", false, 4)
GUI.New("lbl_vals", "Label", 9, 96, 16, "", false, 4, nil, elm_bg)
GUI.New("btn_close", "Button", 9, 0, 184, 48, 24, "OK", wnd_OK)

-- We want these elements out of the way until the window is opened
GUI.elms_hide[9] = true
GUI.elms_hide[10] = true


-- :onopen is a hook provided by the Window class. This function will be run
-- every time the window opens.
function GUI.elms.wnd_test:onopen()
    
    -- :adjustelm places the element's specified x,y coordinates relative to
    -- the Window. i.e. creating an element at 0,0 and adjusting it will put
    -- the element in the Window's top-left corner.
    self:adjustelm(GUI.elms.btn_close)
    
    -- Buttons look nice when they're centered.
    GUI.elms.btn_close.x, _ = GUI.center(GUI.elms.btn_close, self)    
    
    self:adjustelm(GUI.elms.lbl_elms)
    self:adjustelm(GUI.elms.lbl_vals)
    
    -- Set the Window's title
  local tab_num = GUI.Val("tabs")
    self.caption = "Element values for Tab " .. tab_num
    
    --Msg("Menu "..menu_val)
    
    -- This Window provides a readout of the values for every element
    -- on the current tab.
    local strs_v, strs_val = get_values_for_tab(tab_num)
    
    GUI.Val("lbl_elms", table.concat(strs_v, "\n"))
    GUI.Val("lbl_vals", table.concat(strs_val, "\n"))
    
end




------------------------------------
-------- Main functions ------------
------------------------------------
function show_item_instrument_name()

  sep = "\t"
  sel_item = reaper.GetSelectedMediaItem( 0, 0 )
  if sel_item then  
    take = reaper.GetMediaItemTake( sel_item, 0 )
    source = reaper.GetMediaItemTake_Source( take )
    filenamebuf = reaper.GetMediaSourceFileName( source )
    instrument_name1 = getFolderName2(filenamebuf)
    
    --Msg(instrument_name)
    if instrument_name1 then
      instrument_name = instrument_name1:gsub(" Direct Input", "")
      RT_number = getRTnumber(instrument_name)
      if not RT_number then RT_number = "000" end 
      ---++++-+Msg(instrument_name) 
      GUI.New("lbl_rt", "Label", 3, 30, 400, RT_number..":"..instrument_name,true , 3,"chorus_fill", "wnd_bg" )
      --GUI.elms.lbl_rt.font = {"Arial", 150, "i"}
      sel_item_name = RT_number..":"..instrument_name
    else
      GUI.New("lbl_rt", "Label", 3, 30, 400, "Not Audio Item",true , 3 ,"chorus_fill", "wnd_bg" )
      sel_item_name = ""
    end
  end
  
  --Msg("Mouse "..tostring(GUI.mouse.cap))
 


    if GUI.mouse.cap & 1 == 0 then
      
      --[[
      pos_start, pos_end = reaper.GetSet_LoopTimeRange2( 0, 0, 0, "", "", 0 )
      if pos_start ~= pos_end then
        if pre_pos_start ~= pos_start or pre_pos_end ~= pos_end then
          Msg("Set Time")
          set_riff_time_sel_btn_click()
        end  
      end
      pre_pos_start = pos_start
      
      pre_pos_end = pos_end
      
      --]]
    end
  
end

-- This will be run on every update loop of the GUI script; anything you would put
-- inside a reaper.defer() loop should go here. (The function name doesn't matter)
local function Main()
  
  -- Prevent the user from resizing the window
  if GUI.resized then
    
    -- If the window's size has been changed, reopen it
    -- at the current position with the size we specified
    local __,x,y,w,h = gfx.dock(-1,0,0,0,0)
    gfx.quit()
    gfx.init(GUI.name, GUI.w, GUI.h, 0, x, y)
    GUI.redraw_z[0] = true
  end    
  
end


-- Open the script window and initialize a few things
GUI.Init()

-- Tell the GUI library to run Main on each update loop
-- Individual elements are updated first, then GUI.func is run, then the GUI is redrawn
GUI.func = show_item_instrument_name --Main

-- How often (in seconds) to run GUI.func. 0 = every loop.
GUI.freq = .5


-- Start the main loop
GUI.Main()
